VERSION 5.00
Begin VB.Form serviceActivity 
   Caption         =   "Service Activity"
   ClientHeight    =   7500
   ClientLeft      =   60
   ClientTop       =   375
   ClientWidth     =   6525
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   7500
   ScaleWidth      =   6525
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Screen Buffer Size"
      Height          =   645
      Left            =   4650
      TabIndex        =   5
      Top             =   60
      Width           =   1785
      Begin VB.TextBox scrBufferSizeText 
         Height          =   345
         Left            =   150
         TabIndex        =   6
         Text            =   "100"
         Top             =   240
         Width           =   825
      End
      Begin VB.Label Label1 
         Caption         =   "lines"
         Height          =   255
         Left            =   1080
         TabIndex        =   7
         Top             =   270
         Width           =   525
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Input Command :"
      Height          =   615
      Left            =   60
      TabIndex        =   2
      Top             =   90
      Width           =   4515
      Begin VB.CommandButton sendCmd 
         Caption         =   "send"
         Height          =   345
         Left            =   3750
         TabIndex        =   4
         Top             =   180
         Width           =   675
      End
      Begin VB.TextBox cmdText 
         Height          =   315
         Left            =   90
         TabIndex        =   3
         Text            =   "help"
         Top             =   180
         Width           =   3585
      End
   End
   Begin VB.TextBox outputText 
      Height          =   6375
      Left            =   60
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   720
      Width           =   6375
   End
   Begin VB.Timer responseTimer 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   5790
      Top             =   7110
   End
   Begin VB.Label statusLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   345
      Left            =   60
      TabIndex        =   0
      Top             =   7110
      Width           =   6375
   End
End
Attribute VB_Name = "serviceActivity"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim rwOverlapped As T_OVERLAPPED
Dim rOverlapped As T_OVERLAPPED

Dim pipeHandle As Long
Dim hWriteEvent As Long
Dim hReadEvent As Long

Dim sa As SECURITY_ATTRIBUTES

Private Const PipePath = "\\.\pipe\"
Dim PipeName As String
Private Sub appendOutput(msg As String)
  Dim txtlen As Long
  Dim maxlen As Integer
  
  On Error GoTo appendOutputError
  maxlen = Val(scrBufferSizeText.text)
  If maxlen < 100 Then maxlen = 100
  If maxlen > 800 Then maxlen = 800 ' max text string length !
  maxlen = maxlen * 40 ' average 40 chars per line
  txtlen = Len(outputText.text)
  If txtlen > maxlen + Len(msg) Then
    outputText.text = Right$(outputText.text, txtlen - 2 * Len(msg))
  End If
  'msg = TrimString(msg)
  outputText.text = outputText.text + msg
  outputText.SelStart = 32767
  Exit Sub
appendOutputError:
  maxlen = 100
  Resume Next
End Sub

Sub openServicePipe(fecName As String)
  Dim res As Long
  
  PipeName = PipePath + fecName + ".ipc"
  res = WaitNamedPipe(PipeName, NMPWAIT_USE_DEFAULT_WAIT)
  If res = 0 Then
    statusLabel.Caption = "pipe: " + PipeName + " is not  available"
    Exit Sub
  End If

End Sub

Private Sub cmdText_KeyDown(KeyCode As Integer, Shift As Integer)
If KeyCode = vbKeyReturn Then Call sendCmd_Click

End Sub


Private Sub Form_Load()
  Dim fec As String
  
  fec = Command$
  If Len(fec) = 0 Then
    MsgBox "Usage: AttachFec <fecname>", vbOKOnly, "Input Error"
    End
  End If
  serviceActivity.Caption = fec + " Activity"
  openServicePipe fec
End Sub

Private Sub Form_Unload(Cancel As Integer)
CloseHandle pipeHandle
End Sub


Private Sub responseTimer_Timer()
  Dim res As Long, myStr As String, i As Long, cbRead As Long
  Dim nRead As Long, nWritten As Long, nAvail As Long
  Dim request As Long
  Dim buff(256) As Byte
    
  res = WaitForSingleObject(hReadEvent, 100)
  If res <> 0 Then Exit Sub
  
  res = PeekNamedPipe(pipeHandle, 0, 0, 0, nAvail, 0)
  rOverlapped.hEvent = hReadEvent
  If nAvail > 256 Then nAvail = 256
  res = ReadFile(pipeHandle, pipeReadBuffer(0), nAvail, nRead, rOverlapped)
  If res And nRead > 0 Then appendOutput Left$(BSTR(pipeReadBuffer), nRead)
  pipeHasBeenRead = False
  DoEvents
End Sub

Private Sub sendCmd_Click()
  Dim requestString As String
  Dim nWritten As Long, nRead As Long, nAvail As Long
  Dim res As Long, myStr As String, i As Long, cbRead As Long
  
  If pipeHandle = 0 Then
    sa.bInheritHandle = 0
    sa.lpSecurityDescriptor = 0
    sa.nLength = LenB(sa)
    pipeHandle = CreateFile(PipeName, GENERIC_READ + GENERIC_WRITE, 0, sa, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0)
    If pipeHandle = -1 Then
      statusLabel.Caption = "invalid pipeHandle"
      Exit Sub
    Else
      statusLabel.Caption = "pipeHandle = " + str(pipeHandle)
    End If
    hWriteEvent = CreateEvent(sa, True, False, vbNullString)
    hReadEvent = CreateEvent(sa, True, False, vbNullString)
  End If
  rwOverlapped.hEvent = hWriteEvent
  requestString = cmdText.text
  res = WriteFile(pipeHandle, requestString, Len(requestString), nWritten, rwOverlapped)
  If res <> 0 Then
      statusLabel.Caption = "request = " + requestString + " sent. Length of message = " + str(nWritten)
  Else
      statusLabel.Caption = "error sending request: " + str(GetLastError)
      CloseHandle (pipeHandle)
      Exit Sub
  End If
  appendOutput vbNewLine + ">" + requestString + vbNewLine + ">"
  responseTimer.Enabled = True
  pipeHasBeenRead = True
  rOverlapped.hEvent = hReadEvent
  res = PeekNamedPipe(pipeHandle, 0, 0, 0, nAvail, 0)
  If nAvail > 256 Then nAvail = 256
  res = ReadFile(pipeHandle, pipeReadBuffer(0), nAvail, nRead, rOverlapped)
  If res Then appendOutput Left$(BSTR(pipeReadBuffer), nRead)
  
End Sub

