#include <direct.h>
#include <math.h>
#include "mex.h"
#include <windows.h>

#define	PROPMAX 1024
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#include "tine.h"
#include "tbufsrv.h"

#define mxerr(s) { mxerrStr = s; goto err; }

static int mexCreateWindowDone = FALSE;
static char mexWndName[32];
HANDLE hMexWnd = 0;
#define WM_ML_CALLBACK        (WM_USER+200)
//static mxArray *ID = NULL;
static mxArray *dpParams[2];

#ifndef HWND_MESSAGE
#define HWND_MESSAGE     ((HWND)-3)
#endif

#define MAX_CBHANDLERS 1024
typedef struct PrpHndlrStruct
{
  int id;
  char fcnName[128];
} CbHndlrTbl;
CbHndlrTbl cbHndlrTbl[MAX_CBHANDLERS];
int cbHndlrTblSize = 0;

int getCbHndlrTblEntry(int id)
{
  int i;
  for (i=0; i<cbHndlrTblSize; i++)
  {
    if (cbHndlrTbl[i].id == id) return i; 
  }
  return -1;
}
int addDbHndlrTblEntry(int id,

__declspec(dllexport) LRESULT CALLBACK mexWndProc(HWND hWnd, WORD iMessage, WORD wParam, LONG lParam)
{
  char fn[512], dfcn[128], *fcn=NULL;
  switch (iMessage)
  {
    case WM_ML_CALLBACK:
      //mexCallMATLAB(0,NULL,1, &ID, "disp");
      return (LRESULT)mexCallMATLAB(0,NULL,1,&ID,"tine_callback");
      break;
    default: 
      return DefWindowProc (hWnd, iMessage, wParam, lParam);
  }
  return 0;
}
int CreateMexWindow(void)
{
  static WNDCLASS wndclass;
  int err, pid = GetCurrentProcessId();

  if (mexCreateWindowDone) return 0;
  sprintf(mexWndName,"mxCbWnd-%x",pid);
  mexWndName[32] = 0;

  mexCreateWindowDone = TRUE;
  if (hMexWnd != 0 && FindWindow(mexWndName,mexWndName) != 0) 
  { /* still active */
    return 0; 
  }
  
  wndclass.style         = CS_GLOBALCLASS|CS_SAVEBITS; 
  wndclass.lpfnWndProc   = (WNDPROC) mexWndProc;
  wndclass.cbClsExtra    = 0;
  wndclass.cbWndExtra    = 0;
  wndclass.hInstance     = (HINSTANCE)HWND_MESSAGE;
  wndclass.hIcon         = LoadIcon (0, IDI_APPLICATION);
  wndclass.hCursor       = LoadCursor (0, IDC_ARROW);
  wndclass.hbrBackground = (HBRUSH)COLOR_BACKGROUND; //GetStockObject (WHITE_BRUSH);
  wndclass.lpszMenuName  = 0;
  wndclass.lpszClassName = mexWndName;

  if (!RegisterClass(&wndclass)) 
  {
    if ((err=GetLastError()) != ERROR_CLASS_ALREADY_EXISTS)
    {
      MessageBeep(-1);
      return -1;
    }
  }

  if (!(hMexWnd = CreateWindowEx (
      WS_EX_NOPARENTNOTIFY,
			mexWndName, mexWndName,               
			WS_BORDER|WS_CAPTION,         
			CW_USEDEFAULT, CW_USEDEFAULT, 
			CW_USEDEFAULT, CW_USEDEFAULT, 
			HWND_MESSAGE, 0,                 
			(HINSTANCE)HWND_MESSAGE,               
			(LPSTR)""                     
      ) ) ) 
  {
    err = GetLastError();
    MessageBeep(-1);
    MessageBeep(-1);
    return -1;
  }

  return 0;
}

short ftoi(char *fmt)
{
  char *c,fmtstr[64];
  short ifmt;
  strncpy(fmtstr,fmt,64);
  if ((c=strchr(fmtstr,'.')) != NULL) *c = 0;
  strupr(fmtstr);
  if ((ifmt=getSimpleFormatType(fmtstr)) != CF_NULL) return ifmt;
  return getCompoundFormatType(fmtstr);
}
int mexlog(char *tag,char *text,...)
{
  char str[512];
  FILE *fp = NULL;
  va_list args;
  time_t t = time(NULL);
  static char *fmod = "a+";

  sprintf(str,"%.24s[%s] ",ctime(&t),tag);

  va_start(args,text);
  _vsnprintf(&str[strlen(str)],256,text,args); str[256] = 0;
  va_end(args);

  strcat(str,"\n");
  if ((fp=fopen("l:\\log\\mex.log","a+")) == NULL) return -1;
  fwrite(str,strlen(str),1,fp);

  fclose(fp);
  return 0;
}
int	read_names(const char **name, mxArray **field, char* buf, int op)
{
	PropertyQueryStruct	svrProps[PROPMAX];
	NAME64 svrTags[DEVMAX];
	char bf[80], *tname;
	DTYPE dout;
	int	cc,i,tlen;
	u_short count;

	switch (op)
  {
    case 0:
      dout.dFormat = CF_NAME32; // CF_NAME16;
      dout.dArrayLength = DEVMAX/2;
      dout.data.vptr = svrTags;
      svrTags[0].name[0] = '\0';
      dout.dTag[0] = 0;
      cc = alsnExecLink("ENS","TAGS",&dout,NULL,CA_READ,500);
      count = PROPMAX;
      tlen = 32;
      break;
    case 1:
      i = DEVMAX;
      cc = GetSystemDevices(buf,NULL, svrTags,&i);
      if (cc) break;
      count = (u_short)i;
      tlen = 64;
      /*
      dout.dFormat = CF_SHORT;
      dout.dArrayLength = 1;
      dout.data.usptr = &count;
      cc = alsnExecLink(buf,"NDEVICES",&dout,NULL,CA_READ,500);
      if(cc) break;
      if (count > DEVMAX) count = DEVMAX;
      dout.dFormat = CF_NAME16;
      dout.dArrayLength = count;
      dout.data.vptr = svrTags;
      svrTags[0].name[0] = '\0';
      dout.dTag[0] = 0;
      cc = alsnExecLink(buf,"DEVICES",&dout,NULL,CA_READ,500);
      */
      break;		
    case 2:
      dout.dFormat = CF_SHORT;
      dout.dArrayLength = 1;
      dout.data.usptr = &count;
      cc = alsnExecLink(buf,"NPROPS",&dout,NULL,CA_READ,500);
      if(cc) break;
      if (count > PROPMAX) count = PROPMAX;
      dout.dFormat = CF_STRUCT;
      dout.dArrayLength = count*PROPERTYQUERYSTRUCT_SIZE;
      dout.data.vptr = svrProps;
      svrProps[0].prpName[0] = '\0';
      cc = alsnExecLink(buf,"PROPS",&dout,NULL,CA_READ,500);
      break;
  }
  if(cc) 
  {
    GetLastLinkError(cc,buf);
    return 0;
  }
  switch (op)
  {
		case 0:
		case 1:
			for(i = 0; i < count;i++)
      {
        tname = (char *)svrTags + i*tlen;
        if(strlen(tname) == 0 ) return i;
        //if(strlen((const char *)svrTags[i].name) == 0 ) return i;
        sprintf(bf,"Device_%d",i+1);
        cc = strlen(bf)+1;
        name[i] = (char *)mxCalloc(cc, sizeof(char));
        memset((void *)name[i],0,sizeof(name[i]));
        strcpy((char *)name[i],bf);
        memset((void *)bf,0,sizeof(bf));
        //if(!op)	sprintf(bf,"%s",svrTags[i].name);
        //else	sprintf(bf,"%s/%s",buf,svrTags[i].name);
        if(!op)	sprintf(bf,"%s",tname);
        else	sprintf(bf,"%s/%s",buf,tname);
        field[i] = mxCreateString(bf);
      }
      break;		
    case 2:
      for(i= 0;i < count;i++)
      {
        if(svrProps[i].prpName[0] == 0 ) return i;
        cc = strlen(svrProps[i].prpName)+1;
        name[i] = (char *)mxCalloc(cc, sizeof(char));
        memset((void *)name[i],0,sizeof(name[i]));
        strcpy((char *)name[i],svrProps[i].prpName);
        field[i] = mxCreateString(svrProps[i].prpDescription);
			}
      break;
 	}
  return i;
}
int mexIsStockProperty(char *prop)
{
  if (!stricmp(prop,"DEVICES")) return TRUE;
  if (!stricmp(prop,"NDEVICES")) return TRUE;
  if (!stricmp(prop,"NPROPS")) return TRUE;
  if (!stricmp(prop,"NPROPERTIES")) return TRUE;
  if (!stricmp(prop,"PROPERTIES")) return TRUE;
  return FALSE;
}
int	read_prop(char *dev, char *prop, int *size)
{
  PropertyQueryStruct	svrProp;
	DTYPE dout, din;
	int cc, fmt;
  char *prp = "PROPS";
  if ((cc=getPropertyInfoFromListener(dev,prop,size,&fmt)) == 0)
  {
    return fmt;
  }

  if (mexIsStockProperty(prop)) prp = "STOCKPROPS";

  dout.dFormat = CF_STRUCT;
  dout.dArrayLength = PROPERTYQUERYSTRUCT_SIZE;
  dout.data.vptr = &svrProp;
  dout.dTag[0] = '\0';

  din.dFormat = CF_TEXT;
  din.dArrayLength = strlen(prop);
  din.data.vptr = prop;
  din.dTag[0] = '\0';
  svrProp.prpName[0] = '\0';

  if ((cc=alsnExecLink(dev,prp,&dout,&din,CA_READ,500)) != 0)
  {
    *size = 0;
    return -cc;
 	}
  if (svrProp.prpName[0] == 0) 
  {
    *size = 0;
    return -cc;
 	}
  *size = svrProp.prpSize;
  return LFMT(svrProp.prpFormat);
}
int	read_data_ext(char *dev, char *prop, int type, int size, char *buf,int access_rate,double *pDataTime)
{
	DTYPE dout;
	int cc;

	dout.dFormat = type;
	dout.dArrayLength = size;
	dout.data.vptr = buf;
	dout.dTag[0] = 0;
  if ((cc=alsnExecLinkEx(dev,prop,&dout,NULL,CA_READ,access_rate,pDataTime)) != 0)
  {
    GetLastLinkError(cc,buf);
    if (pDataTime != NULL) *pDataTime = (double)time(NULL);
		return 1;
	}
	return 0;
}
int	read_data(char *dev,char *prop,int type,int size,char *buf)
{
  return read_data_ext(dev,prop,type,size,buf,1000,NULL);
}
void name_corr(char *name)
{
  int	i, len;

  len = strlen(name);
  for (i = 0; i < len; i++) 
  {
    if (name[i] == '.') 
    {
      name[i] = '_';
    } 
    else if (name[i] == '-') 
    {
      name[i] = '_';
    }
	}
}
static char cwd[256] = "";

//__declspec(dllexport) 
extern "C" void _mlCbNf(int id)
{
  int err, rc=0;

  if (ID == NULL)	
  {
    ID = mxCreateDoubleMatrix(1, 1, mxREAL);
    chdir(cwd);
  }
  *((double *)mxGetPr(ID)) = (double)id;
	mexPutVariable("base", "ID", ID);
  err = (int)SendMessageTimeout((HWND)hMexWnd,WM_ML_CALLBACK,id,0,SMTO_NORMAL,100,(LPDWORD)&rc);
  if (rc != 0) dbglog("MatLab callback error %d",rc);
  *((double *)mxGetPr(ID)) = (double)(-1);
}

//char Buffer[MAX_TINE_BUFFER];
char *Buffer = NULL;
int mlBufferSize = MAX_TINE_BUFFER;
char *usageStr = "tine_read usage:\n ret=tine_read('/<context>/<server>/<device>[<property>]'[,'<data_type>',data_size,timer_interval,callback_id])\n;'ret' contains the status/error message,timestamps,and returned values";
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) 
{
	mxArray	*data[PROPMAX];
	const char *field[PROPMAX];
	double *lp, dt = (double)time(NULL);
	int	error[PROPMAX];
	char *name, *typestr, *mxerrStr=NULL;
	char *p;
	char buf[1024];
	char bf1[1024], *c=NULL, *c1=NULL, *c2=NULL, *c3=NULL;
  char dtstr[32];
	char prop[80];
	char dev[80];
	int	len,type,size,fmtsiz,readsize = -1,ln,datatype = -1;
	int	dims[2];
	int	i,j,k,err,count,n,startindex = 3,cbid=-1;
	int	lim,nmb;
  int tmr = 1000;
  int acc = CA_READ;
	mxChar *CharData;
  char tsstr[64];
  char *tmpBuffer;
    
  if (plhs == NULL || prhs == NULL) return;

  /* Check for proper number of arguments. */
  switch (nrhs)
  {
    case 5:
      if (mxIsDouble(prhs[4]))
      {
        cbid = (int)mxGetScalar(prhs[4]);
        if (!mexCreateWindowDone) 
        {
          getcwd(cwd,256);
          CreateMexWindow();
        }
      }
    case 4: // timer interval (int)
      if (!mxIsDouble(prhs[3])) mxerr(usageStr);
      if (mxGetM(prhs[3]) != 1) mxerr(usageStr);
      tmr = (int)mxGetScalar(prhs[3]);
    case 3: // output data size (int)
      if (!mxIsDouble(prhs[2])) mxerr(usageStr);
      if (mxGetM(prhs[2]) != 1) mxerr(usageStr);
      readsize = (int)mxGetScalar(prhs[2]);
    case 2: // input/output data type
      if (!mxIsChar(prhs[1])) mxerr(usageStr);
      if (mxGetM(prhs[1]) != 1) mxerr(usageStr);
      len = mxGetN(prhs[1]) + 1;
      typestr = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[1],typestr,len);
      strncpy(dtstr,typestr,32);
      strupr(dtstr);
      if (dtstr[strlen(dtstr)-1] == 'S') dtstr[strlen(dtstr)-1] = 0; // in case "floats" instead of "float"
      datatype = ftoi(dtstr);
      mxFree(typestr);
    case 1: // target
      if (!mxIsChar(prhs[0])) mxerr(usageStr);
      if (mxGetM(prhs[0]) != 1) mxerr(usageStr);
      // the requested data endpoint ...
      len = mxGetN(prhs[0]) + 1;
      name = (char *)mxCalloc(len, sizeof(char));
      mxGetString(prhs[0],name,len);
      field[0] = (char *)mxCalloc(6, sizeof(char));
      field[1] = (char *)mxCalloc(10, sizeof(char));
      field[2] = (char *)mxCalloc(4, sizeof(char));
      memset((void *)field[0],0,sizeof(field[0]));
      memset((void *)field[1],0,sizeof(field[1]));
      memset((void *)field[2],0,sizeof(field[2]));
      if((p=strchr(name,'?')) != NULL)
      {
        strcpy((char *)field[0],"usage");
        plhs[0] = mxCreateStructMatrix(1,1,1,&field[0]);
        data[0] = mxCreateString("data = tine_read('dev/loc[prop1;prop2;....;propn]<data_size data_type>@interval');\ndev = tine_read('');\nloc = tine_read('dev/*');\nprop = tine_read('dev/loc')\nThe error field contains the number(s) of the wrong read\nprops and the corresponding props contain error message(s)!!!");
        mxSetFieldByNumber(plhs[0],0,0,data[0]);
        mxFree(name);
        return;
 	    }
      strcpy((char *)field[0],"error");
      strcpy((char *)field[1],"timestamp");
      strcpy((char *)field[2],"utc");

      break;
    default:
      mxerr(usageStr);
  }  
    
  if (Buffer == NULL)
  {
    if ((Buffer=(char *)malloc(MAX_TINE_BUFFER)) == NULL)
    {
      plhs[0] = mxCreateString("Out of memory !!!");
      return;
    }
    mlBufferSize = MAX_TINE_BUFFER;
  }
	
  if(len < 2 || name[0] == '[' || name[0] == '*')
  {
    k = read_names(&field[0], &data[0], bf1, 0);
    if(!k)
    {
      plhs[0] = mxCreateStructMatrix(1, 1, 1, &field[0]);
      sprintf(buf,"Names read error: %s",bf1);
      data[0] = mxCreateString(buf);
      mxSetFieldByNumber(plhs[0], 0, 0, data[0]);
      mxFree(name);
      return;
    }
    plhs[0] = mxCreateStructMatrix(1,1,k,&field[0]);
    mxSetFieldByNumber(plhs[0],0,0,data[0]);
    for(i = 1; i < k; i++)
    {
      mxSetFieldByNumber(plhs[0],0,i,data[i]);
    }
    mxFree(name);
    return;
 	}	
  strcpy(buf,name);
  if((p = strchr(name,'[')) == NULL)
  { // no property name specified -> query of some sort ?
    if((p=strchr(name,'*')) != NULL && (p=strchr(name,'/')) != NULL)
    {
      //strcpy(bf1,strtok(buf,"/"));
      strncpy(bf1,buf,1024);
      if ((p=strstr(bf1,"/*")) != NULL) *p = 0;
      k = read_names(&field[0], &data[0],bf1,1);
    } 
    else 
    { // no wild card -> get the property list ?
      strcpy(bf1,name);
      k = read_names(&field[0], &data[0],bf1,2);
    }
    if (!k) 
    {
      plhs[0] = mxCreateStructMatrix(1,1,1,&field[0]);
      sprintf(buf,"Names read error: %s",bf1);
      data[0] = mxCreateString(buf);
      mxSetFieldByNumber(plhs[0],0,0,data[0]);
      mxFree(name);
      return;
    }
    plhs[0] = mxCreateStructMatrix(1,1,k,&field[0]);
    mxSetFieldByNumber(plhs[0],0,0,data[0]);
    for(i = 1; i < k; i++)
    {
      mxSetFieldByNumber(plhs[0],0,i,data[i]);
    }
    return;
  }
  if ((p = strchr(name,']')) == NULL)
  {
    plhs	[0] = mxCreateStructMatrix(1,1,1,&field[0]);
    data[0] = mxCreateString("usage: tine_read('dev/loc[prop1;prop2;....;propn]<data_type @interval>'  !!!");
    mxSetFieldByNumber(plhs [0],0,0,data[0]);
    mxFree(name);
    return;
  }

  mxFree(name);
  if ((c1=strchr(buf,'<')) != NULL)
  {
    c = c1; c++;
    strncpy(bf1,c,sizeof(bf1));
    for (c2=bf1; *c2 == ' '; c2++);  // any leading blanks?
    readsize = atoi(c2);
    if ((c2=strchr(c2,' ')) != NULL) // is the datatype left to parse out ?
    {
      while (*c2 == ' ') c2++;       // remove all leading blanks
      if ((c3=strchr(c2,'>')) != NULL) *c3 = 0;
      strncpy(dtstr,c2,32);
      strupr(dtstr);
      if (dtstr[strlen(dtstr)-1] == 'S') dtstr[strlen(dtstr)-1] = 0;
      datatype = ftoi(dtstr);
    }
  }
  if ((c=strchr(buf,'@')) != NULL)
  {
    *c++ = 0; // peel it off before we start tokenizing
    tmr = atoi(c);
  }
  if (c1 != NULL) *c1 = 0; // peel this one off too, if it's there
  strcpy(dev, strtok(buf, "["));
  strncpy(bf1, "", sizeof(bf1));
  strcpy(bf1, strtok(NULL, "]"));
  len = strlen(bf1);

  j = 0;
  k = startindex;
  count = 0;
  for(i = 0; i < len+1; i++)
  {
    if(bf1[i] == ' ') continue;
    if(bf1[i] == ';' || bf1[i] == '\0') 
    {
      prop[j]='\0';
      j = 0;
      if (readsize < 0 || datatype < 0)
      {
        type = read_prop(dev, prop, &size);
      }
      if (type < 0)
      {
        err = -type;
        GetLastLinkError(err,Buffer);
      }
      else
      {
        if (readsize > 0) size = readsize;
        if (datatype > 0) type = datatype;
        if ((fmtsiz=fmtsizeof(type)) < 1) return;
        if (size * fmtsiz > mlBufferSize) 
        {
          if ((tmpBuffer=(char *)realloc(Buffer,size*fmtsiz)) == NULL)
          { // didn't work -> scale down
            size = mlBufferSize / fmtsiz;
          }
          else
          { // record the new settings ...
            Buffer = tmpBuffer;
            mlBufferSize = size * fmtsiz;
          }
        }
        err = read_data_ext(dev, prop, type, size, Buffer, tmr, &dt);
        if (cbid >= 0) 
        {
          sprintf(buf,"%.130s[%.64s]",dev,prop);
          tAttachNotifier(buf, _mlCbNf, cbid);
        }
      }
      name_corr(prop);
      ln = strlen(prop)+1;

      if (ln > 1) 
      {
        field[k] = (char *)mxCalloc(ln, sizeof(char));
        memset((void *)field[k],0,sizeof(field[k]));
        strcpy((char *)field[k],prop);
        memset((void *)prop,0,sizeof(prop));
      } 
      else 
      {
        k++;
        break;
      }

      if (err) 
      {
        error[count++] = k;
        data[k]  = mxCreateString(Buffer);
        data[0]  = mxCreateString(Buffer);
      } 
      else 
      {
        switch(type)
        {	
          case CF_TEXT:
            data[k] = mxCreateString(Buffer);
            break;
          case CF_NAME8:
          case CF_NAME16:
          case CF_NAME32:
          case CF_NAME48:
          case CF_NAME64:
            nmb = fmtsizeof(type);
            dims[0] = size;
            dims[1] = nmb;
            if (size > 1)
            {
              data[k] = mxCreateCharArray(2,dims);
              j = 0;
              CharData = (mxChar *)mxGetData(data[k]);
              for(n = 0; n < size; n++)
              {
                lim = 0;
                while(Buffer[j] != '\0')
                {
                  if(lim < nmb) CharData[size*lim+n] = (mxChar)(unsigned char)Buffer[j];
                  j++;
                  lim++;
                }
                j = (n + 1) * nmb;
              }
            }
            else
            {
              data[k] = mxCreateString(Buffer);
            }
            break;
          case CF_USTRING:
            Buffer[96] = '\0';
            sprintf(buf,"%d %g %g %u %s",*(int *)&Buffer[0],*(float *)&Buffer[4],*(float *)&Buffer[8],*(time_t *)&Buffer[12],(char *)&Buffer[16]);
            data[k] = mxCreateString(buf);
            break;					
          case CF_BYTE:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(unsigned char *)&Buffer[n]);
            break;
          case CF_INT16:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(short*)&Buffer[2*n]);
            break;
          case CF_BOOLEAN:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(int *)&Buffer[2*n]);
            break;
          case CF_INT32:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(int *)&Buffer[4*n]);
            break;
          case CF_FLOAT:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(float *)&Buffer[4*n]);
            break;
          case CF_DOUBLE:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(double *)&Buffer[8*n]);
            break;
          case CF_FI:
            data[k] = mxCreateDoubleMatrix(size,2,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(float *)&Buffer[8*n]);
              *(lp+size) = double(*(int *)&Buffer[8*n+4]);
              lp++;
            }
            break;
          case CF_II:
            data[k] = mxCreateDoubleMatrix(size,2,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(int *)&Buffer[8*n]);
              *(lp+size) = double(*(int *)&Buffer[8*n+4]);
              lp++;
            }
            break;
          case CF_IFFF:
            data[k] = mxCreateDoubleMatrix(size,4,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
	            *lp = double(*(int *)&Buffer[16*n]);
	            *(lp+size) = double(*(float *)&Buffer[16*n+4]);
	            *(lp+2*size) = double(*(float *)&Buffer[16*n+8]);
	            *(lp+3*size) = double(*(float *)&Buffer[16*n+12]);
	            lp++;
            }
            break;
          case CF_FIFI:
            data[k] = mxCreateDoubleMatrix(size,4,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(float *)&Buffer[16*n]);
              *(lp+size) = double(*(int *)&Buffer[16*n+4]);
              *(lp+2*size) = double(*(float *)&Buffer[16*n+8]);
              *(lp+3*size) = double(*(int *)&Buffer[16*n+12]);
              lp++;
            }
            break;
          case CF_IIII:
            data[k] = mxCreateDoubleMatrix(size,4,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(int *)&Buffer[16*n]);
              *(lp+size) = double(*(int *)&Buffer[16*n+4]);
              *(lp+2*size) = double(*(int *)&Buffer[16*n+8]);
              *(lp+3*size) = double(*(int *)&Buffer[16*n+12]);
              lp++;
            }
            break;
          case CF_TTII:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(time_t *)&Buffer[16*n]);
              *(lp+size) = double(*(time_t *)&Buffer[16*n+4]);
              *(lp+2*size) = double(*(int *)&Buffer[16*n+8]);
              *(lp+3*size) = double(*(int *)&Buffer[16*n+12]);
              lp++;
            }
            break;
          case CF_SPECTRUM:
            data[k] = mxCreateDoubleMatrix(size-96,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size-96; n++) *lp++ = double(*(float *)&Buffer[n]);
            break;
          case CF_TDS:
            data[k] = mxCreateDoubleMatrix(size,3,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(time_t *)&Buffer[12*n]);
              *(lp+size) = double(*(float *)&Buffer[12*n+4]);
              *(lp+2*size) = double(*(int *)&Buffer[12*n+8]);
              lp++;
            }	
            break;
          default:
            sprintf(Buffer,"data type %d not handled\n",type);
            data[k]  = mxCreateString(Buffer);
            break;
        }
      }
      k++;
    }
    else
    {
      prop[j++]=bf1[i];
    }
 	}
  strcpy((char *)field[0],"error");
  plhs	[0] = mxCreateStructMatrix(1,1,k,&field[0]);
  if(count)
  {
    if (count > 1)
    {
      data[0] = mxCreateDoubleMatrix(count,1,mxREAL),
      lp = (double *)mxGetPr(data[0]);
      for(i = 0; i < count; i++) *lp++ = double(error[i]);
    }
  } 
  else 
  {
    strcpy((char *)field[1],"timestamp");
    strcpy((char *)field[2],"utc");
    data[0] = mxCreateString("");
  }
  strncpy(tsstr,getDataTimeString(dt,0),64);
  sprintf(dtstr,"%10.3f",dt);
  data[1] = mxCreateString(tsstr);
  data[2] = mxCreateString(dtstr);

  mxSetFieldByNumber(plhs[0],0,0,data[0]);
  mxSetFieldByNumber(plhs[0],0,1,data[1]);
  mxSetFieldByNumber(plhs[0],0,2,data[2]);
  for(i = startindex; i < k; i++) 
  {
    mxSetFieldByNumber(plhs[0],0,i,data[i]);
 	}	
err:
  if (mxerrStr != NULL) 
  {
    mexErrMsgTxt(mxerrStr);
  }
}
