#include <math.h>
#include "mex.h"
#include <windows.h>

#define	PROPMAX 1024
#define	DEVMAX 4096
#define	MAX_TINE_BUFFER 512000 //256000

#include "tine.h"
#include "tbufsrv.h"
//#include "win32rpctypes.h"
//#include "rpcsrv.h"
#include "errors.h"

short ftoi(char *fmt)
{
  char *c,fmtstr[64];
  short ifmt;
  strncpy(fmtstr,fmt,64);
  if ((c=strchr(fmtstr,'.')) != NULL) *c = 0;
  strupr(fmtstr);
  if ((ifmt=getSimpleFormatType(fmtstr)) != CF_NULL) return ifmt;
  return getCompoundFormatType(fmtstr);
}
int mexlog(char *tag,char *text,...)
{
  char str[512];
  FILE *fp = NULL;
  va_list args;
  time_t t = time(NULL);
  static char *fmod = "a+";

  sprintf(str,"%.24s[%s] ",ctime(&t),tag);

  va_start(args,text);
  _vsnprintf(&str[strlen(str)],256,text,args); str[256] = 0;
  va_end(args);

  strcat(str,"\n");
  if ((fp=fopen("l:\\log\\mex.log","a+")) == NULL) return -1;
  fwrite(str,strlen(str),1,fp);

  fclose(fp);
  return 0;
}
int	read_names(const char **name, mxArray **field, char* buf, int op)
{
	PropertyQueryStruct	svrProps[PROPMAX];
	NAME64 svrTags[DEVMAX];
	char bf[80], *tname;
	DTYPE dout;
	int	cc,i,tlen;
	u_short count;

	switch (op)
  {
    case 0:
      dout.dFormat = CF_NAME32; // CF_NAME16;
      dout.dArrayLength = DEVMAX/2;
      dout.data.vptr = svrTags;
      svrTags[0].name[0] = '\0';
      dout.dTag[0] = 0;
      cc = alsnExecLink("ENS","TAGS",&dout,NULL,CA_READ,500);
      count = PROPMAX;
      tlen = 32;
      break;
    case 1:
      i = DEVMAX;
      cc = GetSystemDevices(buf,NULL, svrTags,&i);
      if (cc) break;
      count = (u_short)i;
      tlen = 64;
      /*
      dout.dFormat = CF_SHORT;
      dout.dArrayLength = 1;
      dout.data.usptr = &count;
      cc = alsnExecLink(buf,"NDEVICES",&dout,NULL,CA_READ,500);
      if(cc) break;
      if (count > DEVMAX) count = DEVMAX;
      dout.dFormat = CF_NAME16;
      dout.dArrayLength = count;
      dout.data.vptr = svrTags;
      svrTags[0].name[0] = '\0';
      dout.dTag[0] = 0;
      cc = alsnExecLink(buf,"DEVICES",&dout,NULL,CA_READ,500);
      */
      break;		
    case 2:
      dout.dFormat = CF_SHORT;
      dout.dArrayLength = 1;
      dout.data.usptr = &count;
      cc = alsnExecLink(buf,"NPROPS",&dout,NULL,CA_READ,500);
      if(cc) break;
      if (count > PROPMAX) count = PROPMAX;
      dout.dFormat = CF_STRUCT;
      dout.dArrayLength = count*PROPERTYQUERYSTRUCT_SIZE;
      dout.data.vptr = svrProps;
      svrProps[0].prpName[0] = '\0';
      cc = alsnExecLink(buf,"PROPS",&dout,NULL,CA_READ,500);
      break;
  }
  if(cc) 
  {
    GetLastLinkError(cc,buf);
    return 0;
  }
  switch (op)
  {
		case 0:
		case 1:
			for(i = 0; i < count;i++)
      {
        tname = (char *)svrTags + i*tlen;
        if(strlen(tname) == 0 ) return i;
        //if(strlen((const char *)svrTags[i].name) == 0 ) return i;
        sprintf(bf,"Device_%d",i+1);
        cc = strlen(bf)+1;
        name[i] = (char *)mxCalloc(cc, sizeof(char));
        memset((void *)name[i],0,sizeof(name[i]));
        strcpy((char *)name[i],bf);
        memset((void *)bf,0,sizeof(bf));
        //if(!op)	sprintf(bf,"%s",svrTags[i].name);
        //else	sprintf(bf,"%s/%s",buf,svrTags[i].name);
        if(!op)	sprintf(bf,"%s",tname);
        else	sprintf(bf,"%s/%s",buf,tname);
        field[i] = mxCreateString(bf);
      }
      break;		
    case 2:
      for(i= 0;i < count;i++)
      {
        if(svrProps[i].prpName[0] == 0 ) return i;
        cc = strlen(svrProps[i].prpName)+1;
        name[i] = (char *)mxCalloc(cc, sizeof(char));
        memset((void *)name[i],0,sizeof(name[i]));
        strcpy((char *)name[i],svrProps[i].prpName);
        field[i] = mxCreateString(svrProps[i].prpDescription);
			}
      break;
 	}
  return i;
}
int mexIsStockProperty(char *prop)
{
  if (!stricmp(prop,"DEVICES")) return TRUE;
  if (!stricmp(prop,"NDEVICES")) return TRUE;
  if (!stricmp(prop,"NPROPS")) return TRUE;
  if (!stricmp(prop,"NPROPERTIES")) return TRUE;
  if (!stricmp(prop,"PROPERTIES")) return TRUE;
  return FALSE;
}
int	read_prop(char *dev, char *prop, int *size)
{
  PropertyQueryStruct	svrProp;
	DTYPE dout, din;
	int cc, fmt;
  char *prp = "PROPS";
  if ((cc=getPropertyInfoFromListener(dev,prop,size,&fmt)) == 0)
  {
    return fmt;
  }

  if (mexIsStockProperty(prop)) prp = "STOCKPROPS";

  dout.dFormat = CF_STRUCT;
  dout.dArrayLength = PROPERTYQUERYSTRUCT_SIZE;
  dout.data.vptr = &svrProp;
  dout.dTag[0] = '\0';

  din.dFormat = CF_TEXT;
  din.dArrayLength = strlen(prop);
  din.data.vptr = prop;
  din.dTag[0] = '\0';
  svrProp.prpName[0] = '\0';

  if ((cc=alsnExecLink(dev,prp,&dout,&din,CA_READ,500)) != 0)
  {
    *size = 0;
    return -cc;
 	}
  if (svrProp.prpName[0] == 0) 
  {
    *size = 0;
    return -cc;
 	}
  *size = svrProp.prpSize;
  return LFMT(svrProp.prpFormat);
}
int write_read_data(char *dev, char *prop, int type, int writesize, int readsize, char *buf,int access_rate,double *pDataTime)
{
	DTYPE dout, din;
	int cc;

  if (readsize < 0 || writesize < 0) return dimension_error;
  if (type < 0) return illegal_format;
  if (buf == NULL) return code_failure;
  din.dFormat = type;
  din.dArrayLength = writesize;
  din.data.vptr = buf;
  din.dTag[0] = 0;
	dout.dFormat = type;
	dout.dArrayLength = readsize;
	dout.data.vptr = buf;
	dout.dTag[0] = 0;
  if ((cc=ExecLinkEx(dev,prop,&dout,&din,CA_READ|CA_WRITE|CA_MUTABLE,access_rate)) != 0)
  {
    GetLastLinkError(cc,buf);
    if (pDataTime != NULL) *pDataTime = (double)time(NULL);
		return 1;
	}
  if (pDataTime != NULL) *pDataTime = dout.dTimeStamp;
	return 0;
}
void name_corr(char *name)
{
  int	i, len;

  len = strlen(name);
  for (i = 0; i < len; i++) 
  {
    if (name[i] == '.') 
    {
      name[i] = '_';
    } 
    else if (name[i] == '-') 
    {
      name[i] = '_';
    }
	}
}
char Buffer[MAX_TINE_BUFFER];
//__declspec(dllexport) 
void mexFunction(int lcnt,mxArray *lsp[],int rcnt,const mxArray *rsp[]) 
{
	mxArray	*data[PROPMAX];
	const char *field[PROPMAX];
	double *lp, dt = (double)time(NULL);
	int	error[PROPMAX];
	char *name;
	char *p;
	char buf[1024];
	char bf1[1024], *c=NULL, *c1=NULL, *c2=NULL, *c3=NULL, *cf=NULL;
  char dtstr[32];
	char prop[80];
	char dev[80];
	int	plen,len,type,size,fmtsiz,writesize = -1,readsize = -1,ln,rate=1000,datatype = -1;
	int	dims[2];
	int	i,j,k,err,count,n,startindex = 3;
	int	lim,nmb;
	mxChar *CharData;
  char tsstr[64];
  
  if (lsp == NULL || rsp == NULL || rcnt == 0) return;
  if (rcnt != 2 || !mxIsChar(rsp[1]))
  {
    if (rcnt == 1 || !mxIsChar(rsp[0]))
    {
      len = mxGetN(rsp[0]) + 1;
      name = (char *)mxCalloc(len, sizeof(char));
      mxGetString(rsp[0],name,len);
      lsp[0] = mxCreateString("Usage: error=tinewriteread(values,\'/<CONTEXT>/<SERVER>/<DEV>[<PROP>]<data_size data_type>@interval\');\n where value - string or double Nx1 array\nThe error contains error message!!!");
      mxFree(name);
    }
    else
    {
      lsp[0] = mxCreateString("Input argument error !!!");
    }
    return;
  }

  // the requested data endpoint ...
  len = mxGetN(rsp[1]) + 1;
  name = (char *)mxCalloc(len, sizeof(char));
  mxGetString(rsp[1],name,len);

  field[0] = (char *)mxCalloc(6, sizeof(char));
  field[1] = (char *)mxCalloc(10, sizeof(char));
  field[2] = (char *)mxCalloc(4, sizeof(char));
  memset((void *)field[0],0,sizeof(field[0]));
  memset((void *)field[1],0,sizeof(field[1]));
  memset((void *)field[2],0,sizeof(field[2]));

  if((p=strchr(name,'?')) != NULL)
  {
    strcpy((char *)field[0],"usage");
    lsp[0] = mxCreateStructMatrix(1,1,1,&field[0]);
    data[0] = mxCreateString("data = tinewriteread(values,\'/<CONTEXT>/<SERVER>/<DEV>[<PROP>]<data_size data_type>@interval\');\nSERVERs = tineread('CONTEXT');\nDEVs = tineread('/CONTEXT/SERVER/*');\nPROP = tineread('/CONTEXT/SERVER/DEV')\nThe error field contains the number(s) of the wrong read\nprops and the corresponding props contain error message(s)!!!");
    mxSetFieldByNumber(lsp[0],0,0,data[0]);
    mxFree(name);
    return;
 	}
	
  strcpy((char *)field[0],"error");
  strcpy((char *)field[1],"timestamp");
  strcpy((char *)field[2],"utc");
  if(len < 2 || name[0] == '[' || name[0] == '*')
  {
    k = read_names(&field[0], &data[0], bf1, 0);
    if(!k)
    {
      lsp[0] = mxCreateStructMatrix(1, 1, 1, &field[0]);
      sprintf(buf,"Names read error: %s",bf1);
      data[0] = mxCreateString(buf);
      mxSetFieldByNumber(lsp[0], 0, 0, data[0]);
      mxFree(name);
      return;
    }
    lsp[0] = mxCreateStructMatrix(1,1,k,&field[0]);
    //data[0] = mxCreateString("");
    mxSetFieldByNumber(lsp[0],0,0,data[0]);
    for(i = 1; i < k; i++)
    {
      mxSetFieldByNumber(lsp[0],0,i,data[i]);
    }
    mxFree(name);
    return;
 	}
	
  strcpy(buf,name);
  if((p = strchr(name,'[')) == NULL)
  { // no property name specified -> query of some sort ?
    if((p=strchr(name,'*')) != NULL && (p=strchr(name,'/')) != NULL)
    {
      //strcpy(bf1,strtok(buf,"/"));
      strncpy(bf1,buf,1024);
      if ((p=strstr(bf1,"/*")) != NULL) *p = 0;
      k = read_names(&field[0], &data[0],bf1,1);
    } 
    else 
    { // no wild card -> get the property list ?
      strcpy(bf1,name);
      k = read_names(&field[0], &data[0],bf1,2);
    }
    if (!k) 
    {
      lsp[0] = mxCreateStructMatrix(1,1,1,&field[0]);
      sprintf(buf,"Names read error: %s",bf1);
      data[0] = mxCreateString(buf);
      mxSetFieldByNumber(lsp[0],0,0,data[0]);
      mxFree(name);
      return;
    }
    lsp[0] = mxCreateStructMatrix(1,1,k,&field[0]);
    //data[0] = mxCreateString("");
    mxSetFieldByNumber(lsp[0],0,0,data[0]);
    for(i = 1; i < k; i++)
    {
      mxSetFieldByNumber(lsp[0],0,i,data[i]);
    }
    return;
  }

  if ((p = strchr(name,']')) == NULL)
  {
    lsp	[0] = mxCreateStructMatrix(1,1,1,&field[0]);
    data[0] = mxCreateString("usage: tinewriteread('/<CONTEXT>/<SERVER>/<DEV>[<PROP>]<data_size data_type>@interval'  !!!");
    mxSetFieldByNumber(lsp [0],0,0,data[0]);
    mxFree(name);
    return;
  }

  mxFree(name);
  if ((c1=strchr(buf,'<')) != NULL)
  {
    c = c1; c++;
    strncpy(bf1,c,sizeof(bf1));
    for (c2=bf1; *c2 == ' '; c2++);  // any leading blanks?
    if (isalpha(*c2))
    { // just the format given
      cf = c2;
    }
    else
    {
      readsize = atoi(c2);
      if ((c2=strchr(c2,' ')) != NULL) // is the datatype left to parse out ?
      {
        while (*c2 == ' ') c2++;       // remove all leading blanks
        cf = c2;
      }
    }
    if (cf != NULL)
    {
      if ((c3=strchr(cf,'>')) != NULL) *c3 = 0;
      strncpy(dtstr,cf,32);
      strupr(dtstr);
      if (dtstr[strlen(dtstr)-1] == 'S') dtstr[strlen(dtstr)-1] = 0; // in case "floats" instead of "float"
      datatype = ftoi(dtstr);
    }
  }
  if ((c=strchr(buf,'@')) != NULL)
  {
    *c++ = 0; // peel it off before we start tokenizing
    rate = atoi(c);
  }
  if (c1 != NULL) *c1 = 0; // peel this one off too, if it's there
  strcpy(dev, strtok(buf, "["));
  strncpy(bf1, "", sizeof(bf1));
  strcpy(bf1, strtok(NULL, "]"));
  plen = strlen(bf1);  // length of property string

  if (datatype < 0)
  {
    type = read_prop(dev, bf1, &readsize);
    if (type < 0) type = CF_INT32; // try this ...
  }
  else
  {
    type = datatype;
  }
  size = -1;
	// the data to 'write'
  switch(type)
  {
    default:
      if(!mxIsChar(rsp[0]))
      {
        lsp[0] = mxCreateString("Input argument error !!!");
        return;
      }
      len = mxGetN(rsp[0]);
      mxGetString(rsp[0],Buffer,len);
      if(getFormatSize(type)) 
      {  
	      size=len/getFormatSize(type);
      } 
      else 
      {
	      size=len;
      } 
    	break;    
    case CF_TEXT:
      if(!mxIsChar(rsp[0]))
      {
	      lsp[0] = mxCreateString("Input argument error !!!");
	      return;
      }
      len = mxGetN(rsp[0]) + 1;
      mxGetString(rsp[0],Buffer,len);
      break;
      // this below is wrong ...
    case CF_CHAR8:
    case CF_CHAR16:
    case CF_CHAR32:
    case CF_CHAR48:
    case CF_USTRING:
      if(!mxIsChar(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			len = mxGetN(rsp[0]) + 1;
			mxGetString(rsp[0],Buffer,len);
  		break;
		case CF_BYTE:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if(n < size) size = n;
			for(i = 0; i < size; i++) Buffer[i] = (char)lp[i];
		  break;
		case CF_INT16:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if (n < size)	size = n;
			for (i = 0; i < size; i++) *(short *)&Buffer[2*i] = (short)lp[i];
  		break;
		case CF_INT32:
		case CF_BOOLEAN:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if (n < size)	size = n;
			for(i = 0; i < size; i++) *(u_int *)&Buffer[4*i] = (u_int)lp[i];
		  break;
		case CF_FLOAT:
			if (!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if (n < size) size = n;
			for (i = 0; i < size; i++) 
      {
				*(float *)&Buffer[4*i] = (float)lp[i];
			}
		  break;
		case CF_DOUBLE:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if(n < size) size = n;
			for(i = 0; i < size; i++) 
      {
			  //printf("#%d: %f\n", i, lp[i]);
			  *(double *)&Buffer[i] = (double)lp[i];
			}
		  break;
		case CF_FI:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if(n < size)	size = n;
			for(i = 0; i < size; i+=2)
      {
				*(float *)&Buffer[4*i] = (float)lp[i];
				*(int *)&Buffer[4*i+4] = (int)lp[i+1];
			}
		  break;
		case CF_II:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if(n < size)	size = n;
			for(i = 0; i < size; i+=2)
      {
				*(int *)&Buffer[4*i]   = (int)lp[i];
				*(int *)&Buffer[4*i+4] = (int)lp[i+1];
			}
		  break;
		case CF_IFFF:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if(n < size)	size = n;
			for(i = 0; i < size; i+=4)
      {
				*(int *)&Buffer[4*i]      = (int)lp[i];
				*(float *)&Buffer[4*i+4]  = (float)lp[i+1];
				*(float *)&Buffer[4*i+8]  = (float)lp[i+2];
				*(float *)&Buffer[4*i+16] = (float)lp[i+3];
			}
      break;
		case CF_TTII:
		case CF_IIII:
			if(!mxIsDouble(rsp[0]))
      {
				lsp[0] = mxCreateString("Input argument error !!!");
				return;
			}
			lp = (double *)mxGetPr(rsp[0]);
			size = mxGetM(rsp[0]);
//			if(n < size)	size = n;
			for(i = 0; i < size; i+=4)
      {
				*(int *)&Buffer[4*i]    = (int)lp[i];
				*(int *)&Buffer[4*i+4]  = (int)lp[i+1];
				*(int *)&Buffer[4*i+8]  = (int)lp[i+2];
				*(int *)&Buffer[4*i+16] = (int)lp[i+3];
			}
		  break;
	}
  writesize = size;
	//-> err = write_data(dev,bf1,type,size,Buffer,rate);

  j = 0;
  k = startindex;
  count = 0;
  for(i = 0; i < plen+1; i++)
  {
    if(bf1[i] == ' ') continue;
    if(bf1[i] == ';' || bf1[i] == '\0') 
    {
      prop[j]='\0';
      j = 0;
      if (readsize < 0 || datatype < 0)
      {
        type = read_prop(dev, prop, &readsize);
      }
      if (type < 0)
      {
        err = -type;
        GetLastLinkError(err,Buffer);
      }
      else
      {
        if (readsize > 0) size = readsize;
        if (datatype > 0) type = datatype;
        if ((fmtsiz=fmtsizeof(type)) < 1) return;
        if (readsize *  fmtsiz > MAX_TINE_BUFFER) readsize = MAX_TINE_BUFFER / fmtsiz;
//->
        err = write_read_data(dev, prop, type, writesize, readsize, Buffer, rate, &dt);
      }
      name_corr(prop);
      ln = strlen(prop)+1;

      if (ln > 1) 
      {
        field[k] = (char *)mxCalloc(ln, sizeof(char));
        memset((void *)field[k],0,sizeof(field[k]));
        strcpy((char *)field[k],prop);
        memset((void *)prop,0,sizeof(prop));
      } 
      else 
      {
        k++;
        break;
      }

      if (err) 
      {
        error[count++] = k;
        data[k]  = mxCreateString(Buffer);
        data[0]  = mxCreateString(Buffer);
      } 
      else 
      {
        switch(type)
        {	
          case CF_TEXT:
            data[k] = mxCreateString(Buffer);
            break;
          case CF_NAME8:
          case CF_NAME16:
          case CF_NAME32:
          case CF_NAME48:
          case CF_NAME64:
            nmb = fmtsizeof(type);
            dims[0] = size;
            dims[1] = nmb;
            if (size > 1)
            {
              data[k] = mxCreateCharArray(2,dims);
              j = 0;
              CharData = (mxChar *)mxGetData(data[k]);
              for(n = 0; n < size; n++)
              {
                lim = 0;
                while(Buffer[j] != '\0')
                {
                  if(lim < nmb) CharData[size*lim+n] = (mxChar)(unsigned char)Buffer[j];
                  j++;
                  lim++;
                }
                j = (n + 1) * nmb;
              }
            }
            else
            {
              data[k] = mxCreateString(Buffer);
            }
            break;
          case CF_USTRING:
            Buffer[96] = '\0';
            sprintf(buf,"%d %g %g %u %s",*(int *)&Buffer[0],*(float *)&Buffer[4],*(float *)&Buffer[8],*(time_t *)&Buffer[12],(char *)&Buffer[16]);
            data[k] = mxCreateString(buf);
            break;					
          case CF_BYTE:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(unsigned char *)&Buffer[n]);
            break;
          case CF_INT16:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(short*)&Buffer[2*n]);
            break;
          case CF_BOOLEAN:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(int *)&Buffer[2*n]);
            break;
          case CF_INT32:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(int *)&Buffer[4*n]);
            break;
          case CF_FLOAT:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(float *)&Buffer[4*n]);
            break;
          case CF_DOUBLE:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++) *lp++ = double(*(double *)&Buffer[8*n]);
            break;
          case CF_FI:
            data[k] = mxCreateDoubleMatrix(size,2,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(float *)&Buffer[8*n]);
              *(lp+size) = double(*(int *)&Buffer[8*n+4]);
              lp++;
            }
            break;
          case CF_II:
            data[k] = mxCreateDoubleMatrix(size,2,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(int *)&Buffer[8*n]);
              *(lp+size) = double(*(int *)&Buffer[8*n+4]);
              lp++;
            }
            break;
          case CF_IFFF:
            data[k] = mxCreateDoubleMatrix(size,4,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
	            *lp = double(*(int *)&Buffer[16*n]);
	            *(lp+size) = double(*(float *)&Buffer[16*n+4]);
	            *(lp+2*size) = double(*(float *)&Buffer[16*n+8]);
	            *(lp+3*size) = double(*(float *)&Buffer[16*n+12]);
	            lp++;
            }
            break;
          case CF_FIFI:
            data[k] = mxCreateDoubleMatrix(size,4,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(float *)&Buffer[16*n]);
              *(lp+size) = double(*(int *)&Buffer[16*n+4]);
              *(lp+2*size) = double(*(float *)&Buffer[16*n+8]);
              *(lp+3*size) = double(*(int *)&Buffer[16*n+12]);
              lp++;
            }
            break;
          case CF_IIII:
            data[k] = mxCreateDoubleMatrix(size,4,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(int *)&Buffer[16*n]);
              *(lp+size) = double(*(int *)&Buffer[16*n+4]);
              *(lp+2*size) = double(*(int *)&Buffer[16*n+8]);
              *(lp+3*size) = double(*(int *)&Buffer[16*n+12]);
              lp++;
            }
            break;
          case CF_TTII:
            data[k] = mxCreateDoubleMatrix(size,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(time_t *)&Buffer[16*n]);
              *(lp+size) = double(*(time_t *)&Buffer[16*n+4]);
              *(lp+2*size) = double(*(int *)&Buffer[16*n+8]);
              *(lp+3*size) = double(*(int *)&Buffer[16*n+12]);
              lp++;
            }
            break;
          case CF_SPECTRUM:
            data[k] = mxCreateDoubleMatrix(size-96,1,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size-96; n++) *lp++ = double(*(float *)&Buffer[n]);
            break;
          case CF_TDS:
            data[k] = mxCreateDoubleMatrix(size,3,mxREAL),
            lp = (double *)mxGetPr(data[k]);
            for(n = 0; n < size; n++)
            {
              *lp = double(*(time_t *)&Buffer[12*n]);
              *(lp+size) = double(*(float *)&Buffer[12*n+4]);
              *(lp+2*size) = double(*(int *)&Buffer[12*n+8]);
              lp++;
            }	
            break;
          default:
            sprintf(Buffer,"data type %d not handled\n",type);
            data[k]  = mxCreateString(Buffer);
            break;
        }
      }
      k++;
    }
    else
    {
      prop[j++]=bf1[i];
    }
 	}
  strcpy((char *)field[0],"error");
  lsp	[0] = mxCreateStructMatrix(1,1,k,&field[0]);
  if(count)
  {
    if (count > 1)
    {
      data[0] = mxCreateDoubleMatrix(count,1,mxREAL),
      lp = (double *)mxGetPr(data[0]);
      for(i = 0; i < count; i++) *lp++ = double(error[i]);
    }
  } 
  else 
  {
    strcpy((char *)field[1],"timestamp");
    strcpy((char *)field[2],"utc");
    data[0] = mxCreateString("");
  }
  strncpy(tsstr,getDataTimeString(dt,0),64);
  sprintf(dtstr,"%10.3f",dt);
  data[1] = mxCreateString(tsstr);
  data[2] = mxCreateString(dtstr);

  mxSetFieldByNumber(lsp[0],0,0,data[0]);
  mxSetFieldByNumber(lsp[0],0,1,data[1]);
  mxSetFieldByNumber(lsp[0],0,2,data[2]);
  for(i = startindex; i < k; i++) 
  {
    mxSetFieldByNumber(lsp[0],0,i,data[i]);
 	}	
}
