Attribute VB_Name = "ARCH1"
Option Explicit


Global HistoryKeywords(200) As HistDisplayType, NOCXCSVProps%
Global OCXFormCaption$, OCXConfigDirectory$
Global DefaultDataReadTimeOut&, DefaultDataLinkTimeOut&, DefaultComTimeOut&, DefaultTimeOutIncrement&
Global selectedTransportModeDecoration As String
Global selectedTransportModeHelperText As String

Type ArchiveServerInfo
  context As String
  HistoryServerName As String
  DataServerName As String
  ConfigFileName As String
  StateServerName As String
  'MachineName As String
  ConfigFilePath As String
End Type

Global Const NUMEQP = 1000
Global Const NUMDEV = 100
Global Const MaxStrings = 500
'Global Const MaxPoints = 60000 '4000 '20000 ' 4000
Global MaxPoints&
Global Const MaxCurves = 10
Global Const MaxPlots = 10
Global Const MaxDevices = 10000
Global Const MaxAxes = 2
Global NArchContexts%

' Redim-ed!!
Global ArchDataBuffer() As DBLDBL
Global ArchData() As DBLDBL
Global ArchTimeBins#()
Global PlotData() As DBLDBL
Global filterDataBuffer() As FLTINT
Global filterTextBuffer() As NAME32I
Global ydat() As Single
Global xdat0&(), ydat0!()
Global xdat1&(), ydat1!()
Global xdat2() As Long
Global ydat2() As Single
Global ydat3() As Single

' Get config files from SERVER (central or archiver...)
Global Const ConfFiles = 500
Global ConfigNames(ConfFiles - 1) As NAME64
Global ConfigSubDirNames(ConfFiles - 1) As NAME64

' USe for FILES and for PROPERTIES...
Global ConfigStruct(ConfFiles) As HstCfg

Global ComJob$, ComFacility$, ComSubsystem$, FormLoaded As Boolean
Global Const CommandArchiver$ = "ARCHIVER"
Global Const CommandLHistChooser$ = "LHCHOOSER"
Global Const CommandLHistClient$ = "LHCLIENT"
Global UseFileServerFlag As Boolean

Global ArchiveServerTestNames$(10), NArchiveServerTestNames%

Global Const OpMinus = "-"
Global Const OpPlus = "+"
Global Const OpMult = "*"
Global Const OpDiv = "/"
Global Const ErrorValue! = 1E+20
Global DisplayModes$(8), DisplayModeIndexes%(8), NDisplayModes%

Global Const CArchivers = 0
Global Const LHistoryChooser = 1
Global Const LHistoryClient = 2

Global Const RelativeScale = 0
Global Const AbsoluteScale = 1
Global ArchiveMode%, ScalingMode%, SwitchingScalingFlag As Boolean
Global SkipLoading%

Global Const OneHour& = 3600
Global Const OneDay& = 24 * OneHour

Global devNames() As String, NDevs%
Global devNameBuff(MaxAxes - 1, MaxDevices, MaxCurves) As String

Global NamesX1$(), NamesX2$(), NNamesX1&, NNamesX2&, MaxSubIndex%

Global Const CopyOffset = MaxCurves

Global Const NTDBunches = 12 ' Number of bunches in TTF-TD Archives...
Global SwitchingWindows As Boolean
Global LiveData As Boolean

Global Const MaxZooms = 10
Global NZooms%, ZoomLimits#(MaxZooms, 3)
Global ArchiveStart&, ArchiveStop&, KeepZoom#(3)
Global SelectedTrace%(1), SelectedTracePlotIndex&(1), SelectedPlotArrayTrace%

Global ArchStringDataBuffer(MaxStrings, MaxCurves * 2) As NAME32I

Global ArrayData!(), ArrayRefData!(), PlotArrayData!(), RefAxisData!()
Global ArrayDataSize&, ArrayDataTimeStamp#, ArrayDataKeyword$
Global ArrayINTData%(), ArrayProp$, ArrayLinkIndex&, ArrayDataDeviceNames$(), GotArrayDeviceNamesFlag As Boolean
Global ArrayDataDevice$, ArrayDataServer$, ArrayDataContext$, ArrayNameProperty$

Global ActivePlot%, ArchiveTS#, ReferenceTS#
Global ArchiveTSIndex%, KinoIndex%, KinoFrames%, KinoCursor%, ChubbyFactor!
Global KinoFlag As Boolean

Global ExtraDigitFlag As Boolean, DLabWidthDefault%, DUnitLeftDefault%, DHelpLeftDefault%

Global filterDataBufferNPoints&(10)
Global filterAcquired As Boolean
Global filterString As String

Global YCursorArray!(1), XCursorArray#(1), DNameToIndex%(MaxCurves * 2), IndexToDName%(MaxCurves * 2)
Global ACOPDefaultMode&, ACOPDefaultWidth&, ACOPDisplayModes&(10), ACOPBarModeFlag As Boolean
Global gArchiveContext$, gHistoryServer$, gDataServer$, SelectedContext%, gArchiveDevice$


Global gArchiveServerInfo() As ArchiveServerInfo ' ReDim in getArchiveServerInfo()
Global nConfiguredArchiveServers As Integer, UserConfigOK As Boolean, nMaxConfiguredArchiveServers As Integer
'Global SetFile$(), SetHelp$(), SetDir$()     ' ReDim in getArchiveServerInfo()
'Global NElem%(), NSet%()          ' ReDim in getArchiveServerInfo()
Global CONFIGContexts$(), CONFIGFile$(), CONFIGHelp$(), CONFIGDir$()    ' ReDim in getArchiveServerInfo()
Global nCONFIG%, NElem%(), ncontexts%          ' ReDim in getArchiveServerInfo()

Global Nmax_last(MaxCurves) As Integer
Global ih_last(MaxCurves) As Integer
Global xIndex As Integer, OptXIndex%
Global yIndex As Integer, OptYIndex%
Global saveConfigCanceled As Boolean
Global saveConfigFileName As String
Global saveConfigDescription As String

Global nl$
Global Win_Sec&(10)
Global datstr As String * 32
Global param%, Index%, iplotable%
Global StartUp%
Global TargetYear As Integer

Global F_load As Integer

Global col_field(10) As Long
Global SelectBits&(33)

Global nparam%
Global Const DBPATH$ = "l:\database\archive\"
Global UserConfigDir$, UserConfigPath$, HistoryOCXPath$
'Global UserConfigSubDirectory$, ConfigPath$
Global rtyp As String * 1
Type FECSTRUCT: eqm As String
                prop As String
                dev As String
                EqNo As Integer
                len As Integer
                fmt As String
                reclen As Integer
                rectyp As Integer
                tstamp As Integer
                vnum As Integer
                Comment As String
                responsible As String
                recIndex As Integer
End Type
Global fec(NUMEQP) As FECSTRUCT
Global vname$(NUMEQP, NUMDEV), vfmt$(NUMEQP, NUMDEV), vcmt$(NUMEQP, NUMDEV), VPlot$(NUMEQP, NUMDEV)
Global VMax#(NUMEQP, NUMDEV), VMin#(NUMEQP, NUMDEV), VUnit$(NUMEQP, NUMDEV), vsize%(NUMEQP, NUMDEV)
Global fref%(NUMEQP), pref%(NUMEQP), VOffset#(NUMEQP, NUMDEV), Nexti%, Nextp%, Nextf%, NextSubi%
Global correlate%, lg%

Global MKIoffset%, DLabWidth%

Type FECSLCT: ' structure for selected properties:
              'PropIndex As Integer
'
              ArchiveSourceFlag As Boolean ' From Central archiver, or a history?
              ContextName As String
              DataServerName As String
              HistoryServerName As String ' Don't separate HISTORY and ARCHIVE! (use .HIST and .ARCH!)
              PropName As String
              deviceName As String
              DeviceIndex As Integer
              DeviceSubIndex As Integer ' for TD properties,...
              PropUnits As String
              PropSize As Long
              PropFormat As Byte
              PropFormatStr As String
              PropDesc As String
              NPropDevices As Long ' if the number of DEVICES for the property is not its SIZE
              
              ' Which has been used to select this channel? Device NAME or INDEX?
              ValidDeviceName As Boolean
              ValidDeviceIndex As Boolean
              
              'ArchiveServer As String
              'FecName As String ' Archiver-Keyword....
              'fecNo As Integer are these really NOT needed? (pref and fref....)
              'pNo As Integer
              'helpText As String
              '
              ' Need for Local History Stuff
              'ArchiveDataServer As String
              'ArchiveHistoryServer As String
              'ArchiveProperty As String
              ' Flag that data is from archiver....
              'LHDataAlsoFromArchiver As Boolean
              'WhereToGetDataOption As Integer
              
              '
              NumPoints As Long
              TotalPoints As Long
              ' Total History Points
              TotalLHPoints As Long
              ' Total Archive Points
              TotalArchPoints As Long
              '
              '
              'DataServer As String
              LinkIndex As Long
              ACOPPlotIndex As Long
              DrawWidth As Integer
              DispColor As Long
              '
              scale As Integer
              PListIndex As Integer
              VMax As Double ' Default Values
              VMin As Double ' for scaling
              VScale As Double
              VOffset As Double
              VPlot As String
              VUnit As String
              Active As Boolean
              Acquire As Boolean
              ReFilter As Boolean
              ReScale As Boolean
              RePlot As Boolean
              MaxValue As Double
              MinValue As Double
              ' For SPECTRA
              arrayType As Integer
              XMaxValue As Double
              XMinValue As Double
              XUnits As String
              'Offset As Integer
              '
              SelectedMaxValue As Double ' When reading in TextBox stuff...
              SelectedMinValue As Double ' For scaling....
              SelectedOffset As Double ' For scaling....
              SelectedVMode As String ' Plotted as Log/Lin...
              SelectedVModeIndex As Integer ' Plotted as Log/Lin...
              PlotMaxValue As Double ' Actual Values (especially for AUTOSCALE, needed for ARRAY mode)
              PlotMinValue As Double ' for scaling
              PlotOffset As Double ' for scaling
              PlotZeroOffset As Double ' for calculating BACK
              PlotDelta As Double '
              PlotScale As Double '
              PlotAutoScale As Boolean
            SampleRasterFlag As Boolean ' Didn't use ZERO?
            SampleRasterIndex As Integer ' Which Index?
            SampleRaster As Integer ' If calculated by client program, what was the value?

            LastDeviceContext As String
            LastDeviceProperty As String
            LastDeviceServer As String
End Type
Global FSlct(MaxCurves * 2) As FECSLCT
Global SampleRasterCheckIndex%

Type SETSLCT: PropertyName As String
              ContextName As String
              DataServerName As String
              HistoryServerName As String
              'ArchiveServerName As String
              EqnIndex As Integer
              deviceName As String
              DeviceIndex As Integer
              DeviceSubIndex As Integer
              AxScale As Double
              AxOffset As Double
              min As Double
              max As Double
              plottype As String
              units As String
              Description As String
End Type
Global CSet() As SETSLCT ' ReDim in getArchiveServerInfo()

Global NPlots%(1)
Global fecKeywords() As String, ttfKeywords() As String

Type KeywordInfo
  context As String
  HistoryServer As String
  DataServer As String
  Keyword As String
  max As Single
  min As Single
  egu As String
  plot As String
  desc As String
  size As Integer
  fmt As String
  arrayType As Integer
  xmax As Single
  xmin As Single
  XUnits As String
End Type

Global archivedKeywords() As KeywordInfo
Global filterKeywords(10) As KeywordInfo
Global nFilterKeywords As Integer
Global TmpConfigKeyword As KeywordInfo

Type HistoryConfigType
    name As String
    Description As String
    LocationProps As String
    LocationConfigs As String
    'NClientOcxProps As Integer
    NProps As Integer
    OCXFlag As Boolean
    OCX_But_use_CentralFiles_Flag As Boolean
    WhichCentralDirectoryForConfigFiles As String
End Type
Global HistoryConfigs(20) As HistoryConfigType
Global NHistoryConfigs%, MaxNHistoryConfigs%
Global SelectedHistoryDir%, SelectedHistoryConfigDescription$
Global SelectedConfig%

Global gSubSystems() As String
Global gArchiveSubSystem$
Global gNumSubSystems As Integer
'Global cslct(2) As FECSLCT
'Global typ$(3)
Global extraArchiveServer(10) As String
Global nExtraArchiveServers As Integer
Global Const MaxnExtraArchiveServers = 5


' REDUCE for Kaul's slow PC....
'Global Const MaxPlotPoints = 3000
'Global Const MaxGetDataPoints = 10000
'Global Const MaxDataPointsAPPEND = MaxPlotPoints - MaxGetDataPoints - 2

Global MaxPlotPoints&
Global MaxGetDataPoints&
Global MaxDataPointsAPPEND&

Global AppendTimeIncrement%, AppendTimeCounter%, AppendTotalCounter%

Global ShiftWindowDirection%


' Registry function declarations:
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" _
        (ByVal hKey As Long, ByVal lpctstr As String, phKey As Long) _
        As Long
        
Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, _
         lpcbValue As Long) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpdwReserved As Long, _
         lpdwType As Long, lpbData As Byte, lpcbValue As Long) As Long

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Sub PlotTheData(flag%)
Dim i%, ii%, n&, StartLabel%, StopLabel%, TmpPlots%, tmpIndex%, TmpMin#, tmpMax#
Dim errcnt As Integer

On Error GoTo PlotTheDataError
ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0
' Mode from OptPlot

ArchiveForm.ComSelect(2).BackColor = &HE0E0E0
For i% = 0 To 2
    ArchiveForm.TxtSelect(i%).BackColor = &HE0E0E0
Next i%

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).RePlot = False
        End If
    Next i%
    
    
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
    
    ArchiveForm.ACOPPlot(ActivePlot%).Visible = True
    'ArchiveForm.ACOPPlot(ActivePlot%).GraphStyle = TIME_LIN
ElseIf flag = 1 Then
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
End If

If NZooms% > 0 Then
    'ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits&(NZooms%, 2)
    'ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits&(NZooms%, 3)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmin = ZoomLimits&(NZooms%, 0)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmax = ZoomLimits&(NZooms%, 1)
Else
    ZoomLimits#(0, 0) = CDbl(ArchiveStart&)
    ZoomLimits#(0, 1) = CDbl(ArchiveStop&)
    
    If ScalingMode% = RelativeScale Then
        ZoomLimits#(0, 2) = 0
        ZoomLimits#(0, 3) = 100
    Else
        ' Do the same check in ScaleData ?
        TmpMin# = 1000000#
        tmpMax# = -1000000#
        For i% = StartLabel% To StopLabel%
            With FSlct(i%)
                If FSlct(i%).RePlot = True Then
                    If .PlotMaxValue > tmpMax# Then tmpMax# = .PlotMaxValue
                    If .PlotMinValue < TmpMin# Then TmpMin# = .PlotMinValue
                End If
            End With
        Next i%
        ZoomLimits#(0, 2) = TmpMin#
        ZoomLimits#(0, 3) = tmpMax#
    End If
End If

ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits#(NZooms%, 2)
ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits#(NZooms%, 3)
ArchiveForm.ACOPPlot(ActivePlot%).xmin = CLng(ZoomLimits#(NZooms%, 0))
ArchiveForm.ACOPPlot(ActivePlot%).xmax = CLng(ZoomLimits#(NZooms%, 1))

' Get more points than one thinks one needs (x-min and max are set to ZOOM limits not to ArchiveStart and -Stop
'ArchiveStart& = ArchiveStart& - 3600 * 1
'ArchiveStop& = ArchiveStop& + 3600 * 1

' Get an overview of what is to be plotted?
Call DrawCaption

For i% = StartLabel% To StopLabel%
    ArchiveForm.dnam(i%).BorderStyle = 0
    'ArchiveForm.Text1(i%).text = ""
Next i%

'For i% = 0 To 3
'    ArchiveForm.ComSelect(i%).Enabled = False
'Next i%

ArchiveForm.ChkAuto(1).Enabled = False

For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).RePlot = True Then
        n& = FSlct(i%).NumPoints
        ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = ACOPDefaultMode&
        ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = FSlct(i%).DispColor
        ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + ACOPDefaultWidth&
            
' for some inexplicible reason the Draw method can occasionally fail (hence the new error logic!)
        FSlct(i%).ACOPPlotIndex = ArchiveForm.ACOPPlot(ActivePlot%).Draw(PlotData(0, i%).d1val, PlotData(0, i%).d2Val, , , n&, "DBLDBL", MaxPoints)
    
        FSlct(i%).RePlot = False
    Else
        FSlct(i%).RePlot = False
    End If
Next i%

' Check if automatic AUTOSCALE (for ABSOLUTE scaling) is on?
If ArchiveForm.ChkScale.Value = vbUnchecked And ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPPlot(0).AutoScale False, False, True, True
    ArchiveForm.ACOPPlot(1).AutoScale False, False, True, True
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
End If

ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 1

TmpPlots% = NPlots%(ActivePlot%)
If ActivePlot% = 1 Then TmpPlots% = TmpPlots% + CopyOffset
For i% = StartLabel% To TmpPlots% - 1
    ArchiveForm.OptX(i%).Visible = True
    ArchiveForm.OptY(i%).Visible = True
Next i%
For i% = TmpPlots% To StopLabel%
    ArchiveForm.OptX(i%).Visible = False
    ArchiveForm.OptY(i%).Visible = False
Next i%

'ArchiveForm.ACOPPlot(ActivePlot%).AutoScale True, True, False, False

If SelectedTrace%(ActivePlot%) <> -1 Then
    tmpIndex% = SelectedTrace%(ActivePlot%)
    Call SelectATrace(tmpIndex%)
End If
ArchiveForm.LabelMisc(3).Visible = False

' ALSO REFRESH CORRELATE PLOT?
If ArchiveForm.ChkDouble(2).Value = vbChecked Or ArchiveForm.ChkDouble(3).Value = vbChecked Then
    Call DrawCorr
End If

Exit Sub
PlotTheDataError:
errcnt = errcnt + 1
If errcnt < 3 Then Resume
Exit Sub
End Sub

Public Sub ScaleTheData(ChannelFlag%, DataFlag%)
Dim i%, ii&, j%, n&, StartLabel%, StopLabel%, tmpFaktor!, TmpOffset!, tmpMask&
Dim ScaleMax!, ScaleMin!, ScaleOffset!, tmpPlotRange!, tmpPlotOffset!
Dim Delta!, ZeroOffset!, InvDelta!, tmpCopyBytes&, tmpNPoints%

Dim tmpArchData() As DBLDBL
ReDim tmpArchData(MaxPoints)

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

On Error Resume Next

' How to do the scaling? 0-100, or absolute, or ACOP-YScale?
'If ScalingMode% = 0 Then

If ChannelFlag% = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).ReScale = True
        Else
            FSlct(i%).ReScale = False
        End If
    Next i%
End If

'Need to do anything? Check if RELATIVE scale....
If ArchiveForm.ChkScale.Value Then
    'Need to do the re-scaling
Else
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).ReScale = True Then
            'FSlct(i%).ReScale = False
            'FSlct(i%).RePlot = True
        Else
            ''FSlct(i%).ReScale = False
        End If
    Next i%
End If

For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).ReScale = True And FSlct(i%).NumPoints > 0 Then
        n& = FSlct(i%).NumPoints
        
        ' What is this for?
        For j% = 0 To NDisplayModes% - 1
            If UCase$(FSlct(i%).SelectedVMode) = DisplayModes$(j%) Then
                FSlct(i%).SelectedVModeIndex = DisplayModeIndexes%(j%)
                Exit For
            End If
        Next j%
                
        ' A bit of data-verarbeiting...
        ' Check if the DATA is meant to be scaled...
        tmpFaktor! = FSlct(i%).VScale
        If DataFlag% = 0 Then
            If Not (tmpFaktor! = 0 Or tmpFaktor! = 1) Then
                TmpOffset! = FSlct(i%).VOffset
                For ii& = 0 To n& - 1
                   'tmpArchData(ii&).fval = ArchData(ii&, i%).fval * tmpFaktor! + TmpOffset!
                   'tmpArchData(ii&).iVal = ArchData(ii&, i%).iVal
                   ArchData(ii&, i%).d1val = ArchData(ii&, i%).d1val * tmpFaktor! + TmpOffset!
                Next ii&
            ElseIf (FSlct(i%).VPlot = "BIT") Or (FSlct(i%).VPlot = "BITS") Then
                'FSlct(i%).VMax = 16.1
                'FSlct(i%).VMin = -0.05
                FSlct(i%).SelectedMaxValue = FSlct(i%).VMax
                FSlct(i%).SelectedMinValue = FSlct(i%).VMin
               
                ' ScaleForBits
                'tmpFaktor! = 1
                'tmpMask& = SelectBits&(FSlct(i%).DeviceSubIndex - 1)
                For ii& = 0 To n& - 1
                   'tmpArchData(ii&).fval = ScaleForBits(i%, CLng(ArchData(ii&, i%).fval)) '2 * i% + (CLng(ArchData(ii&, i%).fval) And TmpMask&) / TmpMask&
                   'tmpArchData(ii&).iVal = ArchData(ii&, i%).iVal
                   ArchData(ii&, i%).d1val = ScaleForBits(i%, CLng(ArchData(ii&, i%).d1val)) '2 * i% + (CLng(ArchData(ii&, i%).fval) And TmpMask&) / TmpMask&
                Next ii&
            ElseIf UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                ' Do this check HERE, and do it only ONCE....
                For ii& = 0 To n& - 1
                   'If ArchData(ii&, i%).fval <= 0 Then tmpArchData(ii&).fval = 0.0000001 Else tmpArchData(ii&).fval = ArchData(ii&, i%).fval
                   'tmpArchData(ii&).iVal = ArchData(ii&, i%).iVal
                   If ArchData(ii&, i%).d1val <= 0 Then ArchData(ii&, i%).d1val = 0.0000001
                Next ii&
                tmpFaktor! = 1
            'Else
            '    tmpCopyBytes& = CLng(n&) * 8
            '    Call MEMCPYL(tmpArchData(0).fval, ArchData(0, i%).fval, tmpCopyBytes&)
            End If
        'Else
        End If
        tmpCopyBytes& = CLng(n&) * 16
        Call MEMCPYL(tmpArchData(0).d1val, ArchData(0, i%).d1val, tmpCopyBytes&)

        
        FSlct(i%).PlotScale = tmpFaktor!
        
        FSlct(i%).MaxValue = -1
        FSlct(i%).MinValue = -1
                                                      
        If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
            ' Scale to the Max and Min values IN THE DATA....
            If FSlct(i%).MaxValue = -1 And FSlct(i%).MinValue = -1 Then
                ' Must find NEW max and min values
                ScaleMax! = CSng(ArchData(1, i%).d1val)
                ScaleMin! = ScaleMax!
                For ii& = 2 To n&
                    ' Only look at points being DISPLAYED!
                    If tmpArchData(ii&).d2Val > ZoomLimits#(NZooms%, 0) And tmpArchData(ii&).d2Val < ZoomLimits#(NZooms%, 1) Then
                        If tmpArchData(ii&).d1val > ScaleMax! Then
                            ScaleMax! = tmpArchData(ii&).d1val
                        ElseIf tmpArchData(ii&).d1val < ScaleMin! Then
                            ScaleMin! = tmpArchData(ii&).d1val
                        End If
                    End If
                Next ii&
                ' make sure an array of "all the same thing" goes down the middle:
                If ScaleMax! = ScaleMin! Then
                  ScaleMax! = ScaleMax! + ScaleMax! * 0.1 + 1
                  ScaleMin! = ScaleMin! - ScaleMin! * 0.1 - 1
                End If
                FSlct(i%).MaxValue = ScaleMax!
                FSlct(i%).MinValue = ScaleMin!
            End If
            ' Put them 5% away from the edge?
            ScaleMax! = FSlct(i%).MaxValue + (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
            ScaleMin! = FSlct(i%).MinValue - (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
        
            ScaleMax! = ScaleMax! * 1
            ScaleMin! = ScaleMin!
        
            ScaleOffset! = 0
        Else
            FSlct(i%).MaxValue = -1: FSlct(i%).MinValue = -1
            ScaleMax! = FSlct(i%).SelectedMaxValue
            ScaleMin! = FSlct(i%).SelectedMinValue
            ScaleOffset! = FSlct(i%).SelectedOffset
        End If
                
        FSlct(i%).PlotMaxValue = ScaleMax!
        FSlct(i%).PlotMinValue = ScaleMin!
        FSlct(i%).PlotOffset = ScaleOffset!
    
        If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
            tmpPlotRange! = ZoomLimits#(NZooms%, 3) - ZoomLimits#(NZooms%, 2)
            tmpPlotOffset! = ZoomLimits#(NZooms%, 2)
        Else
            tmpPlotRange! = 100
            tmpPlotOffset! = 0
        End If
        
        If n& <= 1 Then
            Delta! = ScaleMax! - ScaleMin!
            ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
            FSlct(i%).PlotDelta = Delta! / 100
            FSlct(i%).PlotZeroOffset = ZeroOffset!
        Else
            ' To scale the data properly....
            If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                If ScaleMin <= 0 Then ScaleMin = 0.01
                If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
                Delta! = (Log(ScaleMax!) - Log(ScaleMin!)) '/ Log(10#)
                If FSlct(i%).VMin = 0 Then FSlct(i%).VMin = 1E-20
                ZeroOffset! = Log(ScaleMin) 'Log(FSlct(i%).VMin) '/ Log(10#)
            Else
                Delta! = ScaleMax! - ScaleMin!
                ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
            End If
        
            ' Use the scale-factor in the form for the GRAPHICS!
            If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = tmpPlotRange! / Delta!
        
            ' For re-scaling
            If tmpPlotRange! = 0 Then tmpPlotRange! = 100
            FSlct(i%).PlotDelta = Delta! / tmpPlotRange!
            FSlct(i%).PlotZeroOffset = ZeroOffset!
        
            ' The number of points in the array...
            'PlotData(0, i%).iVal = ArchData(0, i%).iVal
            
            Select Case ScalingMode%
            Case AbsoluteScale:
                    tmpCopyBytes& = (n& + 1) * 16
                    Call MEMCPYL(PlotData(0, i%).d1val, tmpArchData(0).d1val, tmpCopyBytes&)
            
            Case RelativeScale:
                
                ' Plotting "mode"
                If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                    'Call ARRLOG(ydat(0, i%), ydat(0, i%), n&)
                    For ii& = 0 To n& - 1
                        PlotData(ii&, i%).d2Val = tmpArchData(ii&).d2Val
                        If tmpArchData(ii&).d1val > 0 Then
                            PlotData(ii&, i%).d1val = (Log(tmpArchData(ii&).d1val) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                            'PlotData(ii&, i%).d1val = (Log(ArchData(ii&, i%).d1val) - ZeroOffset!) * InvDelta!
                        Else
                            PlotData(ii&, i%).d1val = 0
                        End If
                    Next ii&
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "ABS" Then
                    For ii& = 0 To n& - 1
                        PlotData(ii&, i%).d2Val = tmpArchData(ii&).d2Val
                        PlotData(ii&, i%).d1val = (Abs(tmpArchData(ii&).d1val) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii&
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "SLOG" Then
                    'Call ARRMULT(CF_FLOAT, ydat(0, i%), 1 / fslct(i%).VMax, n&)
                    tmpFaktor! = 1 '/ FSlct(i%).VMax
                    For ii& = 0 To n& - 1
                        PlotData(ii&, i%).d2Val = tmpArchData(ii&).d2Val
                        If tmpArchData(ii&).d1val > 0 Then
                            ii& = ii&
                        End If
                        PlotData(ii&, i%).d1val = (tmpArchData(ii&).d1val * tmpFaktor! - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii&
                Else
                    For ii& = 0 To n& - 1
                        PlotData(ii&, i%).d2Val = tmpArchData(ii&).d2Val
                        PlotData(ii&, i%).d1val = (tmpArchData(ii&).d1val - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                        'Debug.Print ii&, PlotData(ii&, i%).ival, PlotData(ii&, i%).d1val, ArchData(ii&, i%).d1val
                    Next ii&
                End If
            End Select
        End If
    
        FSlct(i%).ReScale = False
        FSlct(i%).ReFilter = True
        FSlct(i%).RePlot = True
    Else
        ' Nothing to do?
        FSlct(i%).ReScale = False
    End If
Next i%
End Sub


Public Sub DoTheData(flag%)

'   flag=0  alle daten neu
'   flag=1  nur plotten ohne daten holen

' NEW
Call ReadTheData(flag%)

'If ArchiveMode% = CArchivers Then
'    Call ReadTheArchiveData(Flag%)
'Else
'    Call ReadTheHistoryData(Flag%)
'End If

' Throw out points?

Call FilterTheData(flag%)

'
Call ScaleTheData(flag%, 0)

'
Call PlotTheData(0) '(Flag%)

End Sub

Function getArchiveServerInfo(fname As String) As Integer
Dim i%, j%, tmpFileFlag As Boolean, rc%
   
Dim tmpContextsStr$(), tmpnContexts%
Dim tmpDevServersStr$(), tmpnDevServers%
Dim TmpPath$, TmpFileName$
Dim tmpName32(100) As NAME32, tmpNMax%, tmpName As NAME32, tmpstr$

NArchContexts = getArchiveServerFileInfo(fname)
'NArchContexts = 0

Dim tmpFlag As Boolean
tmpFlag = True
If NArchContexts = 0 Then
    ' New Method!
    ' get DIRECTLY from the ENS all the CONTEXTS which have HISTORY servers!!!!
    ' Get the list from the NAME-SERVER!
    If tmpFlag Then
        tmpNMax% = 100
        With ArchiveForm.ACOPData
            .deviceContext = "SERVICE"
            .DeviceGroup = "ENS"
            .deviceName = "#0"
            .deviceProperty = "CONTEXTS"
            Call BARR(tmpName.nam, "HISTORY")
            rc% = .Execute(tmpName32(0).nam(0), tmpNMax%, "NAME32", tmpName.nam(0), 1, "NAME32")
            If rc% <> 0 Then
                Debug.Print
                MsgBox "Error reading History Server Names from ENS! " + .status
                Return
            Else
                rc% = .GetDataSize(NArchContexts%)
                ReDim CONFIGContexts$(NArchContexts% - 1)
            End If
        End With
        NArchContexts% = 0
        For i% = 0 To tmpNMax% - 1
            tmpstr$ = Trim$(BSTR(tmpName32(i%).nam()))
            If tmpstr$ = "" Then Exit For
            
            CONFIGContexts$(NArchContexts%) = tmpstr$
            With gArchiveServerInfo(NArchContexts%)
                .context = tmpstr$
                .DataServerName = "ARCHIVER"
                .HistoryServerName = "HISTORY"
                .StateServerName = ""
            End With
            NArchContexts = NArchContexts + 1
        Next i%
    Else
        rc% = GetEquipmentDeviceContexts(tmpContextsStr$(), tmpnContexts%)
        If rc% <> 0 Then
            MsgBox "Error reading contexts from Name-Server!" + RPCERROR(rc%)
        End If
    
        If tmpnContexts% < 1 Then Exit Function
        
        ' Loop throgh, and check which have SERVERS!
        ReDim CONFIGContexts$(tmpnContexts% - 1)
        ncontexts% = 0
        For i% = 0 To tmpnContexts% - 1
            'Function GetEquipmentDeviceServers(devcontext As String, devSubSystem As String, devServers() As String, nDevServers As Integer) As Integer
            ' Search for ARCHIVER and HISTORY servers
            rc% = GetEquipmentDeviceServers(tmpContextsStr$(i%), "ALL", tmpDevServersStr$, tmpnDevServers%)
            If rc% <> 0 Then
                MsgBox "Error reading device-servers for context: " + tmpContextsStr$(i%) + RPCERROR(rc%)
            Else
                For j% = 0 To tmpnDevServers% - 1
                    If tmpDevServersStr$(j%) = "ARCHIVER" Then
                        ' This Context has an archiver!
                        CONFIGContexts$(ncontexts%) = tmpContextsStr$(i%)
                        With gArchiveServerInfo(ncontexts%)
                            .context = tmpContextsStr$(i%)
                            .DataServerName = "ARCHIVER"
                            .HistoryServerName = "HISTORY"
                            .StateServerName = ""
                        
                            'gArchiveServerInfo(nCONTEXTS%).ConfigFileName = getcol(a$, cfg_col)
                        End With
                        ncontexts% = ncontexts% + 1
                        Exit For
                    End If
                Next j%
            End If
        Next i%
        NArchContexts = ncontexts%
    End If
End If
    
' put USER files in NArchContexts +1
ReDim CONFIGFile$(ConfFiles)
ReDim CONFIGDir$(ConfFiles)
ReDim CONFIGHelp$(ConfFiles)
ReDim NElem%(ConfFiles)
'ReDim nCONFIG%
ReDim CSet(ConfFiles, 300)

getArchiveServerInfo = NArchContexts 'i%

Exit Function

FileError:
MsgBox ("Error Reading Context-File " + TmpFileName$ + ":  " + Err.Description)
Close #1

End Function

Function getUserConfigDefaultDirInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, data_col%, arc_col%, state_col%
Dim fn$

On Error GoTo ErrorRoutine

'UserConfigDir$ = "" '"H:"
UserConfigPath$ = "H:" '"\" ' Use a SUBDIRECTORY?

fn$ = App.path + "\" + fname

Open fn$ For Input Access Read Shared As #1
Line Input #1, a$ ' First Header-Line
Line Input #1, UserConfigPath$
  
Close 1
Exit Function

ErrorRoutine:

End Function

'
Function getArchiveServerFileInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, data_col%, arc_col%, state_col%
Dim fn$

fn$ = App.path + "\" + fname

NArchContexts = getDatabaseSize(fn$)
If NArchContexts = 0 Then
    getArchiveServerFileInfo = 0
    Exit Function
End If

con_col% = -1
data_col% = -1
arc_col% = -1
state_col% = -1

Open fn$ For Input Access Read Shared As #1
Line Input #1, a$ ' First Header-Line
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      con_col% = colptr(a$, "CONTEXT")
      data_col% = colptr(a$, "DATASERVER")
      arc_col% = colptr(a$, "ARCHIVER")
      state_col% = colptr(a$, "STATESERVER")
      done = True
    Else
      If con_col% > -1 Then gArchiveServerInfo(i%).context = getcol(a$, con_col%)
      If data_col% > -1 Then gArchiveServerInfo(i%).DataServerName = getcol(a$, data_col%)
      If arc_col% > -1 Then gArchiveServerInfo(i%).HistoryServerName = getcol(a$, arc_col%)
      If state_col% > -1 Then gArchiveServerInfo(i%).StateServerName = getcol(a$, state_col%)
      i% = i% + 1
      If i% >= NArchContexts Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1

' If only CONTEXT was included, then fill "defaults" in for the other columns
If data_col% = -1 Then
    For i% = 0 To NArchContexts - 1
        gArchiveServerInfo(i%).DataServerName = "ARCHIVER"
    Next i%
End If
If arc_col% = -1 Then
    For i% = 0 To NArchContexts - 1
        gArchiveServerInfo(i%).HistoryServerName = "HISTORY"
    Next i%
End If
If state_col% = -1 Then
    For i% = 0 To NArchContexts - 1
        gArchiveServerInfo(i%).StateServerName = "STATE"
    Next i%
End If

getArchiveServerFileInfo = NArchContexts
End Function

Function getKeywordNames32(server As String, Keyword As String, keywordNames() As String) As Integer
Dim rc%, i%
Dim dbout As DBLK
Dim dbin As DBLK
Dim dbinbuf(1) As Long
Dim size As Integer
Dim kwd As String
Dim bKeywordNames() As NAME32
Dim bkwd(32) As Byte
Dim prp As PropertyQuery
Dim tmpstr$
Dim tmpNameSize%

kwd = Keyword + ".NAM"

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR bkwd(), kwd
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)
If prp.prpSize = 0 Then rc = illegal_property
If rc = 0 Then
  size = prp.prpSize
  ReDim bKeywordNames(size)
  dbout.dArrayLength = size: dbout.dFormat = CF_NAME32
  'If 1 = 0 Then
  If ArchiveStart& > 0 And ArchiveStop& > 0 Then
    dbin.dArrayLength = 2: dbin.dFormat = CF_LONG
    dbinbuf(0) = ArchiveStart&: dbinbuf(1) = ArchiveStop&
    'dbinbuf(0) = ArchiveStart& - 10000: dbinbuf(1) = ArchiveStop&
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, dbinbuf(0), CA_READ, 1000)
  Else
    dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, 0, CA_READ, 1000)
  End If
  
    ' if NAM prop BIGGER than PROP!
    tmpNameSize% = UBound(keywordNames) - LBound(keywordNames) + 1
    If size > tmpNameSize% Then
        MsgBox "Property/Name size Mismatch!  Keyword: " + kwd
        size = tmpNameSize%
    End If
Else
  size = UBound(keywordNames) - LBound(keywordNames) + 1
End If

If size = 8000 Then size = 1 ' force extra archive servers to register names
For i% = 0 To size - 1
  If rc <> 0 Then
    keywordNames(i%) = "#" + Trim(STR(i%))
  Else
    tmpstr$ = BSTR(bKeywordNames(i%).nam)
    If tmpstr$ = "" Then
        Exit For
    Else
        keywordNames(i%) = tmpstr$ 'BSTR(bKeywordNames(i%).nam)
    End If
  End If
Next
getKeywordNames32 = size
End Function
Function getKeywordNames(server As String, Keyword As String, keywordNames() As String) As Integer
Dim rc%, i%
Dim dbout As DBLK
Dim dbin As DBLK
Dim dbinbuf(1) As Long
Dim size As Integer
Dim kwd As String
Dim bKeywordNames() As NAME16
Dim bkwd(32) As Byte
Dim prp As PropertyQuery
Dim tmpstr$
Dim tmpNameSize%

kwd = Keyword + ".NAM"

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR bkwd(), kwd
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)
If prp.prpSize = 0 Then rc = illegal_property
If rc = 0 Then
  size = prp.prpSize
  ReDim bKeywordNames(size)
  dbout.dArrayLength = size: dbout.dFormat = CF_NAME16
  If ArchiveStart& > 0 And ArchiveStop& > 0 Then
    dbin.dArrayLength = 2: dbin.dFormat = CF_LONG
    dbinbuf(0) = ArchiveStart&: dbinbuf(1) = ArchiveStop&
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, dbinbuf(0), CA_READ, 1000)
  Else
    dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, 0, CA_READ, 1000)
  End If
  
    ' if NAM prop BIGGER than PROP!
    tmpNameSize% = UBound(keywordNames) - LBound(keywordNames) + 1
    If size > tmpNameSize% Then
        MsgBox "Property/Name size Mismatch!  Keyword: " + kwd
        size = tmpNameSize%
    End If
Else
  size = UBound(keywordNames) - LBound(keywordNames) + 1
End If

If size = 8000 Then size = 1 ' force extra archive servers to register names
For i% = 0 To size - 1
  If rc Then
    keywordNames(i%) = "#" + Trim(STR(i%))
  Else
    tmpstr$ = BSTR(bKeywordNames(i%).nam)
    If tmpstr$ = "" Then
        Exit For
    Else
        keywordNames(i%) = tmpstr$ 'BSTR(bKeywordNames(i%).nam)
    End If
  End If
Next
getKeywordNames = size
End Function


Sub getKeywordInfo(server As String, Keyword As String, minimum As Single, maximum As Single, _
                   egu As String, plot As String, desc As String, size As Integer, dataType As String)
Dim rc%, fmt%, ptype As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim prp As PropertyQuery
Dim denom As Single
Dim bkwd(32) As Byte

If dataType <> "" Then Exit Sub ' already done
rc% = GetEquipmentExtEGU(server, Keyword, minimum, maximum, egu, ptype)
If rc% Then Exit Sub
denom = Abs(minimum)
If denom = 0 Then denom = 1
Select Case ptype
  Case 0: plot = "LIN"
  Case 1: plot = "LOG"
  Case 2: plot = "SLOG"
  Case 3: plot = "TD"
  Case 4: plot = "BITS"
  Case 5: plot = "TEXT"
  Case 6: plot = "ABS"
  Case Else: plot = "LIN"
End Select

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR bkwd(), Keyword$
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)
desc = BSTR(prp.prpDesc())
size = prp.prpSize
fmt% = prp.prpFormat + 512
Select Case fmt
 Case CF_TEXT: dataType = "NAME32": plot = "LUMI"
 Case CF_NAME32: dataType = "NAME32": plot = "LUMI"
 Case CF_NAME16: dataType = "NAME16": plot = "LUMI"
 Case CF_NAME48: dataType = "NAME48": plot = "LUMI"
 Case CF_FLOAT: dataType = "float"
 Case CF_LONG: dataType = "long"
 Case CF_SHORT: dataType = "short"
 Case CF_DOUBLE: dataType = "double"
 Case Else: dataType = "float"
End Select
End Sub

Sub getALLKeywordInfo(server As String, Keyword As String, minimum As Single, maximum As Single, _
                   egu As String, plot As String, desc As String, size As Integer, dataType As String, _
                   arrayType As Integer, xmax As Single, xmin As Single, XUnits As String)
Dim rc%, fmt%, ptype As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim XPrp As XPropertyQuery
Dim denom As Single
Dim bkwd(32) As Byte
Dim tmpMax%
If dataType <> "" Then Exit Sub ' already done
rc% = GetEquipmentExtEGU(server, Keyword, minimum, maximum, egu, ptype)
If rc% Then Exit Sub
denom = Abs(minimum)
If denom = 0 Then denom = 1
Select Case ptype
  Case 0: plot = "LIN"
  Case 1: plot = "LOG"
  Case 2: plot = "SLOG"
  Case 3: plot = "TD"
  Case 4: plot = "BITS"
  Case 5: plot = "TEXT"
  Case 6: plot = "ABS"
  Case Else: plot = "LIN"
End Select

' GetFullPropertyInformation(devName As String, property As String, prp As XPropertyQuery)
Call GetFullPropertyInformation(server, Keyword, XPrp)

'dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
'BARR bkwd(), keyword$
'dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
'rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)

With XPrp
    desc = BSTR(.prpDesc())
    tmpMax% = 30000
    If .prpSize < tmpMax% Then
        size = .prpSize
    Else
        size = tmpMax%
    End If
    ' IF an array, a SPECTRUM or a SCALAR...
    arrayType = .prpArrayType
    
    ' X-AXIS!
    xmax = .rangeMaxValue
    xmin = .rangeMinValue
        
    XUnits = .rangeUnits
    
    fmt% = .prpFormat + 512
End With

Select Case fmt
 Case CF_TEXT: dataType = "NAME32": plot = "LUMI"
 Case CF_NAME32: dataType = "NAME32": plot = "LUMI"
 Case CF_NAME16: dataType = "NAME16": plot = "LUMI"
 Case CF_NAME48: dataType = "NAME48": plot = "LUMI"
 Case CF_NAME64: dataType = "NAME64": plot = "LUMI"
 Case CF_FLOAT: dataType = "float"
 Case CF_LONG: dataType = "long"
 Case CF_SHORT: dataType = "short"
 Case CF_DOUBLE: dataType = "double"
 Case Else: dataType = "float"
End Select
End Sub

Sub DrawCaption()
Dim i%, nm$, tmpIndex%, idx%, tmpText$, TmpDNameIndex%

'ArchiveForm.FrameMisc(0).Visible = True
'ArchiveForm.FrameMisc(1).Visible = False

' Clear everything first....
'For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
'    ArchiveForm.dunit(i%).Caption = ""
'    ArchiveForm.dnam(i%).Caption = ""
'    ArchiveForm.dhelp(i%).Caption = ""
'    ArchiveForm.dlab(i%).Caption = ""
'    'ArchiveForm.dNow(i%).Caption = ""
'    ArchiveForm.dhelp(i%).ToolTipText = ""
'
'    'ArchiveForm.dhelp(i%).AutoSize = False
'    'ArchiveForm.dhelp(i%).WordWrap = False
'Next i%

'If SelectedTrace%(ActivePlot%) <> -1 Then
'    TmpDNameIndex% = IndexToDName%(SelectedTrace%(ActivePlot%))
'    'ArchiveForm.dhelp(TmpDNameIndex%).AutoSize = True
'ElseIf SelectedPlotArrayTrace% <> -1 Then
'    TmpDNameIndex% = SelectedPlotArrayTrace%
'End If
'SelectedPlotArrayTrace%

For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    With FSlct(i%)
        tmpIndex% = IndexToDName%(i%)
        If .Active = True Then
            ArchiveForm.dlab(tmpIndex%).ForeColor = .DispColor
            ArchiveForm.dunit(tmpIndex%).ForeColor = .DispColor
            'ArchiveForm.dNow(tmpIndex%).ForeColor = FSlct(i%).DispColor
          
            nm$ = .PropName
            If nm$ = "H1LUMI" Then
                If .DeviceIndex = 5 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "E+31"
                ElseIf .DeviceIndex = 6 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "E+30"
                ElseIf .DeviceIndex = 3 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "kHz"
                End If
            Else
                ArchiveForm.dunit(tmpIndex%).Caption = .VUnit
            End If
            idx% = .PListIndex
            If .PropSize > 1 Then
                If (UCase$(.VPlot) = "TD") Then 'Or (UCase$(.VPlot) = "T.D.") Then
                    'If NNamesX1& > -1 Then
                    '    nm$ = nm$ + "[" + NamesX1$(.DeviceIndex) + "]"
                    '    nm$ = nm$ + "(" + NamesX2$(.DeviceSubIndex) + ")" ' why was there a .DeviceSubIndex-1 ?
                    'Else
                        nm$ = nm$ + "[" + format$(.DeviceIndex, "###0") + "]"
                        nm$ = nm$ + "(" + format$(.DeviceSubIndex, "###0") + ")"
                    'End If
                Else
                    nm$ = nm$ + "[" + format$(.DeviceIndex, "###0") + "]"
                    
                    If (UCase$(.VPlot) = "BIT") Or (UCase$(.VPlot) = "BITS") Then
                        nm$ = nm$ + "(" + format$(.DeviceSubIndex - 1, "###0") + ")"
                    ElseIf ArchiveForm.ChkArrayIndex.Value = vbChecked Then
                        nm$ = nm$ + "(" + format$(.DeviceSubIndex, "###0") + ")"
                    End If
                End If
            End If
            
            ArchiveForm.dnam(tmpIndex%).ForeColor = .DispColor
            ArchiveForm.dnam(tmpIndex%).Caption = nm$
            
            ArchiveForm.dhelp(tmpIndex%).ForeColor = .DispColor
            tmpText$ = .PropDesc
            If .NPropDevices > 1 Then
                If (UCase$(.VPlot) = "TD") Then 'Or (UCase$(.VPlot) = "T.D.") Then
                    If NNamesX1& > -1 Then
                        tmpText$ = tmpText$ + "[" + NamesX1$(.DeviceIndex) + "]"
                        tmpText$ = tmpText$ + "(" + NamesX2$(.DeviceSubIndex) + ")" ' why was there a .DeviceSubIndex-1 ?
                    Else
                        tmpText$ = tmpText$ + "[" + format$(.DeviceIndex, "###0") + "]"
                        tmpText$ = tmpText$ + "(" + format$(.DeviceSubIndex, "###0") + ")"
                    End If
                ElseIf .deviceName = "" Then
                    tmpText$ = tmpText$ + " [" + format(.DeviceIndex, "0") + "]"
                Else
                    If InStr(1, .deviceName, "#") <> 0 Then
                        tmpText$ = tmpText$ + " [" + Trim(STR$(.DeviceIndex)) + "]"
                    Else
                        tmpText$ = tmpText$ + " [" + .deviceName + "]"
                    End If
                End If
            Else
                tmpText$ = .PropDesc
            End If
            If .VPlot = "BIT" Then
                tmpText$ = tmpText$ + " (Bit" + STR$(.DeviceSubIndex - 1) + ")"
            ElseIf ArchiveForm.ChkArrayIndex.Value = vbChecked Then
                tmpText$ = tmpText$ + "(#" + format$(.DeviceSubIndex, "0") + ")"
            End If
            
            If ArchiveForm.dhelp(tmpIndex%).Caption <> tmpText$ Then
                ArchiveForm.dhelp(tmpIndex%).Caption = tmpText$
            End If
            
            'ArchiveForm.dhelp(tmpIndex%).Caption = tmpText$
            ArchiveForm.dhelp(tmpIndex%).ToolTipText = tmpText$
        
        Else
'            ArchiveForm.dunit(tmpIndex%).Caption = ""
'            ArchiveForm.dnam(tmpIndex%).Caption = ""
'            ArchiveForm.dhelp(tmpIndex%).Caption = ""
'            ArchiveForm.dlab(tmpIndex%).Caption = ""
'            'ArchiveForm.dNow(tmpIndex%).Caption = ""
'            ArchiveForm.dhelp(tmpIndex%).ToolTipText = ""
        End If
     End With
Next i%

End Sub

Function filterArchiveData(d As Long) As Integer
Dim i%, j%
Dim iStart As Integer, iStop As Integer
Dim latched As Boolean
Dim foundCnt As Integer

If nFilterKeywords = 0 Then
  filterArchiveData = 0
  Exit Function
End If
For j% = 0 To nFilterKeywords - 1
  If foundCnt < j% Then Exit For
  If filterKeywords(j%).fmt = "NAME32" Then
  ' latch timestamp
    If filterDataBufferNPoints&(j%) = 0 Then
      filterArchiveData = 0
      Exit Function
    End If
    iStart = 0: iStop = filterDataBufferNPoints&(j%) - 1
    While Not ((latched) Or (iStop = iStart) Or (iStop = iStart + 1))
      i% = iStart + ((iStop - iStart) / 2)
      If filterTextBuffer(i%, j%).iVal < d Then
        iStart = i%
      ElseIf filterTextBuffer(i%, j%).iVal > d Then
        iStop = i%
      ElseIf filterTextBuffer(i%, j%).iVal = d Then
        latched = True
      End If
    Wend
    If UCase(filterKeywords(j%).plot) = UCase(BSTR(filterTextBuffer(i%, j%).nam)) Then
      foundCnt = foundCnt + 1
'      filterArchiveData = 1
'      Exit Function
    End If
  Else
  ' latch timestamp
    If filterDataBufferNPoints&(j%) = 0 Then
      filterArchiveData = 0
      Exit Function
    End If
    iStart = 0: iStop = filterDataBufferNPoints&(j%) - 1
    While Not ((latched) Or (iStop = iStart) Or (iStop = iStart + 1))
      i% = iStart + ((iStop - iStart) / 2)
      If filterDataBuffer(i%, j%).iVal < d Then
        iStart = i%
      ElseIf filterDataBuffer(i%, j%).iVal > d Then
        iStop = i%
      ElseIf filterDataBuffer(i%, j%).iVal = d Then
        latched = True
      End If
    Wend
    If filterDataBuffer(i%, j%).fval >= filterKeywords(j%).min And _
       filterDataBuffer(i%, j%).fval <= filterKeywords(j%).max Then
      foundCnt = foundCnt + 1
'      filterArchiveData = 1
'      Exit Function
    End If
  End If
Next
If foundCnt = nFilterKeywords Then filterArchiveData = 1 Else filterArchiveData = 0
End Function

Sub Main()
ArchiveForm.Show
End Sub
Sub DrawCorr()
Dim n%, ii&, n2%, rc%, rcc&
Dim TmpTextX$, TmpTextY$
Dim tmpIndex%

On Error Resume Next

tmpIndex% = ActivePlot%

'TmpTextX$ = ArchiveForm.LinLog(xIndex)
'TmpTextY$ = ArchiveForm.LinLog(yIndex)
If TmpTextX$ = "LOG" And TmpTextY$ = "LIN" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LOG_LIN
ElseIf TmpTextY$ = "LIN" And TmpTextY$ = "LOG" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LIN_LOG
Else 'If TmpTextY$ = "LIN" And TmpTextY$ = "LIN" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LIN_LIN
End If
 
OptXIndex% = DNameToIndex%(xIndex)
n% = FSlct(OptXIndex%).NumPoints
If n% > 1 Then
    For ii& = 0 To n% - 1
        ydat0!(ii&) = CSng(ArchData(ii&, OptXIndex%).d1val)
        'Debug.Print ArchData(ii% + 1, OptXIndex%).d1val
        
        'ydat0!(ii%) = 0
        ' What about these 10^30? - CAN'T USE BECAUSE OF LUMI!!!
        'If ydat0!(ii%) > 10000000000# Then ydat0!(ii%) = 0
         
         'ydat1(ii%) = ArchData(ii% + 1, TmpXSelect%).d1val
         'xdat0(ii%) = xdat(ii%, TmpXSelect%)
         xdat0&(ii&) = CLng(ArchData(ii&, OptXIndex%).d2Val)
    Next ii&
End If
       
OptYIndex% = DNameToIndex%(yIndex)
n2% = FSlct(OptYIndex%).NumPoints
If n2% > 1 Then
    For ii& = 0 To n2% - 1
        ydat1!(ii&) = CSng(ArchData(ii&, OptYIndex%).d1val)
        
         ' What about these 10^30? - CAN'T USE BECAUSE OF LUMI!!!
         'If ydat1!(ii%) > 10000000000# Then ydat1!(ii%) = 0
        
        'ydat2(ii%) = ArchData(ii% + 1, TmpYSelect%).d1val
        'xdat0(ii%) = xdat(ii%, TmpYSelect%)
        xdat1&(ii&) = CLng(ArchData(ii&, OptYIndex%).d2Val)
    Next ii&

    rc% = INTERP(ydat1!(0), xdat1&(0), n2%, xdat0&(0), n%)
End If

'For ii% = 0 To 1 'n2% - 1
'    Debug.Print ydat1!(ii%)
'Next ii%

' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
'rc% = INTERP(TmpYData!(1), TmpXData0&(1), PEne(0).ival, TmpXData1&(1), CMFLBunch(0, 2).ival)

If ArchiveForm.ChkChubby.Value = vbChecked Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).DrawWidth = 5
    'ArchiveForm.ACOPCorrelate(tmpIndex%).XExtent = 4
    'ArchiveForm.ACOPCorrelate(tmpIndex%).DisplayMode = Dots
Else
    ArchiveForm.ACOPCorrelate(tmpIndex%).DrawWidth = 1
End If
ArchiveForm.ACOPCorrelate(tmpIndex%).ClearScreen
ArchiveForm.ACOPCorrelate(tmpIndex%).ForeColor = BLACK 'FSlct(TmpYSelect%).DispColor
rcc& = ArchiveForm.ACOPCorrelate(tmpIndex%).Draw(ydat1, ydat0, , , n%)

If ArchiveForm.ChkAuto(0).Value = vbChecked Or ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).AutoScale True, True, True, True
Else
    ArchiveForm.ACOPCorrelate(tmpIndex%).AutoScale False, False, False, False
    ArchiveForm.ACOPCorrelate(tmpIndex%).xmax = FSlct(OptXIndex%).PlotMaxValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).xmin = FSlct(OptXIndex%).PlotMinValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).ymax = FSlct(OptYIndex%).PlotMaxValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).ymin = FSlct(OptYIndex%).PlotMinValue
End If

ArchiveForm.ACOPCorrelate(tmpIndex%).XAxisLabel = ArchiveForm.dnam(xIndex) + "  (" + FSlct(OptXIndex%).VUnit + ") "
ArchiveForm.ACOPCorrelate(tmpIndex%).YAxisLabel = ArchiveForm.dnam(yIndex) + "  (" + FSlct(OptYIndex%).VUnit + ") "
    
End Sub

Sub INTERP1(X() As Long, Y() As Single, n As Integer, _
    xr() As Long, yr() As Single, M As Integer)
    
    'calculates (interpolates) yr based on x,y at xr

Dim i1 As Integer
Dim i As Integer
Dim j As Integer
Dim a As Double
Dim b As Double
Dim denom As Single

'Debug.Print n, M
For j = 0 To M - 1
    i1 = n
    For i = 0 To n - 1
        If X(i) > xr(j) Then
            i1 = i
            Exit For
        End If
    Next i
    
    If i1 = 0 Then i1 = 1
    If i1 = n Then i1 = n - 1
    
    denom = (X(i1) - X(i1 - 1))
    If denom = 0 Then denom = 0.001
    b = (Y(i1) - Y(i1 - 1)) / denom
    a = Y(i1) - b * X(i1)
 '   Debug.Print a, b, i1
    yr(j) = a + b * xr(j)

Next j

End Sub

Public Sub RemoveTrace(tmpIndex As Integer)
Dim i%, TmpPosition%, tmpCount%, StartLabel%, StopLabel%

' -10: delete EVERYTHING

'Index is the fslct array index...
If tmpIndex = -1 Then Exit Sub
If NPlots%(ActivePlot%) <= 0 Then Exit Sub

SelectedPlotArrayTrace% = -1
If ArchiveForm.ChkDouble(4).Value = vbChecked Then
    ArchiveForm.ACOPPlot(2).ClearScreen
End If

StartLabel% = ActivePlot% * CopyOffset
StopLabel% = ActivePlot% * CopyOffset + MaxPlots - 1
For i% = StartLabel% To StopLabel%
    ArchiveForm.dnam(i%).BorderStyle = 0
Next i%

If tmpIndex% = -10 Then
    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen

    For i% = StartLabel% To StopLabel%
        FSlct(i%).Active = False
    Next i%
    'For i% = 0 To MaxPlots - 1
    '    FSlct(i%).ACOPPlotIndex = -1
    'Next i%
Else
    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, FSlct(tmpIndex).ACOPPlotIndex
    If SelectedTrace%(ActivePlot%) > -1 Then ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, SelectedTracePlotIndex&(ActivePlot%)
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen FSlct(tmpIndex).ACOPPlotIndex, 0

    FSlct(tmpIndex).Active = False
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
    FSlct(tmpIndex).ACOPPlotIndex = -1

    For i% = 0 To MaxPlots - 1
        If FSlct(i%).Active Then ArchiveForm.ACOPPlot(ActivePlot%).RecallScreen FSlct(i%).ACOPPlotIndex
    Next i%
End If


' Can ONLY REMOVE SELECTED TRACE!!!
SelectedTrace%(ActivePlot%) = -1

'' Be sure array-plot is not elected?
'ArchiveForm.ChkDouble(4).Value = 0

StartUp% = 1
' Correlation-Plot Stuff
If tmpIndex% = -10 Then
    For i% = StartLabel% To StopLabel%
        'FSlct(i%).Active = False
        ArchiveForm.OptX(i%).Value = False
        ArchiveForm.OptY(i%).Value = False
    Next i%
    ArchiveForm.ACOPCorrelate(0).ClearScreen
    ArchiveForm.ACOPCorrelate(0).XAxisLabel = ""
    ArchiveForm.ACOPCorrelate(0).YAxisLabel = ""
Else
    ' Change the pointers for all captions AFTER the one removed...
    TmpPosition% = IndexToDName%(tmpIndex)
    If ArchiveForm.OptX(TmpPosition%).Value = True Then
        ArchiveForm.OptX(TmpPosition%).Value = False
        ArchiveForm.ACOPCorrelate(0).XAxisLabel = ""
        ArchiveForm.ACOPCorrelate(0).ClearScreen
    End If
    If ArchiveForm.OptY(TmpPosition%).Value = True Then
        ArchiveForm.OptY(TmpPosition%).Value = False
        ArchiveForm.ACOPCorrelate(0).YAxisLabel = ""
        ArchiveForm.ACOPCorrelate(0).ClearScreen
    End If
    
    For i% = StartLabel% To StopLabel%
        If (FSlct(i%).Active = True) Then
            If IndexToDName%(i%) > TmpPosition% Then
                ' For this index, the previous DName-Label
                IndexToDName%(i%) = IndexToDName%(i%) - 1
                ' For this DName-Label, this index...
                DNameToIndex%(IndexToDName%(i%)) = i%
            End If
        
            If IndexToDName%(i%) >= TmpPosition% Then
                tmpIndex% = IndexToDName%(i%)
                ArchiveForm.dlab(tmpIndex%).Caption = ArchiveForm.dlab(tmpIndex% + 1).Caption
            End If
        
        Else
'            ArchiveForm.dunit(i%).Caption = ""
'            ArchiveForm.dnam(i%).Caption = ""
'            ArchiveForm.dhelp(i%).Caption = ""
'            ArchiveForm.dlab(i%).Caption = ""
'            ArchiveForm.dNow(i%).Caption = ""
'            ArchiveForm.dhelp(i%).ToolTipText = ""
        End If
    Next i%
End If

If tmpIndex% = -10 Then
    NPlots%(ActivePlot%) = 0
Else
    NPlots%(ActivePlot%) = NPlots%(ActivePlot%) - 1
End If
tmpCount% = NPlots%(ActivePlot%)
If ActivePlot% = 1 Then tmpCount% = tmpCount% + CopyOffset

If tmpIndex% <> -10 Then
    ' Move the TEXT up....
    For i% = TmpPosition% To tmpCount% - 1
        'ArchiveForm.Text1(i%).text = ArchiveForm.Text1(i% + 1).text
        
        ArchiveForm.OptX(i%).Value = ArchiveForm.OptX(i% + 1).Value
        ArchiveForm.OptY(i%).Value = ArchiveForm.OptY(i% + 1).Value
        'ArchiveForm.dlab(i%).Width = ArchiveForm.dlab(i% + 1).Width ' WHY WIDTH?
        ArchiveForm.dlab(i%).Caption = ArchiveForm.dlab(i% + 1).Caption
    Next i%
    For i% = tmpCount% To StopLabel%
        'ArchiveForm.Text1(i%).text = ""
        ArchiveForm.OptX(i%).Visible = False
        ArchiveForm.OptY(i%).Visible = False
        DNameToIndex%(i%) = -1
    
    
        ArchiveForm.dunit(i%).Caption = ""
        ArchiveForm.dnam(i%).Caption = ""
        ArchiveForm.dhelp(i%).Caption = ""
        ArchiveForm.dlab(i%).Caption = ""
        ArchiveForm.dNow(i%).Caption = ""
        ArchiveForm.dhelp(i%).ToolTipText = ""
    Next i%
Else
    ' CLEAR the text
    For i% = tmpCount% To StopLabel%
        'ArchiveForm.Text1(i%).text = ""
        ArchiveForm.OptX(i%).Visible = False
        ArchiveForm.OptY(i%).Visible = False
        DNameToIndex%(i%) = -1
    
        ArchiveForm.dunit(i%).Caption = ""
        ArchiveForm.dnam(i%).Caption = ""
        ArchiveForm.dhelp(i%).Caption = ""
        ArchiveForm.dlab(i%).Caption = ""
        ArchiveForm.dNow(i%).Caption = ""
        ArchiveForm.dhelp(i%).ToolTipText = ""
    Next i%
End If



' And disable all the buttons and stuff...
For i% = 0 To 3
    ArchiveForm.ComSelect(i%).Enabled = False
Next i%

ArchiveForm.ChkAuto(1).Enabled = False
'ArchiveForm.ChkDouble(4).Visible = False

StartUp% = 0

' "Absolute" Scale: need to re-draw.
Call PlotTheData(0)
'Call DrawCaption

DoEvents

Exit Sub


'
'
'
'For i% = Index% To NPlots% - 2 Step 1
'  fslct(i%).PropName = fslct(i% + 1).PropName
'
'  fslct(i%).fecNo = fslct(i% + 1).fecNo
'  fslct(i%).pNo = fslct(i% + 1).pNo
'  fslct(i%).DeviceIndex = fslct(i% + 1).DeviceIndex
'  fslct(i%).PListIndex = fslct(i% + 1).PListIndex
'  fslct(i%).helpText = fslct(i% + 1).helpText
'
'  fslct(i%).VMax = fslct(i% + 1).VMax
'  fslct(i%).VMin = fslct(i% + 1).VMin
'  fslct(i%).VScale = fslct(i% + 1).VScale
'  fslct(i%).VUnit = fslct(i% + 1).VUnit
'  fslct(i%).VPlot = fslct(i% + 1).VPlot
'  fslct(i%).npoints = fslct(i% + 1).npoints
'  fslct(i%).DrawWidth = fslct(i% + 1).DrawWidth
'  ArchiveForm.Faktor(i%).text = ArchiveForm.Faktor(i% + 1).text
'
'  n% = fslct(i%).npoints%
'
'    If n% > 1 Then
'        For ii% = 0 To n% - 1
'           'ltim(ii%, i%) = ltim(ii%, i% + 1)
'           'fdat(ii%, i%) = fdat(ii%, i% + 1)
'            ArchData(ii%, i%).d1val = ArchData(ii%, i% + 1).d1val
'            ArchData(ii%, i%).ival = ArchData(ii%, i% + 1).ival
'        Next ii%
'    End If
'Next
'
'NPlots% = NPlots% - 1

End Sub

Public Sub SelectATrace(dataIndex%)
Dim i%, TmpDNameIndex%, tmpIndex%, TmpTxtMin$, TmpTxtMax$, TmpTxtOffset$, tmpText$
Dim tmpNPoints&

On Error Resume Next

If dataIndex% = -1 Then
    Exit Sub
End If

' need to do this here?
ArrayPlotIndex& = -1

' May need to replotted (with dots...)
If (SelectedTrace%(ActivePlot%) <> -1) Then
    ArchiveForm.dnam(IndexToDName%(SelectedTrace%(ActivePlot%))).BorderStyle = 0
    
    If FSlct(SelectedTrace%(ActivePlot%)).NumPoints > 1 Then
'LOCK        ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, SelectedTracePlotIndex&(ActivePlot%)
        ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen SelectedTracePlotIndex&(ActivePlot%)
    End If

'    If (ArchiveForm.ChkDouble(4).Value = 1) And (FSlct(SelectedTrace%(ActivePlot%)).PropSize = 1) Then
'        ' Array mode has been selected... MUST DE-SELECT....
'        ArchiveForm.ChkDouble(4).Value = 0
'    End If
End If

SelectedTrace%(ActivePlot%) = dataIndex%
SelectedPlotArrayTrace% = dataIndex%

TmpDNameIndex% = IndexToDName%(dataIndex)
ArchiveForm.dnam(TmpDNameIndex%).BorderStyle = 1
'ArchiveForm.dhelp(TmpDNameIndex%).AutoSize = False
'ArchiveForm.dhelp(TmpDNameIndex%).WordWrap = False

'ArchiveForm.dhelp(TmpDNameIndex%).ZOrder 0

'For i% = 0 To 6
'    ArchiveForm.dhelp(i%).ZOrder 1
'Next i%
'ArchiveForm.dhelp(TmpDNameIndex%).ZOrder 0

For i% = 0 To 2
    ArchiveForm.TxtSelect(i%).Enabled = True
    ArchiveForm.TxtSelect(i%).BackColor = &HE0E0E0
Next i%

tmpIndex% = SelectedTrace%(ActivePlot%)

ArchiveForm.FrameSelect.Caption = "Selected Trace: #" + format$(tmpIndex%, "0")

With FSlct(tmpIndex%)
    StartUp% = 1
    If .PlotAutoScale Then ArchiveForm.ChkAuto(1).Value = vbChecked Else ArchiveForm.ChkAuto(1).Value = vbUnchecked
    
    ArchiveForm.ComboSelect(0).Enabled = True
    
    ' Log or Linear?
    'ArchiveForm.ComboSelect.text = FSlct(tmpIndex%).SelectedVMode
    ArchiveForm.ComboSelect(0).ListIndex = .SelectedVModeIndex
    StartUp% = 0
    
    If .PlotMinValue = 0 Then
        TmpTxtMin$ = format(.PlotMinValue, "0.0") '"0.0"
    ElseIf Abs(.PlotMinValue) < 0.01 Or Abs(.PlotMinValue) > 1000 Then
        TmpTxtMin$ = format(.PlotMinValue, "scientific")
    Else
        TmpTxtMin$ = format(.PlotMinValue, "###0.00##") '"standard")
    End If
    
    If .PlotMaxValue = 0 Then
        TmpTxtMax$ = format(.PlotMaxValue, "0.0") '"0.0"
    ElseIf Abs(.PlotMaxValue) < 0.01 Or Abs(.PlotMaxValue) > 1000 Then
        TmpTxtMax$ = format(.PlotMaxValue, "scientific")
    Else
        TmpTxtMax$ = format(.PlotMaxValue, "###0.00##") '"standard")
    End If
    
    If .PlotOffset = 0 Then
        TmpTxtOffset$ = format(.PlotOffset, "0.0") '"0.0"
    ElseIf Abs(.PlotOffset) < 0.01 Or Abs(.PlotOffset) > 1000 Then
        TmpTxtOffset$ = format(.PlotOffset, "scientific")
    Else
        TmpTxtOffset$ = format(.PlotOffset, "###0.00##") '"standard")
    End If
    
    
    If .TotalPoints > 1000000# Then
        tmpText$ = format$(.NumPoints, "0") + "/" + format$(.TotalPoints, "0")
    Else
        tmpText$ = format$(.NumPoints, "0") + " / " + format$(.TotalPoints, "0")
    End If
    ArchiveForm.LabelPoints(0).Caption = tmpText$
    ArchiveForm.LabelPoints(3).Caption = format$(.NumPoints, "0")
    ArchiveForm.LabelMisc(2).Visible = True
    
    tmpText$ = "L.Hist: " + format$(.TotalLHPoints, "0")
    ArchiveForm.LabelPoints(1).Caption = tmpText$
    tmpText$ = "C.Arch: " + format$(.TotalArchPoints, "0")
    ArchiveForm.LabelPoints(2).Caption = tmpText$
    
    StartUp% = 1
    ArchiveForm.TxtSelect(0).text = TmpTxtMin$ ' Min
    ArchiveForm.TxtSelect(1).text = TmpTxtMax$ ' Max
    ArchiveForm.TxtSelect(2).text = TmpTxtOffset$ ' Offset
    StartUp% = 0
    
    If FSlct(SelectedTrace%(ActivePlot%)).NumPoints > 1 Then
        ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = FSlct(dataIndex%).DispColor
        ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 3 * ChubbyFactor! / 2 + 2
        ' Use the selected type:
        If ACOPDefaultMode& = Dots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = PolyLine
        Else
            ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = Dots
        End If
        
        If ACOPDefaultMode& = Dots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 1 + ACOPDefaultWidth&
        ElseIf ACOPDefaultMode& = PolyLineDots Or ACOPDefaultMode& = BarLineDots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 5 + ACOPDefaultWidth&
        Else
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 3 + ACOPDefaultWidth&
        End If
        tmpNPoints& = FSlct(SelectedTrace%(ActivePlot%)).NumPoints
        SelectedTracePlotIndex&(ActivePlot%) = ArchiveForm.ACOPPlot(ActivePlot%).Draw(PlotData(0, dataIndex%).d1val, PlotData(0, dataIndex%).d2Val, , , tmpNPoints&, "DBLDBL")
    'LOCK    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 1, SelectedTracePlotIndex&(ActivePlot%)
    End If
    
    'For i% = 0 To 3
    '    ArchiveForm.ComSelect(i%).Enabled = False
    'Next i%
    If ScalingMode% = RelativeScale Then
        ArchiveForm.ChkAuto(1).Visible = True
    Else
        ArchiveForm.ChkAuto(1).Visible = False
    End If
    
    ArchiveForm.ChkAuto(1).Enabled = True
    
    ' Need to allow array plotting?
    
    If FSlct(SelectedTrace%(ActivePlot%)).PropSize > 1 Then
        ' should this check-box be displayed?
        If ArchiveForm.MExtraDisplay.Checked = True Then
        'If ArchiveForm.ChkDouble(1).Visible = True Then
            ArchiveForm.TxtSelect(2).Visible = False
            ArchiveForm.LabelSelect(2).Visible = False
        Else
        End If
                
        'ArchiveForm.ChkDouble(4).Visible = True
        
        ' is there already a TS selected?
        KinoFrames% = FSlct(SelectedTrace%(ActivePlot%)).NumPoints
        KinoIndex% = 0
        If ArchiveTS# > 0 Then
            For i% = 2 To KinoFrames%
                If ArchiveTS# < ArchData(i%, SelectedTrace%(ActivePlot%)).d2Val Then
                    KinoIndex% = i%
                    Exit For
                End If
            Next i%
        End If
        If KinoIndex% = 0 Then KinoIndex% = KinoFrames% / 2
        
        ArchiveTS# = ArchData(KinoIndex%, SelectedTrace%(ActivePlot%)).d2Val
        'KinoIndex% = 1
        ArchiveForm.TextTS.text = STR$(KinoIndex%)
        
        StartingUp = True
        ArchiveForm.HScrollTS.max = KinoFrames%
        StartingUp = False
    
        If ArchiveForm.ChkDouble(4).Value = 1 Then Call DoTheArrayData
    Else
        'ArchiveForm.ChkDouble(4).Visible = False
    End If
    
    If .SampleRasterFlag = False Then
        ArchiveForm.LabelPoints(4).Visible = False
    Else
        ArchiveForm.LabelPoints(4).Visible = True
        tmpText$ = "Sample Raster:  " + format$(.SampleRaster, "0")
        ArchiveForm.LabelPoints(4).Caption = tmpText$
    End If
End With

End Sub


Public Sub GetHTCStuff(CurrIndex%)
                    
Dim TmpStartStop&(3), TmpBunches%(220), tmpI%, NBunchPoints%(9)
Dim i%, n%, ii%, rcc&, TmpNBunches%, BIndex%(10), BtoDataIndex%(220), HTC_Index%
Dim BTS&, BTSIndex%, Bunch%, BDataIndex%, tmpNPoints%
Dim TmpHTCIndex%(), BunchData() As FLTINT

ReDim TmpHTCIndex%(MaxPoints - 1)
ReDim BunchData(MaxPoints, 9)

TmpStartStop&(0) = ArchiveStart&
TmpStartStop&(1) = ArchiveStop&
                    
' Find out which data has the HTC-Bunch number....
' (Don't bother to AUTOMATICALLY load it....)
HTC_Index% = -1
For i% = 0 To MaxCurves - 1
    If FSlct(i%).PropName = "HE_HTC_BUNCH" Then
        HTC_Index% = i%
        Exit For
    End If
Next i%
If HTC_Index% = -1 Then
    MsgBox "HTC-Bunch Not Found!"
    FSlct(CurrIndex%).NumPoints = 0
    Exit Sub
End If
'Debug.Print " HE_HTC_BUNCH Index: ", HTC_Index%

' Loop through the data from the "HE_HTC_BUNCH" property, and find
' out WHICH BUNCHES WERE USED....
tmpNPoints% = FSlct(CurrIndex%).NumPoints
If tmpNPoints% = 0 Then
    TmpNBunches% = 0
Else
    Erase TmpBunches%
    For i% = 0 To tmpNPoints% - 1
        ' Because the -1 gets read-back as 65535....
        If (ArchData(i%, HTC_Index%).d1val < 0) Or (ArchData(i%, HTC_Index%).d1val > 219) Then
            ' A bug? have gotten 65535 as bunch number....
            Debug.Print " Hit-Bunch: ", ArchData(i%, HTC_Index%).d1val
            'ArchData(i%, HTC_Index%).d1val = 0
            TmpHTCIndex%(i%) = 0
        Else
            tmpI% = CInt(ArchData(i%, HTC_Index%).d1val) - 1
            TmpBunches%(tmpI%) = TmpBunches%(tmpI%) + 1
            TmpHTCIndex%(i%) = tmpI%
        End If
        'If Not (TmpI% < 0 Or TmpI% > 219) Then TmpBunches%(TmpI%) = TmpBunches%(TmpI%) + 1
        'Debug.Print " HE_HTC_BUNCH Search ", TmpI%
    Next i%

    tmpI% = 0
    ' Get the data for ALL BUNCHES which have been "selected"....
    ArchiveForm.ACOPData.deviceProperty = FSlct(CurrIndex%).PropName
    For i% = 0 To 219
        If TmpBunches%(i%) > 0 Then
            BIndex%(tmpI%) = i%
            TmpStartStop&(2) = i%
            rcc& = ArchiveForm.ACOPData.Execute(BunchData(0, tmpI%).fval, MaxPoints, "FLTINT", TmpStartStop)
            ArchiveForm.ACOPData.GetDataSize NBunchPoints%(tmpI%)
            
            BtoDataIndex%(i%) = tmpI%
            ' Check if enough data....
            tmpI% = tmpI% + 1
            If tmpI% > 9 Then
                MsgBox " Only 10 Bunch-Currents collected!"
                Exit For
            End If
        Else
            BtoDataIndex%(i%) = -1
        End If
    Next i%
    If tmpI% = 0 Then
        ' No useful data in the array?
        TmpNBunches% = 0
    Else
        TmpNBunches% = tmpI%
    End If
End If

' How many bunches were used for the HTC?
If TmpNBunches% = 0 Then
    ' No Bunches found? Just get the data for Bunch-0 and return....
    ArchiveForm.ACOPData.deviceProperty = FSlct(CurrIndex%).PropName
    TmpStartStop&(2) = 0
    rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, CurrIndex%).d1val, MaxPoints, "DBLDBL", TmpStartStop)
    ArchiveForm.ACOPData.GetDataSize tmpNPoints%
    FSlct(CurrIndex%).NumPoints = tmpNPoints%
    Exit Sub
End If

' Transfer all the Bunch Data into ONE array....

FSlct(CurrIndex%).NumPoints = NBunchPoints%(tmpI%) 'BunchData(0, 0).iVal

' Get the right starting conditions....
BTSIndex% = 1
'Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).fval) - 1
'If (Bunch% < 0 Or Bunch% > 219) Then Bunch% = 0
Bunch% = TmpHTCIndex%(BTSIndex%)
BDataIndex% = BtoDataIndex%(Bunch%)
' Set time-stamp to NEXT
BTS& = ArchData(BTSIndex% + 1, HTC_Index%).d2Val

For i% = 0 To NBunchPoints%(tmpI%) - 1 'BunchData(0, 0).iVal - 1
    ' Check each time stamp, to get the current of the right bunch....
    If BunchData(i%, 0).iVal > BTS& Then
        ' Move to the bunch at the NEXT TS....
        BTSIndex% = BTSIndex% + 1
'        If (ArchData(BTSIndex%, HTC_Index%).d1val < 0) Or (ArchData(BTSIndex%, HTC_Index%).d1val > 219) Then
'            ' Kludge: just try to SKIP one?
'            BTSIndex% = BTSIndex% + 1
'            'Bunch% = 0
'            Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).d1val) - 1
'        Else
'            Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).d1val) - 1
'        End If
        Bunch% = TmpHTCIndex%(BTSIndex%)
        BDataIndex% = BtoDataIndex%(Bunch%)
        If (BTSIndex% + 1) > ArchData(0, HTC_Index%).d2Val Then
            ' No More Timestamps.... so keep this bunch....
            BTS& = ArchiveStop& + 100
        Else
            BTS& = ArchData(BTSIndex% + 1, HTC_Index%).d2Val
        End If
    End If
    ArchData(i%, CurrIndex%).d1val = CDbl(BunchData(i%, BDataIndex%).fval)
    ArchData(i%, CurrIndex%).d2Val = CDbl(BunchData(i%, 0).iVal)
Next i%

End Sub

Public Sub DrawArray()
Dim rcc&, i%, ii%, TmpStartStop#(3), TempIndex%, TempSize%
Dim Delta!, InvDelta!, ZeroOffset!, tmpFaktor!
Dim ScaleMax!, ScaleMin!, TempDNameIndex%
Dim tmpstr$

ArchiveForm.ACOPPlot(2).ClearScreen

' Draw an ARRAY in the second window...
' Get the data from the SelectedTrace, at the selected Time-Stamp
TempDNameIndex% = IndexToDName%(SelectedTrace%(0))
TempIndex% = SelectedTrace%(0)

TmpStartStop#(0) = ArchiveTS#
TmpStartStop#(1) = 0

' For TD, need also the SubIndex (the BUNCH)
If UCase$(FSlct(TempIndex%).VPlot) = "TD" Then
'    TmpStartStop&(2) = NextSubi% ' the START INDEX of the "property"
'    TmpStartStop&(3) = NTDBunches ' SAMPLE Interval
    
    TmpStartStop#(2) = 0 ' the START INDEX of the "property"
    TmpStartStop#(3) = 1 ' SAMPLE Interval
Else
    TmpStartStop#(2) = 0 ' the START INDEX of the "property"
    TmpStartStop#(3) = 1 ' SAMPLE Interval
End If

TempSize% = FSlct(TempIndex%).PropSize
ArchiveForm.ACOPData.deviceContext = FSlct(TempIndex%).ContextName
ArchiveForm.ACOPData.DeviceGroup = FSlct(TempIndex%).HistoryServerName
ArchiveForm.ACOPData.deviceName = gArchiveDevice$
ArchiveForm.ACOPData.deviceProperty = FSlct(TempIndex%).PropName
rcc& = ArchiveForm.ACOPData.Execute(ArrayData!(0), TempSize%, "SINGLE", TmpStartStop#, 4)

If rcc& = 0 Then ArrayDataSize = TempSize% Else ArrayDataSize = 0
ArrayDataTimeStamp = ArchiveTS#: ArrayDataKeyword = FSlct(TempIndex%).PropName





' Need to scale the data consistent with MainPlot....
ScaleMax! = FSlct(TempIndex%).PlotMaxValue
ScaleMin! = FSlct(TempIndex%).PlotMinValue

' To scale the data properly....
If FSlct(TempIndex%).VPlot = "LOG" Then
    If ScaleMin! <= 0 Then ScaleMin! = 0.01
    If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
    Delta! = (Log(ScaleMax!) - Log(ScaleMin!))
    If FSlct(TempIndex%).VMin = 0 Then FSlct(TempIndex%).VMin = 1E-20
    ZeroOffset! = Log(ScaleMin!)
Else
    Delta! = ScaleMax! - ScaleMin!
    ZeroOffset! = ScaleMin!
End If

If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = 100 / Delta!
' Use the scale-factor in the form for the GRAPHICS!
InvDelta! = InvDelta! * 1 'Val(ArchiveForm.Faktor(TempDNameIndex%).text)
            
' Plotting "mode"
If FSlct(TempIndex%).VPlot = "LOG" Then
    For ii% = 0 To TempSize% - 1
        If ArrayData!(ii%) > 0 Then
            PlotArrayData!(ii%) = (Log(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
        Else
            PlotArrayData!(ii%) = 0
        End If
    Next ii%
ElseIf FSlct(TempIndex%).VPlot = "ABS" Then
    For ii% = 0 To TempSize% - 1
        PlotArrayData!(ii%) = (Abs(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
    Next ii%
ElseIf FSlct(TempIndex%).VPlot = "SLOG" Then
    tmpFaktor! = 1
    For ii% = 0 To TempSize% - 1
        If PlotArrayData!(ii%) > 0 Then
            ii% = ii%
        End If
        PlotArrayData!(ii%) = (ArrayData!(ii%) * tmpFaktor! - ZeroOffset!) * InvDelta!
    Next ii%
Else
    For ii% = 0 To TempSize% - 1
       PlotArrayData!(ii%) = (ArrayData!(ii%) - ZeroOffset!) * InvDelta!
    Next ii%
End If
                    
If ArchiveForm.OptDisplayArray(0).Value = True Then
    If TempSize% > 100 Then ArchiveForm.ACOPPlot(2).DrawWidth = 1 Else ArchiveForm.ACOPPlot(2).DrawWidth = 3
Else
    ArchiveForm.ACOPPlot(2).DrawWidth = 2
End If

ArchiveForm.ACOPPlot(2).ForeColor = FSlct(TempIndex%).DispColor
ArchiveForm.ACOPPlot(2).Draw PlotArrayData!, , , , TempSize%
ArchiveForm.ACOPPlot(2).xmin = 0
ArchiveForm.ACOPPlot(2).xmax = FSlct(TempIndex%).PropSize

If (ArchiveForm.ChkAuto(0).Value + ArchiveForm.ChkAuto(1).Value + ArchiveForm.ChkAuto(2).Value) > 0 Then
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
Else
    ArchiveForm.ACOPPlot(2).AutoScale False, False, False, False
    ArchiveForm.ACOPPlot(2).ymin = 0
    ArchiveForm.ACOPPlot(2).ymax = 100
End If

Call CTIME(datstr, CLng(ArchiveTS#))
tmpstr$ = ArchiveForm.ACOPPlot(0).CTIME(ArchiveTS#)
tmpstr$ = Mid(tmpstr$, 1, Len(tmpstr$) - 2)

ArchiveForm.ACOPPlot(2).ForeColor = BLACK
ArchiveForm.ACOPPlot(2).YAxisLabel = FSlct(TempIndex%).VUnit
ArchiveForm.ACOPPlot(2).XAxisLabel = "Array Index"
ArchiveForm.ACOPPlot(2).Caption = FSlct(TempIndex%).PropName + "  at  " + tmpstr$

'ArchiveForm.tlab(1).Caption = Left(datstr, Len(datstr) - 2) + "   UTC: " + STR$(ArchiveTS&)
ArchiveForm.tlab(1).Caption = datstr + "   UTC: " + STR$(ArchiveTS#)

ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
'For i% = 0 To MaxPlots% - 1
'    If FSlct(i%).Active Then ArchiveForm.ACOPPlot(0).RecallScreen FSlct(i%).ACOPPlotIndex
'Next i%

ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = PolyLine
ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = -3
XCursorArray#(0) = ArchiveTS#
XCursorArray#(1) = ArchiveTS#
ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = BLUE
ArchiveForm.ACOPPlot(ActivePlot%).Draw YCursorArray!(0), XCursorArray#(0), , , 2, "SINGLE"

' Set markers on array plot?
ArchiveForm.ACOPPlot(2).Tagging = True
ArchiveForm.ACOPPlot(2).ClearTags
For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    If FSlct(i%).Active = True Then
        If FSlct(TempIndex%).PropName = FSlct(i%).PropName Then
            'Set a marker
            If FSlct(i%).DispColor = 0 Then
                ArchiveForm.ACOPPlot(2).TagColor = LGREY
            Else
                ArchiveForm.ACOPPlot(2).TagColor = FSlct(i%).DispColor
            End If
            ArchiveForm.ACOPPlot(2).IsTagged FSlct(i%).DeviceIndex, True
        End If
    End If
Next i%

End Sub

Public Sub DrawMarker()
Dim TempX#(1), TempY#(1)

If ArchiveTS# > 0 Then
    ' Draw a marker
    ArchiveForm.ACOPPlot(0).ClearScreen
    ArchiveForm.ACOPPlot(0).DisplayMode = PolyLine
    ArchiveForm.ACOPPlot(0).DrawWidth = 2
    ArchiveForm.ACOPPlot(0).ForeColor = DGREEN
    TempX#(0) = ArrayDataTimeStamp# 'ArchiveTS# 'ArrayDataTimeStamp#
    TempX#(1) = TempX#(0)
    
    TempY#(0) = ArchiveForm.ACOPPlot(0).ymin - 100
    TempY#(1) = ArchiveForm.ACOPPlot(0).ymax + 100
    
    MarkerPlotIndex& = ArchiveForm.ACOPPlot(0).Draw(TempY#(0), TempX#(0), , , 2, "DOUBLE")
    
    ' Draw a REFERENCE marker
    If (ReferenceTS# > 0) And ((ArchiveForm.CheckRef(0).Value + ArchiveForm.CheckRef(1).Value) > 0) Then
        'ACOPPlot(0).ClearScreen
        ArchiveForm.ACOPPlot(0).DisplayMode = PolyLine
        ArchiveForm.ACOPPlot(0).DrawWidth = 2
        ArchiveForm.ACOPPlot(0).ForeColor = BLUE
        TempX#(0) = ReferenceTS#
        TempX#(1) = TempX#(0)
        
        TempY#(0) = ArchiveForm.ACOPPlot(0).ymin - 100
        TempY#(1) = ArchiveForm.ACOPPlot(0).ymax + 100
        
        RefMarkerPlotIndex& = ArchiveForm.ACOPPlot(0).Draw(TempY#(0), TempX#(0), , , 2, "DOUBLE")
    End If
End If
End Sub

Function getSelectedName(n As Integer) As String
Dim i As Integer
Dim nm$
If n > 15 Then
  getSelectedName = ""
  Exit Function
End If
i = FSlct(n).PListIndex
nm$ = FSlct(n).PropName 'archivedKeywords(i).keyword
If FSlct(n).PropSize > 1 Then
  nm$ = nm$ + "[" + Trim$(STR$(FSlct(n).DeviceIndex)) + "]"
  If FSlct(n).DeviceSubIndex > -1 Then nm$ = nm$ + "[" + Trim$(STR$(FSlct(n).DeviceSubIndex)) + "]"
End If
getSelectedName = nm$
End Function


Public Sub FilterTheData(flag%)
Dim i%, ii&, n&, OKCount&, StartLabel%, StopLabel%

On Error Resume Next

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1
                                
If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).ReFilter = True
        Else
            FSlct(i%).ReFilter = False
        End If
    Next i%
End If
                                
For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).ReFilter = True Then
        n& = FSlct(i%).NumPoints
        
        If FSlct(i%).PropName = "HPFWHM" Then
            ' Bad data from the CMFL FEC....
            For ii& = 1 To n&
                If ArchData(ii&, i%).d1val > 10000# Then ArchData(ii&, i%).d1val = 0
            Next ii&
        ElseIf FSlct(i%).PropName = "H1SLumi" Then
            ' Bad data from H1-Lumi....
            For ii& = 1 To n&
                'If Not (IsNumeric(ArchData(ii&, i%).d1val)) Then ArchData(ii&, i%).d1val = 0
                ArchData(ii&, i%).d1val = Val(ArchData(ii&, i%).d1val)
            Next ii&
        ElseIf FSlct(i%).PropName = "HE_H_HTC_PSC" Or FSlct(i%).PropName = "HE_V_HTC_PSC" Then
            ' Signed Integers read as UNSIGNED...
            For ii& = 1 To n&
                If ArchData(ii&, i%).d1val > 32767 Then ArchData(ii&, i%).d1val = ArchData(ii&, i%).d1val - 65536
            Next ii&
        ElseIf (FSlct(i%).PropName = "TTFAcc2TCoup4KB" And FSlct(i%).DeviceIndex = 4) Or (FSlct(i%).PropName = "TTFAcc1THOM2" And FSlct(i%).DeviceIndex = 2) Then
            ' IS there bad data here?
            ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
            'For ii& = 1 To n&
            '    If ArchData(ii&, i%).d1val > 10000 Then ArchData(ii&, i%).d1val = 0
            'Next ii&
        ElseIf InStr(1, FSlct(i%).PropName, "L3") <> 0 Then '"L3Que"
            ' IS there bad data here?
            ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
            OKCount& = 1
            For ii& = 0 To n& - 1
                If ArchData(ii&, i%).d1val < ErrorValue! Then
                    ArchData(OKCount&, i%).d1val = ArchData(ii&, i%).d1val
                    ArchData(OKCount&, i%).d2Val = ArchData(ii&, i%).d2Val
                    OKCount& = OKCount& + 1
                End If
            Next ii&
            n& = OKCount& - 1
            FSlct(i%).NumPoints = n&
        End If
    
        If ArchiveForm.MenuBADData.Checked Then
            OKCount& = 1
            For ii& = 0 To n& - 1
                If ArchData(ii&, i%).d1val < ErrorValue! Then
                    ArchData(OKCount&, i%).d1val = ArchData(ii&, i%).d1val
                    ArchData(OKCount&, i%).d2Val = ArchData(ii&, i%).d2Val
                    OKCount& = OKCount& + 1
                End If
            Next ii&
            n& = OKCount& - 1
            FSlct(i%).NumPoints = n&
        End If
        FSlct(i%).ReFilter = False
        FSlct(i%).RePlot = True
    Else
        ' Nothing to do?
        FSlct(i%).ReFilter = False
    End If
Next i%

End Sub

Public Sub OperateOnTheData(Index%)
Dim i%, ii%, rc%, NTmp0%, NTmp1%
Dim TmpYData!(), TmpXData0&(), TmpXData1&()
ReDim TmpYData!(MaxPoints)
ReDim TmpXData0&(MaxPoints)
ReDim TmpXData1&(MaxPoints)

On Error GoTo ErrorRoutine

' try to do an operation on two of the arrays which are already loaded.....
If Index% < 2 Then
    MsgBox " error in operation! not enough arrays!"
    Exit Sub
End If

' use the time stamps of the last to get the data points for the SECOND-to-LAST....
NTmp0% = FSlct(Index% - 2).NumPoints
For ii% = 0 To NTmp0% - 1
    TmpXData0&(ii%) = CLng(ArchData(ii%, Index% - 2).d2Val)
    TmpYData!(ii%) = CSng(ArchData(ii%, Index% - 2).d1val)
Next ii%

NTmp1% = FSlct(Index% - 1).NumPoints
For ii% = 0 To NTmp1% - 1
    TmpXData1&(ii%) = ArchData(ii%, Index% - 1).d2Val
Next ii%

' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
rc% = INTERP(TmpYData!(0), TmpXData0&(0), NTmp0%, TmpXData1&(0), NTmp1%)
' assume it is MINUS...
If FSlct(Index%).PropName = OpMinus Then
    If FSlct(Index% - 1).PropName = "HPBunCur" Then
        ' Just so the plot looks good for the proton-current plot....
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            If TmpYData(ii%) > 5 Then  ' Check how much proton current.....
                ArchData(ii%, Index%).d1val = TmpYData(ii%) - ArchData(ii%, Index% - 1).d1val
            Else
                ArchData(ii%, Index%).d1val = 0
            End If
        Next ii%
    Else
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            ArchData(ii%, Index%).d1val = TmpYData(ii%) - ArchData(ii%, Index% - 1).d1val
            'Debug.Print ii%, ArchData(ii%, index%).d1val, ArchData(ii%, index% - 1).d1val, TmpYData(ii%)
        Next ii%
    End If
ElseIf FSlct(Index%).PropName = OpPlus Then
    For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
        ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
        ArchData(ii%, Index%).d1val = TmpYData(ii%) + ArchData(ii%, Index% - 1).d1val
    Next ii%
ElseIf FSlct(Index%).PropName = OpMult Then
    For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
        ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
        ArchData(ii%, Index%).d1val = TmpYData(ii%) * ArchData(ii%, Index% - 1).d1val
    Next ii%
ElseIf FSlct(Index%).PropName = OpDiv Then
    If FSlct(Index% - 1).PropName = "D3IBottom" Then
        ' Just so the plot looks good for the proton-current plot....
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            If (TmpYData(ii%) > 1) And (ArchData(ii%, Index% - 1).d1val <> 0) Then
                ArchData(ii%, Index%).d1val = TmpYData(ii%) / ArchData(ii%, Index% - 1).d1val
            Else
                ArchData(ii%, Index%).d1val = 0
            End If
        Next ii%
    Else
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            If ArchData(ii%, Index% - 1).d1val <> 0 Then
                ArchData(ii%, Index%).d1val = TmpYData(ii%) / ArchData(ii%, Index% - 1).d1val
            Else
                ArchData(ii%, Index%).d1val = 0
            End If
        Next ii%
    End If
End If
FSlct(Index%).NumPoints = FSlct(Index% - 1).NumPoints
FSlct(Index%).TotalPoints = FSlct(Index% - 1).TotalPoints

' Need the time-bins, too...
For ii% = 0 To FSlct(Index%).NumPoints - 1
    ArchTimeBins#(ii%, Index%) = ArchData(ii%, Index%).d2Val
Next ii%
ArchTimeBins#(0, Index%) = ArchData(1, Index%).d2Val - 100
ArchTimeBins#(FSlct(Index%).NumPoints + 1, Index%) = ArchData(FSlct(Index%).NumPoints, Index%).d2Val + 100
Exit Sub
ErrorRoutine:
MsgBox "Error!" + Err.Description
End Sub


Public Sub ReadTheData(flag%)
Dim i%, ii&, j%, k%, kk%, StartLabel%, StopLabel%, MsgRC%, rc%, rcc&
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), tStr$, tmpTotalPoints&, tmpText$
Dim useStringBuffer As Boolean, scratchTotalPoints As FLTINT

On Error GoTo ReadError

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1


If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).Acquire = True
            FSlct(i%).ReFilter = True
            FSlct(i%).ReScale = True
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).Acquire = False
            FSlct(i%).ReFilter = False
            FSlct(i%).ReScale = False
            FSlct(i%).RePlot = False
        End If
        'ArchiveForm.acopplot(0).LockScreen 0, fslct(i%).ACOPPlotIndex
        FSlct(i%).ACOPPlotIndex = -1
    Next
'ElseIf Flag = 1 Then
'    For i% = StartLabel% To StopLabel%
'    '   THIS NEEDS TO BE FIXED !!!! The ArchData() buffer gets reassigned inside the drawing logic to
'    '   accomplish some sort of scaling, etc.  That's why it needs to be reacquired for the autoscale to
'    '   work properly.  The solution is to use a second drawing buffer
'        'If FSlct(i%).Active = True Then FSlct(i%).Acquire = True ' Testing! shouldn't be here - but AUTOSCALE plots wrong without it....
'
'        If FSlct(i%).Active = True Then
'            FSlct(i%).RePlot = True
'        Else
'        End If
'    Next
End If

For i% = StartLabel% To StopLabel%
    With FSlct(i%)
        If .Active And .Acquire = True Then
            If ArchiveForm.MXWindow(1).Checked = True Then
                tmpSide& = 0
            Else
                If NZooms% = 0 Then
                    ' get an extra hour each side.....
                    tmpSide& = 3600
                Else
                    ' What if the data are in ONE SECOND raster - then don't add too much....
                    If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 1000 Then tmpSide& = 100 Else tmpSide& = 1800
                End If
            End If
            
            TmpStartStop&(0) = ArchiveStart& - tmpSide&
            TmpStartStop&(1) = ArchiveStop& + tmpSide&
            
            If ActivePlot% = 1 Then
                ' Don't do anything.... don't need to read data for "copy-buffer"
            ElseIf (.PropName = OpMinus) Or (.PropName = OpPlus) Or (.PropName = OpMult) Or (.PropName = OpDiv) Then
                ' Doing mathematical operations (subtracting coasting beam....)
                Call OperateOnTheData(i%)
            Else
                '
                ' Get everything with the SAME CALLS?
                '
                
                'If .ArchiveSourceFlag = True Then
                '    rc% = ReadArchiveData(i%)
                'Else
                    rc% = ReadHistoryData(i%)
                'End If
                
                If rc% = -10001 Then
                    ' ABORT from the read routine
                    tmpText$ = "ERROR"
                    .NumPoints = 0
                    Exit Sub
                Else
                End If
                                
                If .NumPoints > 0 Then
                    For ii& = 1 To .NumPoints - 2
                        ArchTimeBins#(ii&, i%) = ArchData(ii&, i%).d2Val + ((ArchData(ii& + 1, i%).d2Val - ArchData(ii&, i%).d2Val)) / 2
                    Next ii&
                    ArchTimeBins#(0, i%) = ArchData(1, i%).d2Val - 100
                    ArchTimeBins#(.NumPoints, i%) = ArchData(.NumPoints - 1, i%).d2Val + 100
                Else
                End If
            End If
            
            ' Which row is the data in?
            .Acquire = False
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
    End With
Next i%

Exit Sub
ReadError:
MsgBox "Error in ReadTheData: " + Err.Description
'Resume Next
End Sub

Public Function ReadHistoryData(Index%) As Integer
Dim devProperty$, tmpText$
Dim tmpSide&, TmpStartStop&(3), tmpCount%
Dim tmpTimeOut&, scratchTotalPoints As DBLDBL 'FLTINT
Dim npts As Long, n As Long
Dim rcc&, i&, ii&, j%, nread&, tmpNRaster&, tmpNMax&
Dim dout As DBLK, din As DBLK
Dim iAnswer%, tmpEnabled As Boolean
Dim useStringBuffer As Boolean, tStr$
'Dim tmpLHContext$, tmpLHServer$, tmpLHDeviceName$, tmpLHProperty$
'Dim tmpARCContext$, tmpARCServer$, tmpARCDeviceName$, tmpSelectIndex%
Dim tmpContext$, tmpLHServer$, tmpARCServer$, tmpServer$
Dim tmpProperty$, tmpLHProperty$, tmpARCProperty$
Dim tmpLHDeviceName$, tmpARCDeviceName$, tmpSelectIndex%

Dim tmpDeviceName$, tmpDeviceNUMBER$, tmpDeviceIndex%

Dim scratchTotalPointsFLOAT As FLTINT
Dim DataTypeString$

On Error GoTo ErrorRoutine

' Changing from FLTINT to DBLDBL
DataTypeString$ = "DBLDBL"

With FSlct(Index%)
    .TotalLHPoints = -1
    .TotalArchPoints = -1
    .NumPoints = -1

    .ReFilter = False
    .ReScale = False
    .RePlot = False
    
    If .Active And .Acquire = True Then
        If ArchiveForm.MXWindow(1).Checked = True Then
            tmpSide& = 0
        Else
            If NZooms% = 0 Then
                ' get an extra hour each side.....
                tmpSide& = 3600
            Else
                ' What if the data are in ONE SECOND raster - then don't add too much....
                If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 1000 Then tmpSide& = 100 Else tmpSide& = 1800
            End If
        End If
        
        TmpStartStop&(0) = ArchiveStart& - tmpSide&
        TmpStartStop&(1) = ArchiveStop& + tmpSide&
        TmpStartStop&(2) = 0 'Index
        TmpStartStop&(3) = 0 ' Sample-Raster
        
        ' Check if there is a device name...
        If .DeviceIndex = -1 Then tmpDeviceIndex% = 0
        If .deviceName = "" Or .deviceName = "?" Then
            ' Only an index...
            tmpDeviceName$ = "#" + format$(tmpDeviceIndex%, "###0") 'format$(.DeviceIndex, "###0")
        ElseIf InStr(1, .deviceName, "/") <> 0 Then
            ' Vakuum Servers: some devices have a SLASH!
            tmpDeviceName$ = "#" + format$(tmpDeviceIndex%, "###0") 'format$(.DeviceIndex, "###0")
        Else
            tmpDeviceName$ = .deviceName
        End If
            
        If .VPlot = "TD" Then
            ' Is this a TD Property?
            tmpDeviceIndex% = .DeviceIndex * MaxSubIndex% + .DeviceSubIndex
            ' DON'T USE THE DEVICE NAME!
            tmpDeviceName$ = "#" + format$(tmpDeviceIndex%, "###0")
        Else
            'tmpDeviceIndex% = .DeviceIndex
        End If
        
        ' Invalid device name - not registered (only a .NAM property?) then try a NUMBER....
        tmpDeviceNUMBER$ = "#" + format$(tmpDeviceIndex%, "###0")

        ' First find out how many points
        tmpTimeOut& = DefaultDataReadTimeOut&
        tmpCount% = 0
LaunchPointsLink:
        
        tmpContext$ = .ContextName
        tmpLHServer$ = .HistoryServerName
        tmpProperty$ = .PropName
        
        ' Shouldn't get the ARCHIVER here, oder?
        If InStr(1, tmpLHServer$, "HISTORY") <> 0 Then tmpLHServer$ = "ARCHIVER"
        'If InStr(1, tmpServer$, "ARCHIVER") <> 0 Then tmpServer$ = "HISTORY"
        
        tmpLHDeviceName$ = tmpDeviceName$
        tmpLHProperty$ = tmpProperty$ + ".HIST"
        
        ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
        ArchiveForm.ACOPData.AccessMode = "READ"
        
        ArchiveForm.ACOPData.deviceContext = tmpContext$
        ArchiveForm.ACOPData.DeviceGroup = tmpLHServer$
        
        ArchiveForm.ACOPData.deviceName = tmpLHDeviceName$
        ArchiveForm.ACOPData.deviceProperty = tmpLHProperty$
        rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
        'tmpTimeOut& = 1000 ' This should go fast....
        If rcc& = out_of_range% Or rcc& = device_not_connected% Then
            tmpLHDeviceName$ = tmpDeviceNUMBER$
            ArchiveForm.ACOPData.deviceName = tmpLHDeviceName$
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
        End If
        
        ReadHistoryData = rcc&
        
        If (rcc& And CE_SENDDATA) = CE_SENDDATA Then
            MsgBox "Testing!  Found CE_SENDDATA! Setting rcc to 0!"
            rcc& = 0
        End If
        If (rcc& And CE_REDIRECTED) = CE_REDIRECTED Then
            'MsgBox "Testing!  Found CE_REDIRECTED Setting rcc to 0!"
            tmpCount% = tmpCount% + 1
            If ArchiveForm.MExtraDisplay.Checked = True Then
                MsgBox "Re-Direction Error Code for Context/Server " + tmpContext$ + "/" + tmpLHServer$ + ": " + ArchiveForm.ACOPData.status + "  RPC Code: " + STR$(rcc&)
            End If
            If tmpCount% = 1 Then GoTo LaunchPointsLink
        End If
        If (rcc& And CE_RENEGOTIATE) = CE_RENEGOTIATE Then
            If ArchiveForm.MExtraDisplay.Checked = True Then
                MsgBox "Testing!  Found CE_RENEGOTIATE Setting rcc to 0!"
            End If
            'rcc& = 0
            rcc& = (rcc& And Not (CE_RENEGOTIATE))
        End If
        
        If rcc& Then
            scratchTotalPoints.d2Val = -1
            
            If (rcc& And un_allocated%) = un_allocated% Then
                ' if HISTORY SERVER and .HIST doesn't work, then could be OK....
            ElseIf (rcc& And illegal_property%) = illegal_property% Then
                ' Address unknown!
            ElseIf (rcc& And device_not_connected%) = device_not_connected% Then
                ' Device Not connected!!
            ElseIf (rcc& And address_unknown%) = address_unknown% Then
                ' Address unknown!
            ElseIf (rcc& And non_existent_elem%) = non_existent_elem% Then
                ' Not Defined!
            ElseIf (rcc& And link_blacklisted%) = link_blacklisted% Then
            ElseIf (rcc& And not_defined%) = not_defined% Then
                ' Not Defined!
            Else
                If ArchiveForm.ACOPData.status = "" Then
                    tmpText$ = "Error reading Total-History-POINTS for " + tmpLHProperty$ + " from " + tmpLHDeviceName$ + ":  Status String is empty, but the Return Code = " + STR$(rcc&) + " [" + RPCERROR(rcc&) + "]"
                Else
                    tmpText$ = "Error reading Total-History-POINTS for " + tmpLHProperty$ + " from " + tmpLHDeviceName$ + ":  " + ArchiveForm.ACOPData.status + "     Return Code: " + STR$(rcc&) + " [" + RPCERROR(rcc&) + "]"
                End If
                iAnswer% = MsgBox(tmpText$, vbAbortRetryIgnore, "Reading History Property")
                scratchTotalPoints.d2Val = 0
                If iAnswer% = vbRetry Then
                    tmpTimeOut& = tmpTimeOut& + DefaultTimeOutIncrement&
                    GoTo LaunchPointsLink
                ElseIf iAnswer% = vbAbort Then
                    ReadHistoryData = -10001
                    Exit Function
                Else
                    ' Ignore...
                End If
            End If
        End If
        .TotalLHPoints = CLng(scratchTotalPoints.d2Val)

ArchiveCall:
        
        tmpARCDeviceName$ = tmpDeviceName$
        tmpTimeOut& = DefaultDataReadTimeOut&
        ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
                
        If tmpLHServer$ = "ARCHIVER" Then
            tmpARCServer$ = "HISTORY"
            tmpARCProperty$ = tmpProperty$
        Else
            tmpARCServer$ = tmpLHServer$
            If InStr(1, tmpServer$, "HISTORY") <> 0 Then
                tmpARCProperty$ = tmpProperty$
            Else
                tmpARCProperty$ = tmpProperty$ + ".ARC" 'H"
            End If
        End If
        tmpCount% = 0
ArchiveReTry:
        scratchTotalPoints.d1val = -1
        ArchiveForm.ACOPData.deviceContext = tmpContext$
        ArchiveForm.ACOPData.DeviceGroup = tmpARCServer$
        ArchiveForm.ACOPData.deviceName = tmpARCDeviceName$
        ArchiveForm.ACOPData.deviceProperty = tmpARCProperty$
        rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
        Debug.Print scratchTotalPoints.d2Val

'Global Const CE_SENDDATA = &H4000
'Global Const CE_REDIRECTED = &H8000
'Global Const CE_RENEGOTIATE = &H2000
        If (rcc& And CE_SENDDATA) = CE_SENDDATA Then
            MsgBox "Testing!  Found CE_SENDDATA! Setting rcc to 0!"
            rcc& = 0
        End If
        If (rcc& And CE_REDIRECTED) = CE_REDIRECTED Then
            'MsgBox "Testing!  Found CE_REDIRECTED Setting rcc to 0!"
            tmpCount% = tmpCount% + 1
            If ArchiveForm.MExtraDisplay.Checked = True Then
                MsgBox "Re-Direction Error Code for Context/Server " + tmpContext$ + "/" + tmpLHServer$ + ": " + ArchiveForm.ACOPData.status + "  RPC Code: " + STR$(rcc&)
            End If
            If tmpCount% = 1 Then GoTo ArchiveReTry
        End If
        If (rcc& And CE_RENEGOTIATE) = CE_RENEGOTIATE Then
            If ArchiveForm.MExtraDisplay.Checked = True Then
                MsgBox "Testing!  Found CE_RENEGOTIATE Setting rcc to 0!"
            End If
            rcc& = (rcc& And Not (CE_RENEGOTIATE))
        End If
        
'Global Const not_defined% = 101

        ' Try a different device?
        If rcc& = illegal_equipment_number% Then
            'tmpARCDeviceName$ = "#0"
            'tmpDeviceIndex% = .DeviceIndex
            tmpText$ = "Error reading from central archiver Property, Device " + tmpARCProperty$ + ", " + tmpARCDeviceName$ + ":   " + STR$(rcc&) + " [" + RPCERROR(rcc&) + "]"
            iAnswer% = MsgBox(tmpText$, vbOKOnly, "Reading Archive Property")
            tmpARCDeviceName$ = "#" + format$(tmpDeviceIndex%, "0")
            ArchiveForm.ACOPData.deviceName = tmpARCDeviceName$
            TmpStartStop&(2) = 1
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 3)
            TmpStartStop&(2) = 0
        End If
        
        If rcc& Then
            scratchTotalPoints.d2Val = -1
            If rcc& = address_unknown% Then
                ' Address unknown!
            ElseIf (rcc& And not_implemented%) = not_implemented% Then
                ' Not Defined!
            ElseIf (rcc& And not_defined%) = not_defined% Then
            ElseIf (rcc& And link_blacklisted%) = link_blacklisted% Then
                ' Not Defined!
            ElseIf (rcc& And not_defined%) = illegal_property% Then
            Else
                If ArchiveForm.ACOPData.status = "" Then
                    tmpText$ = "Error reading from central archiver Property " + tmpARCProperty$ + ":  Status String is empty, but the Return Code = " + STR$(rcc&) + " [" + RPCERROR(rcc&) + "]"
                Else
                    tmpText$ = "Error reading from central archiver Property " + tmpARCProperty$ + ":  " + ArchiveForm.ACOPData.status + "  RC = " + STR$(rcc&) + " [" + RPCERROR(rcc&) + "]"
                End If
                iAnswer% = MsgBox(tmpText$, vbAbortRetryIgnore, "Reading Archive Property")
                If iAnswer% = vbRetry Then
                    tmpTimeOut& = tmpTimeOut& + DefaultTimeOutIncrement&
                    GoTo ArchiveCall
                ElseIf iAnswer% = vbAbort Then
                    .NumPoints = 0
                    .TotalPoints = 0
                    ReadHistoryData = -10001
                    Exit Function
                Else
                    ' Ignore....
                End If
                nread = 0
            End If
        End If
        .TotalArchPoints = CLng(scratchTotalPoints.d2Val)
                
        If ArchiveMode% <> LHistoryChooser Or ArchiveForm.OptArcProperty(2).Value = True Then
            If .TotalArchPoints > 500 Or .TotalArchPoints > .TotalLHPoints Then
                ' use ARCH Property
                tmpSelectIndex% = 1
            Else
                tmpSelectIndex% = 0
            End If
        Else
            If ArchiveForm.OptArcProperty(0).Value Then
                tmpSelectIndex% = 0
            Else 'If ArchiveForm.OptArcProperty(1).Value Then
                tmpSelectIndex% = 1
            End If
        End If
        
        'tmpSelectIndex% = 1
        Select Case tmpSelectIndex%
        Case 0: ' NORMAL Local History
            ' Get the Local History Data
            tmpDeviceName$ = tmpLHDeviceName$
            tmpProperty$ = tmpLHProperty$
            tmpServer$ = tmpLHServer$
            .TotalPoints = .TotalLHPoints
            If .TotalPoints > 10000 Then
                tmpTimeOut& = 5000
            Else
                tmpTimeOut& = 2000
            End If
            
        Case 1: ' Central Archiver
            ' Get the data out of the CENTRAL ARCHIVER
            tmpDeviceName$ = tmpARCDeviceName$
            tmpProperty$ = tmpARCProperty$
            tmpServer$ = tmpARCServer$
            .TotalPoints = .TotalArchPoints
            tmpTimeOut& = 1000
        End Select
    
        tmpText$ = "Total: " + format$(.TotalPoints, "0")
        ArchiveForm.LabelPoints(0) = tmpText$

        tmpTimeOut& = DefaultDataReadTimeOut&
        tmpCount% = 0
LaunchHistoryLink:
        'TmpStartStop&(2) = 0.01
        'TmpStartStop&(3) = -1
        
        ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
        ArchiveForm.ACOPData.deviceContext = tmpContext$
        ArchiveForm.ACOPData.DeviceGroup = tmpServer$
        'tmpDeviceName$ = "keyword"
        ArchiveForm.ACOPData.deviceName = tmpDeviceName$
        ArchiveForm.ACOPData.deviceProperty = tmpProperty$
        
        .LastDeviceContext = tmpContext$
        .LastDeviceServer = tmpServer$
        .LastDeviceProperty = tmpProperty$
        
        .SampleRasterIndex = SampleRasterCheckIndex%
        
        ArchiveForm.ACOPData.AccessMode = "READ" + selectedTransportModeDecoration
        
        If ArchiveForm.IndexCombo.Visible = True Then
            ' Use ARRAY INDEX
            'TmpStartStop&(2) = ArchiveForm.IndexCombo.ListIndex
            TmpStartStop&(2) = .DeviceSubIndex
        Else
            TmpStartStop&(2) = 0
        End If
        
        Select Case SampleRasterCheckIndex%
        Case 0: ' HISTRY server decides raster
                .SampleRasterFlag = False
                .SampleRaster = 0
        Case 1: ' Get EVERY point, after START-TIME
                .SampleRasterFlag = True
                .SampleRaster = 1
        Case 2: ' Get every SECOND point, afer start time
                .SampleRasterFlag = True
                .SampleRaster = 2
        Case 3: ' Calculate sample raster: need for SCHEDULED properties, when Local-History Server
                ' cannot use "polling rate" as an estimate for the Short-Term Interval
                ' (z.b. l.h. "polling" at at 1 Hz but scheduling at 10 Hz)
                .SampleRasterFlag = True
                
                If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
                    tmpNMax& = MaxStrings
                Else
                    tmpNMax& = MaxGetDataPoints
                End If
                tmpNRaster& = Int(.TotalPoints / tmpNMax& + 1)
                'If .TotalPoints < tmpNMax& Then
                '    tmpNRaster& = 1
                'Else
                'End If

                .SampleRaster = tmpNRaster&
        End Select
        TmpStartStop(3) = .SampleRaster
        
        tStr = Left(UCase(.PropFormatStr), 4)
        If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
            rcc& = ArchiveForm.ACOPData.Execute(ArchStringDataBuffer(0, Index%).nam, MaxStrings, "NAME32I", TmpStartStop, 4)
            useStringBuffer = True
        Else
            rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, Index%).d1val, MaxGetDataPoints, "DBLDBL", TmpStartStop, 4)
        End If
        
        'rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, Index%).d1val, MaxGetDataPointsHIST, "DBLDBL", TmpStartStop, 3)
                        
        ReadHistoryData = rcc&
        
        If (rcc& And CE_REDIRECTED) = CE_REDIRECTED Then
            'MsgBox "Testing!  Found CE_REDIRECTED Setting rcc to 0!"
            tmpCount% = tmpCount% + 1
            If ArchiveForm.MExtraDisplay.Checked = True Then
                MsgBox "Re-Direction Error Code for Context/Server " + tmpContext$ + "/" + tmpLHServer$ + ": " + ArchiveForm.ACOPData.status + "  RPC Code: " + STR$(rcc&)
            End If
            If tmpCount% = 1 Then GoTo LaunchHistoryLink
        End If
        If (rcc& And CE_RENEGOTIATE) = CE_RENEGOTIATE Then
            If ArchiveForm.MExtraDisplay.Checked = True Then
                MsgBox "Testing!  Found CE_RENEGOTIATE Setting rcc to 0!"
            End If
            rcc& = (rcc& And Not (CE_RENEGOTIATE))
        End If
        If rcc& Then
            'If ArchiveMode% = CArchivers Then
            '    ' Not allocated from .HIST redirection?
            '    nread = -1
            'Else
                ArchiveForm.ACOPData.GetDataSize nread
                If ArchiveForm.ACOPData.status = "" Then
                    tmpText$ = "Error Reading History Data for " + tmpProperty$ + " from " + tmpContext$ + "/" + tmpServer$ + ":  Status String is empty, but the Return Code = " + STR$(rcc&) + " [" + RPCERROR(rcc&) + "]"
                Else
                    tmpText$ = "Error Reading History Data for " + tmpProperty$ + " from " + tmpContext$ + "/" + tmpServer$ + ":  " + ArchiveForm.ACOPData.status + "   and the Return Code = " + STR$(rcc&) + " [" + RPCERROR(rcc&) + "]"
                End If
                iAnswer% = MsgBox(tmpText$, vbAbortRetryIgnore, "Reading History Property")
                If iAnswer% = vbRetry Then
                    tmpTimeOut& = tmpTimeOut& + DefaultTimeOutIncrement&
                    GoTo LaunchHistoryLink
                ElseIf iAnswer% = vbAbort Then
                    .NumPoints = 0
                    .TotalPoints = 0
                    ReadHistoryData = -10001
                    Exit Function
                Else
                    ' Ignore....
                    ArchiveForm.ACOPData.GetDataSize nread
                    .ReFilter = True
                    .ReScale = True
                    .RePlot = True
                End If
            'End If
        Else
            ArchiveForm.ACOPData.GetDataSize nread
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
        .NumPoints = nread
    
        On Error GoTo BadDataErrorRoutine
        
        ii& = 0
        For i& = 0 To nread - 1
            If (nFilterKeywords = 0) Or (filterArchiveData(CLng(ArchDataBuffer(i&, Index%).d2Val)) > 0) Then
                If useStringBuffer Then
                    ArchData(ii&, Index%).d2Val = ArchStringDataBuffer(i&, Index%).iVal
                Else
                    ArchData(ii&, Index%) = ArchDataBuffer(i&, Index%)
                End If
                ii& = ii& + 1
            End If
        Next i&
        If ii& > 1 Then
            .NumPoints = ii& ' - 1
        Else
            .NumPoints = 0
        End If
    End If
End With

' Set back to "nothing"
ArchiveForm.LabelPoints(0).Caption = "-"
ArchiveForm.LabelPoints(1).Caption = "-"
ArchiveForm.LabelPoints(2).Caption = "-"
Exit Function

ErrorRoutine:
MsgBox "Error Reading Data: " + Err.Description
Resume Next

BadDataErrorRoutine:
MsgBox "Error Filtering Data: " + Err.Description + "  Archive Data at index = " + STR$(i&) + ", Value = " + STR$(ArchDataBuffer(i&, Index%).d2Val)
'ArchDataBuffer(i&, Index%).d2Val = 0
'Resume Next
End Function

Public Function ReadArchiveData_Legacy(Index%) As Integer
Dim i%, ii&, j%, k%, kk%, StartLabel%, StopLabel%, MsgRC%, rc%, rcc&
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), tStr$, tmpTotalPoints&, tmpText$, TmpStartStopDble#(3)
Dim useStringBuffer As Boolean, scratchTotalPoints As FLTINT, TmpDevName$, tmpDeviceIndex%, tmpDeviceName$
Dim iAnswer%
Dim nPointsRead%

'On Error GoTo ErrorRoutine
'
'With FSlct(Index%)
'    .ReFilter = False
'    .ReScale = False
'    .RePlot = False
'
'    If .Active And .Acquire = True Then
'        If ArchiveForm.MXWindow(1).Checked = True Then
'            tmpSide& = 0
'        Else
'            If NZooms% = 0 Then
'                ' get an extra hour each side.....
'                tmpSide& = 3600
'            Else
'                ' What if the data are in ONE SECOND raster - then don't add too much....
'                If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
'            End If
'        End If
'
'        TmpStartStop&(0) = ArchiveStart& - tmpSide&
'        TmpStartStop&(1) = ArchiveStop& + tmpSide&
'
'        If Not filterAcquired Then
'retrieveFilterData:
'            If nFilterKeywords > 0 Then
'                ArchiveForm.ACOPData.Caption = filterString
'                For j% = 0 To nFilterKeywords - 1
'                    ArchiveForm.ACOPData.deviceContext = filterKeywords(j%).context
'                    ArchiveForm.ACOPData.DeviceGroup = filterKeywords(j%).server
'                    ArchiveForm.ACOPData.deviceName = gArchiveDevice$
'                    ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
'                    If filterKeywords(j%).fmt = "NAME32" Then
'                        rcc& = ArchiveForm.ACOPData.Execute(filterTextBuffer(0, j%).nam, MaxPoints / 10, "NAME32I", TmpStartStop)
'                    Else
'                        rcc& = ArchiveForm.ACOPData.Execute(filterDataBuffer(0, j%).fval, MaxPoints, "FLTINT", TmpStartStop)
'                    End If
'                    If rcc& Then
'                        MsgRC = MsgBox(" Error acquiring filter! " + ArchiveForm.ACOPData.status, vbAbortRetryIgnore, "Archive Retrieval")
'                        filterDataBufferNPoints&(j%) = 0
'                        If MsgRC = vbRetry Then GoTo retrieveFilterData
'                    End If
'                    ArchiveForm.ACOPData.GetDataSize nPointsRead%
'                    filterDataBufferNPoints&(j%) = nPointsRead%
'                Next j%
'            Else
'                ArchiveForm.ACOPData.Caption = ""
'            End If
'            filterAcquired = True
'        End If
'
'        ' get the data out of the archive
'retrieveArchiveData:
'        ArchiveForm.LabelMisc(3).Caption = "Data loading...."
'        ArchiveForm.LabelMisc(3).Visible = True
'        ArchiveForm.Refresh
'
'        ' give it a longer timeout in case there's a bunch of data :
'        If ArchiveForm.timeoutText.Visible Then
'            ArchiveForm.ACOPData.AccessRate = ArchiveForm.timeoutText.text '3000
'        Else
'            ArchiveForm.ACOPData.AccessRate = 3000
'        End If
'
'        If .DeviceIndex < 0 And .deviceName = "#0" And Mid(.PropName, 1, 3) <> "TTF" Then
'            ' For the HTC: get the BUNCH CURRENTS for the INDEX of the HE_HTC_BUNCH!
'            ArchiveForm.ACOPData.deviceName = .HistoryServerName
'            Call GetHTCStuff(Index%)
'        Else
'            tmpDeviceName$ = .deviceName
'            If .DeviceIndex < 0 Then
'                tmpDeviceIndex% = 0
'            ElseIf .VPlot = "TD" Then
'                ' Is this a TD Property?
'                'TmpStartStop&(2) = .DeviceIndex * NTDBunches + .DeviceSubIndex
'                tmpDeviceIndex% = .DeviceIndex * MaxSubIndex% + .DeviceSubIndex
'                ' DON'T USE THE DEVICE NAME!
'                tmpDeviceName$ = ""
'            Else
'                tmpDeviceIndex% = .DeviceIndex
'            End If
'
'
'LaunchPointsLink:
'            ' Check if there is a device name...
'            If tmpDeviceName$ = "" Or tmpDeviceName$ = "?" Then
'                ' Only an index...
'                TmpDevName$ = "#" + Format$(tmpDeviceIndex%, "###0")
'            ElseIf InStr(1, .deviceName, "/") <> 0 Then
'                ' Vakuum Servers: some devices have a SLASH!
'                    TmpDevName$ = "#" + Format$(tmpDeviceIndex%, "###0")
'            Else
'                     TmpDevName$ = tmpDeviceName$
'            End If
'            ArchiveForm.ACOPData.deviceContext = .ContextName
'            ArchiveForm.ACOPData.DeviceGroup = .HistoryServerName
'            ArchiveForm.ACOPData.deviceName = TmpDevName$
'            ArchiveForm.ACOPData.deviceProperty = .PropName
'
'
'            '' Get the total number of points in the interval
'            'ArchiveForm.ACOPData.deviceName = .ServerName + "/" + .deviceName
'            'If .ContextName <> "" Then
'            '  ArchiveForm.ACOPData.deviceName = "/" + .ContextName + "/" + ArchiveForm.ACOPData.deviceName
'            'End If
'
'            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
'            If rcc& Then '= out_of_range% Then
''                ' Invalid device name - not registered (only a .NAM property?)
''                'MsgBox " error reading device name history for " + devProperty + ": " + RPCERROR(rcc&)
''                If .ContextName = "" Then
''                    TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
''                Else
''                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
''                End If
''                ArchiveForm.ACOPData.deviceName = TmpDevName$
''                rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
'            End If
'
'            If rcc& Then
'                scratchTotalPoints.iVal = 0
'                iAnswer% = MsgBox(" Error Reading Total Points for " + .PropName + " from " + TmpDevName$ + ":  " + ArchiveForm.ACOPData.status, vbAbortRetryIgnore, "Reading Histories")
'                If iAnswer% = vbRetry Then
'                    GoTo LaunchPointsLink
'                ElseIf iAnswer% = vbAbort Then
'                    ReadArchiveData = -10001
'                    Exit Function
'                Else
'                    ' Ignore....
'                End If
'            End If
'            tmpTotalPoints& = scratchTotalPoints.iVal
'            .TotalPoints = tmpTotalPoints&
'
'LaunchDataLink:
'            ArchiveForm.ACOPData.deviceProperty = .PropName
'            ArchiveForm.ACOPData.deviceName = TmpDevName$ '.ServerName + "/" + .deviceName
'            'If .ContextName <> "" Then
'            '  ArchiveForm.ACOPData.deviceName = "/" + .ContextName + "/" + ArchiveForm.ACOPData.deviceName
'            'End If
'            If .Acquire = True Then
'                tStr = Left(UCase(.PropFormatStr), 4)
'                If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
'                    rcc& = ArchiveForm.ACOPData.Execute(ArchStringDataBuffer(0, Index%).nam, MaxStrings, "NAME32I", TmpStartStop, 2)
'                    useStringBuffer = True
'                Else
'                    rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, Index%).d1val, MaxGetDataPointsARCH, "DBLDBL", TmpStartStop, 2)
'                End If
'                If rcc& Then
'                  iAnswer% = MsgBox(" Error Reading Archived Data for " + .PropName + " from " + TmpDevName$ + ":  " + " " + ArchiveForm.ACOPData.status, vbAbortRetryIgnore, "Reading Histories")
'                  'ArchData(0, index%).iVal = 0
'                  If iAnswer% = vbRetry Then
'                      GoTo LaunchDataLink
'                  ElseIf iAnswer% = vbAbort Then
'                      ReadArchiveData = -10001
'                      Exit Function
'                  Else
'                      ' Ignore....
'                  End If
'                  nPointsRead% = 0                                 'P.D  allow for the new way !
'                Else
'                  ArchiveForm.ACOPData.GetDataSize nPointsRead%    'P.D  allow for the new way !
'                End If
'            End If
'
'            .NumPoints = nPointsRead%
'            kk% = 0
'            For k% = 0 To nPointsRead% - 1 'ArchDataBuffer(0, index%).d2val
'                If (nFilterKeywords = 0) Or (filterArchiveData(CLng(ArchDataBuffer(k%, Index%).d2Val)) > 0) Then
'                    If useStringBuffer Then
'                        ArchData(kk%, Index%).d2Val = ArchStringDataBuffer(k%, Index%).iVal
'                    Else
'                        ArchData(kk%, Index%) = ArchDataBuffer(k%, Index%)
'
'                        ' TimeStamp of ZERO????
'                        'If kk% > 0 And ArchData(kk%, index%).iVal = 0 Then
'                        '    ArchData(kk%, index%).iVal = ArchData(kk% - 1, index%).iVal + 1
'                        'End If
'                        'Debug.Print k%, ArchData(kk%, index%).fval, ArchData(kk%, index%).iVal - ArchData(0, index%).iVal
'                    End If
'                    kk% = kk% + 1
'                End If
'            Next k%
'            If kk% > 1 Then
'                .NumPoints = kk% ' - 1
'            Else
'                .NumPoints = 0
'            End If
'        End If
'
'        '.NumPoints = 1
'        ReadArchiveData = rcc&
'        ' .NumPoints = ArchDataBuffer(0, index%).iVal  ' < why is (was) this necessary ?
'
'        If rcc& Then
'
'        Else
'            .ReFilter = True
'            .ReScale = True
'            .RePlot = True
'        End If
'    End If
'End With
'
'Exit Function
'
'ErrorRoutine:
'iAnswer% = MsgBox("Error in Read for Property: " + ArchiveForm.ACOPData.deviceProperty + "  " + Err.Description, vbRetryCancel)
'If iAnswer% = vbCancel Then
'    Exit Function
'Else
'    Resume Next
'End If
End Function

Public Sub ReadArrayData()
Dim i%, TmpDName$, tmpDefaultDName$, TmpPName$, rcc&, TmpStartStop#(3)
Dim tmpTS&, TmpSize&, tmpTSArray&(1), TempIndex%, TempDNameIndex%, tmpTimeOut&
Dim iAnswer%, TmpDataServer$, tmpName64() As NAME64

If SelectedTrace%(0) < 0 Then SelectedTrace%(0) = 0

If ArchiveTS# <= 0 Then
    ArchiveTS# = ArchiveStart& + (ArchiveStop& - ArchiveStart&) / 2
End If

'LabelTime(0).Caption = ACOPPlot(0).CTIME(ArchiveTS&)

' Get the data from the SelectedTrace, at the selected Time-Stamp
TempDNameIndex% = IndexToDName%(SelectedTrace%(0))
TempIndex% = SelectedTrace%(0)

If FSlct(TempIndex%).PropSize = 1 Then
    MsgBox " Selected Property is NOT an array!"
    Exit Sub
End If

If ArchiveMode% = CArchivers Then
    TmpStartStop#(0) = ArchiveTS#
    TmpStartStop#(1) = ArchiveTS#
    
    With FSlct(TempIndex%)
        ' For TD, need also the SubIndex (the BUNCH)
        If UCase$(.VPlot) = "TD" Then
        '    TmpStartStop&(2) = NextSubi% ' the START INDEX of the "property"
        '    TmpStartStop&(3) = NTDBunches ' SAMPLE Interval
            
            TmpStartStop#(2) = 0 ' the START INDEX of the "property"
            TmpStartStop#(3) = 1 ' SAMPLE Interval
        Else
            TmpStartStop#(2) = 0 ' the START INDEX of the "property"
            TmpStartStop#(3) = 1 ' SAMPLE Interval
        End If
        
        TmpSize& = .PropSize
        TmpPName$ = .PropName
                
        ArrayDataContext$ = .ContextName
        ArrayDataServer$ = gHistoryServer$ '.DataServerName
        ArrayDataDevice$ = gArchiveDevice$
    
        ArrayDataContext$ = .LastDeviceContext
        ArrayDataServer$ = .LastDeviceServer
        ArrayDataDevice$ = "#0"
        TmpPName$ = .LastDeviceProperty
        If InStr(1, TmpPName$, ".HIST") <> 0 Then TmpPName$ = TmpPName$ '+ "@"
    End With
        
    ReDim ArrayData!(TmpSize& - 1)
    ReDim PlotArrayData!(TmpSize& - 1)

    ArchiveForm.ACOPData.deviceContext = ArrayDataContext$
    ArchiveForm.ACOPData.DeviceGroup = ArrayDataServer$ 'gHistoryServer$ 'ArrayDataServer$
    ArchiveForm.ACOPData.deviceName = ArrayDataDevice$
    ArchiveForm.ACOPData.deviceProperty = TmpPName$
    
    rcc& = ArchiveForm.ACOPData.Execute(ArrayData!(0), TmpSize&, "SINGLE", TmpStartStop#, 2)
    If rcc& Then
        MsgBox ArchiveForm.ACOPData.status
    End If
    
    If ArrayNameProperty$ <> TmpPName$ Then
    'If GotArrayDeviceNamesFlag = False Then
        ArrayNameProperty$ = TmpPName$
        GotArrayDeviceNamesFlag = True
        ReDim tmpName64(TmpSize& - 1)
        ReDim ArrayDataDeviceNames$(TmpSize& - 1)
        ArchiveForm.ACOPData.deviceName = "#0"
        ArchiveForm.ACOPData.deviceProperty = TmpPName$ + ".NAM"
        rcc& = ArchiveForm.ACOPData.Execute(tmpName64(0).nam(0), TmpSize&, "NAME64")
    
        For i% = 0 To TmpSize& - 1
            ArrayDataDeviceNames$(i%) = BSTR(tmpName64(i%).nam)
        Next i%
    End If
Else
    ' What to read?
    ' Pump-ish data: data is stored with DeviceNumber #0 = only ONE Array
    ' Vibration Data - one array is stored for each DEVICE....
    
    With FSlct(TempIndex%)
        TmpPName$ = .PropName
        TmpSize& = .PropSize
        
        'If .ArrayType And AT_TRACE = AT_TRACE Then
            'ArchiveForm.ACOPPlot(2).DisplayMode = PolyLineDots
            ArrayDataDevice$ = .deviceName
        'Else
            'ArchiveForm.ACOPPlot(2).DisplayMode = SimpleHistogram
            tmpDefaultDName$ = "#0"
        'End If
        
        ArrayDataContext$ = .ContextName
        ArrayDataServer$ = .DataServerName
        'ArrayDataDevice$ = gArchiveDevice$
    End With
    
    ReDim ArrayData!(TmpSize& - 1)
    ReDim PlotArrayData!(TmpSize& - 1)
    
    TmpStartStop#(0) = ArchiveTS#
    TmpStartStop#(1) = TmpStartStop#(0)
    TmpStartStop#(2) = 0
    TmpStartStop#(3) = -1
    
    ' First try with "device index"?
    tmpTimeOut& = DefaultDataReadTimeOut&
    ArchiveForm.ACOPData.deviceProperty = TmpPName$ + ".HIST"
    
    ArchiveForm.ACOPData.AccessMode = "READ"
    'rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", ArchiveTS&, 1, "LONG")
    
ReadArrayAgain:
    ArchiveForm.ACOPData.deviceContext = ArrayDataContext$
    ArchiveForm.ACOPData.DeviceGroup = ArrayDataServer$
    ArchiveForm.ACOPData.deviceName = ArrayDataDevice$
    'ArchiveForm.ACOPData.deviceName = TmpDName$
    ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
    rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop#, 4, "DOUBLE")

    If rcc& = 12 Or rcc& = 32 Then
        ' NOT ALLOCATED! Try with device zero....
        ArchiveForm.ACOPData.deviceName = tmpDefaultDName$
        rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop#, 4, "DOUBLE")
    End If
    
    If rcc& Then
        iAnswer% = MsgBox(" Error Reading History Data for " + ArchiveForm.ACOPData.deviceProperty + " from " + ArchiveForm.ACOPData.deviceName + _
                        ":  " + ArchiveForm.ACOPData.status, vbAbortRetryIgnore, "Reading Histories")
        If iAnswer% = vbRetry Then
            tmpTimeOut& = tmpTimeOut& + 2000
            GoTo ReadArrayAgain
        ElseIf iAnswer% = vbAbort Then
            Exit Sub
        Else
        End If
    End If


'    With FSlct(TempIndex%)
'        TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#1"
'        ArchiveForm.ACOPData.deviceName = TmpDName$
'        ArchiveForm.ACOPData.deviceProperty = TmpPName$ + ".HIST"
'        ReDim ArrayINTData%(TmpSize& - 1)
'        rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop&, 4, "LONG")
'        'rcc& = ArchiveForm.ACOPData.Execute(ArrayINTData%, TmpSize&, "INTEGER", TmpStartStop&, 4, "LONG")
'    End With
End If

ArrayProp$ = TmpPName$

If rcc& = 0 Then
    ArrayDataSize& = TmpSize&
Else
    ArrayDataSize = 0
    MsgBox "error! " + ArchiveForm.ACOPData.status
End If
ArrayDataTimeStamp# = ArchiveForm.ACOPData.timestamp
ArrayDataKeyword$ = FSlct(TempIndex%).PropName

' compare the REQUESTED and the RETURNED time stamps...
Debug.Print ArchiveTS# - ArrayDataTimeStamp#, ArchiveForm.ACOPPlot(0).CTIME(ArchiveTS#), _
                    ArchiveForm.ACOPPlot(0).CTIME(ArrayDataTimeStamp#)

' Show difference in the stamps....
ArchiveForm.LabelTime(2).Caption = STR$(ArrayDataTimeStamp# - ArchiveTS#)

' prepare axis for reference display.....
ReDim RefAxisData!(TmpSize&)
RefAxisData!(0) = -0.5
For i% = 1 To TmpSize&
    RefAxisData!(i%) = RefAxisData!(i% - 1) + 1
Next i%

End Sub

Public Sub PlotTheArrayData()
Dim rcc&
Dim i%, TmpSelectedIndex%, TempIndex%

TmpSelectedIndex% = SelectedTrace%(0)
If TmpSelectedIndex% = -1 Then Exit Sub

TempIndex% = IndexToDName%(TmpSelectedIndex%)

ArchiveForm.ACOPPlot(2).ClearScreen

If ArrayPlotIndex& < 0 Then
    If (FSlct(TempIndex%).arrayType And AT_TRACE) = AT_TRACE Then
        ArchiveForm.ACOPPlot(2).DisplayMode = PolyLineDots
    Else
        ArchiveForm.ACOPPlot(2).DisplayMode = SimpleHistogram
    End If
    
    ArchiveForm.ACOPPlot(2).DrawWidth = 2
    ArchiveForm.ACOPPlot(2).ClearScreen
    ArchiveForm.ACOPPlot(2).xmin = -0.5
    ArchiveForm.ACOPPlot(2).xmax = ArrayDataSize&
    If ArchiveForm.SyncZoom.Value = vbChecked Then
        ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
        ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
    Else
        ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
        ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
    End If
    ArrayPlotIndex& = ArchiveForm.ACOPPlot(2).Draw(PlotArrayData!, , , , ArrayDataSize&)
    'ArrayPlotIndex& = ArchiveForm.ACOPPlot(2).Draw(PlotArrayData!, ArrayXAxis!, , , ArrayDataSize&)
Else
    rcc& = ArchiveForm.ACOPPlot(2).RefreshScreen(PlotArrayData!, ArrayPlotIndex&, ArrayDataSize&)
End If

' Set markers on array plot?
ArchiveForm.ACOPPlot(2).Tagging = True
ArchiveForm.ACOPPlot(2).ClearTags
For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    If FSlct(i%).Active = True Then
        If (FSlct(TempIndex%).PropName = FSlct(i%).PropName) And (FSlct(TempIndex%).HistoryServerName = FSlct(i%).HistoryServerName) Then
            'Set a marker
            If FSlct(i%).DispColor = 0 Then
                ArchiveForm.ACOPPlot(2).TagColor = Gray
            Else
                ArchiveForm.ACOPPlot(2).TagColor = FSlct(i%).DispColor
            End If
            ArchiveForm.ACOPPlot(2).IsTagged FSlct(i%).DeviceIndex, True
        End If
    End If
Next i%

'ArrayDataTimeStamp& , ArrayDataKeyword$

ACOPCaptionText$(2) = FSlct(SelectedTrace%(0)).PropDesc ' ArrayDataKeyword$
ArchiveForm.ACOPPlot(2).ForeColor = vbBlack
ArchiveForm.ACOPPlot(2).Caption = ACOPCaptionText$(2) + " at " + ArchiveForm.ACOPPlot(2).CTIME(ArrayDataTimeStamp#)

ArchiveForm.ACOPPlot(2).YAxisLabel = FSlct(SelectedTrace%(0)).PropUnits

'ArchiveForm.ACOPPlot(2).ClearTags
'ArchiveForm.ACOPPlot(2).TagColor = vbGreen

If ArchiveForm.ChkAuto(0).Value = vbChecked Or ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
Else
    'ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
    'ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
End If

If ReferenceTS# = 0 Then
    ArchiveForm.LabelTime(1).Caption = "No Reference"
End If

Call DrawMarker

End Sub

Public Sub ScaleArrayData()
Dim ii%, Delta!, InvDelta!, ZeroOffset!, tmpFaktor!
Dim ScaleMax!, ScaleMin!, TempSize%
Dim TempIndex%, tmpCopyBytes&

TempIndex% = SelectedTrace%(0)
If TempIndex% = -1 Then Exit Sub

TempSize% = FSlct(TempIndex%).PropSize

Select Case ScalingMode%
Case AbsoluteScale:
        tmpCopyBytes& = TempSize% * 4
        Call MEMCPYL(PlotArrayData(0), ArrayData(0), tmpCopyBytes&)

Case RelativeScale:
        ' Need to scale the data consistent with MainPlot....
        ScaleMax! = FSlct(TempIndex%).PlotMaxValue
        ScaleMin! = FSlct(TempIndex%).PlotMinValue
                
        ' To scale the data properly....
        If FSlct(TempIndex%).VPlot = "LOG" Then
            If ScaleMin! <= 0 Then ScaleMin! = 0.01
            If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
            Delta! = (Log(ScaleMax!) - Log(ScaleMin!))
            If FSlct(TempIndex%).VMin = 0 Then FSlct(TempIndex%).VMin = 1E-20
            ZeroOffset! = Log(ScaleMin!)
        Else
            Delta! = ScaleMax! - ScaleMin!
            ZeroOffset! = ScaleMin!
        End If
        
        
        If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = 100 / Delta!
        ' Use the scale-factor in the form for the GRAPHICS!
        InvDelta! = InvDelta! * 1 'Val(ArchiveForm.Faktor(TempDNameIndex%).text)
                    
        ' Plotting "mode"
        If FSlct(TempIndex%).VPlot = "LOG" Then
            For ii% = 0 To TempSize% - 1
                If ArrayData!(ii%) > 0 Then
                    PlotArrayData!(ii%) = (Log(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
                Else
                    PlotArrayData!(ii%) = 0
                End If
            Next ii%
        ElseIf FSlct(TempIndex%).VPlot = "ABS" Then
            For ii% = 0 To TempSize% - 1
                PlotArrayData!(ii%) = (Abs(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
            Next ii%
        ElseIf FSlct(TempIndex%).VPlot = "SLOG" Then
            tmpFaktor! = 1
            For ii% = 0 To TempSize% - 1
                If PlotArrayData!(ii%) > 0 Then
                    ii% = ii%
                End If
                PlotArrayData!(ii%) = (ArrayData!(ii%) * tmpFaktor! - ZeroOffset!) * InvDelta!
            Next ii%
        Else
            For ii% = 0 To TempSize% - 1
               PlotArrayData!(ii%) = (ArrayData!(ii%) - ZeroOffset!) * InvDelta!
            Next ii%
        End If
End Select

End Sub

Public Sub DoTheArrayData()

' Is it necessary to do anything?
If SelectedTrace%(ActivePlot%) = -1 Then Exit Sub
If FSlct(SelectedTrace%(ActivePlot%)).PropSize < 2 Then Exit Sub

Call ReadArrayData
Call ScaleArrayData
Call PlotTheArrayData

End Sub

Function HistoryPropConfigLoad() As Integer
Dim col_Context%, col_Server%, col_Property%, col_DeviceName%, col_Desc%
Dim col_Units%, col_PlotMin%, col_PlotMax%, tmpDeviceName$
'Dim filename$
Dim i%, j%, a$, p%, tok$, nparam%, type_done, rc%
Dim tmpXPrpQuery As XPropertyQuery, TmpDName$, TmpValStr$, iAnswer%, tmpI%
Dim tmpLongLen&, tmpRC%, rcc&, tmpLong&, tmpText$

Dim col_ArchData%, col_ArchHistory%, col_ArchProperty%
Static done As Boolean

On Error GoTo ErrorRoutine

HistoryPropConfigLoad = 0
ArchiveForm.ListProps.Clear

ArchiveForm.LabelProgress(1).Visible = False
ArchiveForm.ProgressLoad(1).Visible = False
'DoEvents

If ArchiveMode% = CArchivers Then Exit Function
tmpI% = 1

ArchiveForm.LabelProgress(1).Visible = True
ArchiveForm.LabelProgress(1).Caption = "Loading History Configurations"
ArchiveForm.ProgressLoad(1).Visible = True
'DoEvents
                        
tmpLongLen& = Len(ConfigStruct(0))
If tmpLongLen& = 0 Then MsgBox "ERROR! in HistoryPropConfigLoad! "
If Not done Then
    tmpRC% = FILLSTRUCT("HstCfg", tmpLongLen&, 1, CF_NULL)

    tmpRC% = AddFieldToStruct("HstCfg", 0, 32, CF_TEXT, "context")
    tmpRC% = AddFieldToStruct("HstCfg", 32, 32, CF_TEXT, "server")
    tmpRC% = AddFieldToStruct("HstCfg", 64, 64, CF_TEXT, "device")
    tmpRC% = AddFieldToStruct("HstCfg", 128, 64, CF_TEXT, "property")
    tmpRC% = AddFieldToStruct("HstCfg", 192, 16, CF_TEXT, "units")
    tmpRC% = AddFieldToStruct("HstCfg", 208, 32, CF_TEXT, "description") '"help")
    tmpRC% = AddFieldToStruct("HstCfg", 240, 1, CF_LONG, "index")
    tmpRC% = AddFieldToStruct("HstCfg", 244, 1, CF_LONG, "subIndex")
    tmpRC% = AddFieldToStruct("HstCfg", 248, 1, CF_FLOAT, "scale")
    tmpRC% = AddFieldToStruct("HstCfg", 252, 1, CF_FLOAT, "offset")
    tmpRC% = AddFieldToStruct("HstCfg", 256, 1, CF_FLOAT, "max")
    tmpRC% = AddFieldToStruct("HstCfg", 260, 1, CF_FLOAT, "min")
    tmpRC% = AddFieldToStruct("HstCfg", 264, 1, CF_LONG, "plot")
    tmpRC% = SealTaggedStruct("HstCfg", 268, 100)

    done = True
End If

With ArchiveForm.ACOPData
    .deviceContext = gArchiveServerInfo(SelectedContext%).context
    .DeviceGroup = "HISTORY"
    .deviceName = "properties" 'CONFIGFile$(SelectedHistoryDir%)
    .deviceProperty = HistoryConfigs(SelectedHistoryDir%).name '"CONFIGURATION"
    .AccessMode = "READ"
    .AccessRate = DefaultComTimeOut&
    Dim TmpMaxProps%
    TmpMaxProps% = 300
    rcc& = .Execute(ConfigStruct(0).ctx(0), TmpMaxProps%, "STRUCT/HstCfg")
    If rcc& Then
        MsgBox .status
    Else
        rcc& = .GetDataSize(tmpLong&)
        If tmpLong& > 260 Then
            ' Length is in BYTES!
            NElem%(SelectedHistoryDir%) = tmpLong& / tmpLongLen&
        Else
            NElem%(SelectedHistoryDir%) = tmpLong&
        End If
        
        ArchiveForm.ProgressLoad(1).max = NElem%(SelectedHistoryDir%)
        ArchiveForm.ProgressLoad(1).Value = 0

        For i% = 0 To NElem%(SelectedHistoryDir%) - 1
            With HistoryKeywords(i%)
                tmpText$ = BSTR(ConfigStruct(i%).ctx())
                .ContextName = tmpText$
                tmpText$ = BSTR(ConfigStruct(i%).srv())
                .ServerName = tmpText$
                .HistoryName = tmpText$

                tmpText$ = BSTR(ConfigStruct(i%).prp())
                .PropName = tmpText$
                
                ' Kludge because the "help" field is empty!
                tmpText$ = BSTR(ConfigStruct(i%).desc())
                .PropDesc = tmpText$
                If .PropDesc = "" Then .PropDesc = .PropName
        
                ArchiveForm.ProgressLoad(1).Value = i%
                'DoEvents
                
'                    TmpText$ = BSTR(ConfigStruct(i%).units())
'                    .units = TmpText$
'
'                    .DeviceIndex = ConfigStruct(i%).idx
'                    .DeviceSubIndex = ConfigStruct(i%).sidx
'                    .Min = ConfigStruct(i%).Min
'                    .Max = ConfigStruct(i%).Max
'
'                    .AxOffset = ConfigStruct(i%).Offset
'                    .AxScale = ConfigStruct(i%).scale
'                    .plottype = ConfigStruct(i%).plot
'
'                    TmpText$ = BSTR(ConfigStruct(i%).dev())
'                    If TmpText$ = "" Then TmpText$ = "#" + Format$(.DeviceIndex, "0")
'                    .deviceName = TmpText$
'
'                    If .PropertyName = "" Then
'                        Exit For
'                    End If
            End With
        Next i%
    End If
End With

ArchiveForm.LabelProgress(1).Caption = "Loading Keyword Information"
ArchiveForm.ProgressLoad(1).max = NElem%(SelectedHistoryDir%)
ArchiveForm.ProgressLoad(1).Value = 0

For i% = 0 To NElem%(SelectedHistoryDir%) - 1
    With HistoryKeywords(i%)
TryAgain:
        TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/"
        rc% = GetFullPropertyInformation(TmpDName$, .PropName, tmpXPrpQuery)
        If rc% <> 0 Then
            iAnswer% = MsgBox("Error Getting Full-Property Info from Server: " + TmpDName + "  Property: " + .PropName + " : " + RPCERROR(rc%), vbAbortRetryIgnore)
            If iAnswer% = vbRetry Then
                GoTo TryAgain
            ElseIf iAnswer% = vbAbort Then
                Close #1
                NElem%(SelectedHistoryDir%) = i%
                HistoryPropConfigLoad = i%
                ArchiveForm.LabelProgress(1).Caption = "Abort Load Keyword Info"
                Exit Function
            Else
            End If
        End If
        
        If .ServerName = "ARCHIVER" Then
            .HistoryName = "HISTORY"
            .ServerName = "ARCHIVER"
        ElseIf .HistoryName = "HISTORY" Then
            .ServerName = "ARCHIVER"
        Else
        End If
        
        If .PropDesc = "" Then .PropDesc = BSTR$(tmpXPrpQuery.prpDesc)
        
        .PropUnits = BSTR$(tmpXPrpQuery.prpUnits)
        .PropMin = tmpXPrpQuery.prpMinValue
        .PropMax = tmpXPrpQuery.prpMaxValue
        .PropSize = tmpXPrpQuery.prpSize
        .arrayType = tmpXPrpQuery.prpArrayType
        .xmax = tmpXPrpQuery.rangeMaxValue
        .xmin = tmpXPrpQuery.rangeMinValue
        .XUnits = tmpXPrpQuery.rangeUnits
    
        If Trim(.PropDesc) <> "" Then
            ArchiveForm.ListProps.AddItem STR$(i% + 1) + ".  " + .PropDesc
        Else
            ArchiveForm.ListProps.AddItem STR$(i% + 1) + ".  " + .PropDesc + " (" + .PropName + ")"
        End If
    
        ArchiveForm.ProgressLoad(1).Value = i%
    End With
Debug.Print "Number = " + STR$(i%)
Next i%
HistoryPropConfigLoad = NElem%(SelectedHistoryDir%)
ArchiveForm.LabelProgress(1).Visible = False
ArchiveForm.ProgressLoad(1).Visible = False
Exit Function
ErrorRoutine:
Debug.Print
ArchiveForm.LabelProgress(1).Visible = False
ArchiveForm.ProgressLoad(1).Visible = False
End Function



Public Function ScaleForBits(Index%, StatusValue&) As Single
Dim tmpMask&, tmpFaktor!, tmpValue!

' Convert status value to LONG and THEN do bit-mask/scaling?
If Index = 5 Then
    Debug.Print
End If

If FSlct(Index%).DeviceSubIndex = 13 Then
    Debug.Print
End If

'tmpFaktor! = 1
tmpFaktor! = 0.5
tmpMask& = SelectBits&(FSlct(Index%).DeviceSubIndex - 1)

'tmpValue! = 2 * Index% + (StatusValue& And tmpMask&) / tmpMask&
tmpValue! = Index% + tmpFaktor! * ((StatusValue& And tmpMask&) / tmpMask&) + 0#

ScaleForBits! = tmpValue!
End Function

Public Sub RedimArrays()

ReDim ArchDataBuffer(MaxPoints, MaxCurves * 2)
ReDim ArchData(MaxPoints, MaxCurves * 2)
ReDim ArchTimeBins#(MaxPoints, MaxCurves * 2)
ReDim PlotData(MaxPoints, MaxCurves * 2)

ReDim filterDataBuffer(MaxPoints, 10)
ReDim filterTextBuffer(MaxPoints / 10, 10)

ReDim ydat(MaxPoints, MaxCurves)
ReDim xdat0&(MaxPoints)
ReDim ydat0!(MaxPoints)
ReDim xdat1&(MaxPoints)
ReDim ydat1!(MaxPoints)
ReDim xdat2(MaxPoints)
ReDim ydat2(MaxPoints)
ReDim ydat3(MaxPoints)

End Sub
