Attribute VB_Name = "fecadmin"
Option Explicit

Type RPCDataStruct
  FecName As String ' 16
  'reserved(4) As Byte
  ExportName As String '16
  EqName As String ' 7
  context As String '16
  alarmSystem As Integer
End Type
Global RPCDataStructBytes(61) As Byte

Type RPCFecStruct
  name As String ' 16
  'reserved(2) As Byte
  Port As Integer ' byte * 2
  Network(3) As Byte
  Node(5) As Byte
  ImmediateAddress(5) As Byte
  IP As String ' 16
  'PortOffset as byte
  IPh_addr(3) As Byte
  Prot As Integer
End Type
Global RPCFecStructBytes(59) As Byte

Type RPCFecExStruct
  os As String '12
  desc As String ' [64];
  loc As String ' [32];
  hdw As String ' [32];
  sub As String ' [16];
  resp As String ' [32];
End Type
Global RPCFecExStructBytes(187) As Byte

Type GrpMember
  srv(31) As Byte
  devPrefix(7) As Byte
  devPostfix(7) As Byte
  idx As Long
End Type

Function AddServerToGroup(context As String, server As String, group As String, subsystem As String, groupIndex As Integer, devPrefix As String, devPostfix As String) As Integer
Dim i As Integer, n As Integer
Dim cc As Integer
Dim dout As DBLK, din As DBLK
Dim g(7) As NAME32

If Len(context) = 0 Or Len(group) = 0 Or Len(server) = 0 Then
  AddServerToGroup = argument_list_error
  Exit Function
End If


If Len(devPrefix) > 0 Or Len(devPrefix) > 0 Then
  n = 7
Else
  n = 5
End If

dout.dArrayLength = 0: dout.dFormat = CF_NULL
din.dArrayLength = n: din.dFormat = CF_NAME32

BARR g(0).nam, server
BARR g(1).nam, group
BARR g(2).nam, context
BARR g(3).nam, STR(groupIndex)
BARR g(4).nam, subsystem
BARR g(5).nam, devPrefix
BARR g(6).nam, devPostfix

cc = T_EXECLINK("/SITE/GENS", "JOIN", dout, 0, din, g(0), CA_WRITE, 500)
AddServerToGroup = cc

End Function


Sub fillRPCDataBytes(rpcdat As RPCDataStruct)
Dim buf(32) As Byte
BARR buf, rpcdat.FecName
Utils.MEMCPY RPCDataStructBytes(0), buf(0), 16
BARR buf, rpcdat.ExportName
Utils.MEMCPY RPCDataStructBytes(21), buf(0), 16
BARR buf, rpcdat.EqName
Utils.MEMCPY RPCDataStructBytes(37), buf(0), 6
BARR buf, rpcdat.context
Utils.MEMCPY RPCDataStructBytes(44), buf(0), 16
Utils.MEMCPY RPCDataStructBytes(60), rpcdat.alarmSystem, 2
End Sub

Sub fillRPCFecBytes(rpcfec As RPCFecStruct)
Dim buf(32) As Byte
Dim ipbytes(3) As Byte
Dim i As Integer, p As Integer
Dim seg As String, tmp As String

tmp = rpcfec.IP
p = InStr(tmp, ".")
seg = Left$(tmp, p - 1)
ipbytes(0) = Val(seg)
tmp = Right$(tmp, Len(tmp) - p)
p = InStr(tmp, ".")
seg = Left$(tmp, p - 1)
ipbytes(1) = Val(seg)
tmp = Right$(tmp, Len(tmp) - p)
p = InStr(tmp, ".")
seg = Left$(tmp, p - 1)
ipbytes(2) = Val(seg)
seg = Right$(tmp, Len(tmp) - p)
ipbytes(3) = Val(seg)

BARR buf, rpcfec.name
Utils.MEMCPY RPCFecStructBytes(0), buf(0), 16
Utils.MEMCPY RPCFecStructBytes(19), rpcfec.Port, 2
BARR buf, rpcfec.IP
Utils.MEMCPY RPCFecStructBytes(37), buf(0), 16
Utils.MEMCPY RPCFecStructBytes(53), rpcfec.Port, 1
Utils.MEMCPY RPCFecStructBytes(54), ipbytes(0), 4

End Sub

Sub fillRPCFecExBytes(fecex As RPCFecExStruct)
Dim buf(72) As Byte
BARR buf, fecex.os
Utils.MEMCPY RPCFecExStructBytes(0), buf(0), 12
BARR buf, fecex.desc
Utils.MEMCPY RPCFecExStructBytes(12), buf(0), 64
BARR buf, fecex.loc
Utils.MEMCPY RPCFecExStructBytes(76), buf(0), 32
BARR buf, fecex.hdw
Utils.MEMCPY RPCFecExStructBytes(108), buf(0), 32
BARR buf, fecex.sub
Utils.MEMCPY RPCFecExStructBytes(140), buf(0), 16
BARR buf, fecex.resp
Utils.MEMCPY RPCFecExStructBytes(156), buf(0), 32

End Sub


Function FlushNonResponders(ByVal context As String) As Long
Dim cc As Integer
Dim dout As DBLK, din As DBLK

dout.dArrayLength = 1: dout.dFormat = CF_NULL
din.dArrayLength = 1: din.dFormat = CF_NULL

cc = T_EXECLINK("/SITE/ENS/" + context, "REMOVENOTRUNNING", dout, 0, din, 0, CA_WRITE, 500)

If cc <> 0 Then
  FlushNonResponders = -cc
Else
  FlushNonResponders = 0
End If

End Function

Function GetAllowedDeadTime() As Long
Dim cc As Integer
Dim dout As DBLK, din As DBLK
Dim dt As Long

dout.dArrayLength = 1: dout.dFormat = CF_LONG
din.dArrayLength = 0: din.dFormat = CF_NULL

cc = T_EXECLINK("/SITE/ENS", "ALLOWEDDEADTIME", dout, dt, din, 0, CA_READ, 500)

If cc <> 0 Then
  GetAllowedDeadTime = -cc
Else
  dt = dt / 86400
  GetAllowedDeadTime = dt
End If
End Function
Function GetGroupMembers(context As String, group As String, members() As String) As Integer
Dim i As Integer
Dim cc As Integer
Dim dout As DBLK, din As DBLK
Dim g(512) As NAME64, ctx As NAME32
Dim gm(100) As GrpMember
Dim parts() As String
Dim add As String, pref As String, postf As String
Static done As Boolean

If Not done Then
  done = True
  registerStucts
End If

If Len(context) = 0 Or Len(group) = 0 Then
  GetGroupMembers = argument_list_error
  Exit Function
End If
'dout.dArrayLength = 512: dout.dFormat = CF_NAME64
dout.dArrayLength = 100: dout.dFormat = CF_STRUCT: BARR dout.dTag, "GrpMbr"
din.dArrayLength = 1: din.dFormat = CF_NAME32

BARR ctx.nam, context
cc = T_EXECLINK("/SITE/GENS/" + group, "MEMBERS", dout, gm(0), din, ctx, CA_READ, 500)
GetGroupMembers = cc

If cc <> 0 Then
  GetGroupMembers = cc
  Exit Function
End If
If dout.dArrayLength < 1 Then
  GetGroupMembers = non_existent
  Exit Function
End If
ReDim members(dout.dArrayLength - 1)
For i = 0 To dout.dArrayLength - 1
'  members(i) = BSTR(g(i).nam)
  pref = BSTR(gm(i).devPrefix)
  postf = BSTR(gm(i).devPostfix)
  If Len(pref) > 0 Then add = pref + "<device>"
  If Len(postf) > 0 Then
    If Len(add) = 0 Then add = "<device>"
    add = add + postf
  End If
  members(i) = BSTR(gm(i).srv) + " (" + Trim$(STR(gm(i).idx)) + ") " + add
Next

End Function

Function GetGroups(context As String, groups() As String) As Integer
Dim n As Integer, i As Integer
Dim cc As Integer
Dim dout As DBLK, din As DBLK
Dim g(512) As NAME64
Dim ctx As String, parts() As String

dout.dArrayLength = 512: dout.dFormat = CF_NAME64
din.dArrayLength = 0: din.dFormat = CF_NULL

cc = T_EXECLINK("/SITE/GENS", "GROUPS", dout, g(0), din, 0, CA_READ, 500)
GetGroups = cc

If cc <> 0 Then Exit Function

ReDim groups(dout.dArrayLength)
n = 0
For i = 0 To dout.dArrayLength - 1
  parts = Split(BSTR(g(i).nam), "/")
  If UBound(parts) > 1 Then
    ctx = parts(1)
    If ctx = context Then
      groups(n) = parts(2)
      n = n + 1
    End If
  End If
Next

If n = 0 Then Exit Function
ReDim Preserve groups(n - 1)

End Function

Sub registerStucts()
  AddFieldToStruct "GrpMbr", 0, 32, CF_TEXT, "name"
  AddFieldToStruct "GrpMbr", 32, 8, CF_TEXT, "devPrefix"
  AddFieldToStruct "GrpMbr", 40, 8, CF_TEXT, "devPostfix"
  AddFieldToStruct "GrpMbr", 48, 1, CF_INT32, "index"
  SealTaggedStruct "GrpMbr", 52, 100
End Sub

Function RemoveServerFromGroup(context As String, server As String, group As String) As Integer
Dim i As Integer
Dim cc As Integer
Dim dout As DBLK, din As DBLK
Dim g(5) As NAME32

If Len(context) = 0 Or Len(group) = 0 Or Len(server) = 0 Then
  RemoveServerFromGroup = argument_list_error
  Exit Function
End If
dout.dArrayLength = 0: dout.dFormat = CF_NULL
din.dArrayLength = 3: din.dFormat = CF_NAME32

BARR g(0).nam, server
BARR g(1).nam, group
BARR g(2).nam, context

cc = T_EXECLINK("/SITE/GENS", "SEPARATE", dout, 0, din, g(0), CA_WRITE, 500)
RemoveServerFromGroup = cc

End Function

Function SetAllowedDeadTime(ByVal deadTime As Long) As Long
Dim cc As Integer
Dim dout As DBLK, din As DBLK
Dim dt As Long

dout.dArrayLength = 1: dout.dFormat = CF_LONG
din.dArrayLength = 1: din.dFormat = CF_LONG

dt = deadTime * 86400
cc = T_EXECLINK("/SITE/ENS", "ALLOWEDDEADTIME", dout, dt, din, dt, CA_READ + CA_WRITE, 500)

If cc <> 0 Then
  SetAllowedDeadTime = -cc
Else
  SetAllowedDeadTime = dt / 86400
End If

End Function

