Imports System
Imports System.Threading
Imports System.ComponentModel
Imports System.Runtime.InteropServices
Imports tine
Public Class OpHist
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure DclState
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public devname() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public statetag() As Char
    Public machine As Integer
    Public reserved As Integer
  End Structure
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure DclProc
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public devname() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public structfile() As Char
    Public machine As Integer
    Public nstates As Integer
  End Structure
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure PrfCfg
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public name() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
      Public type() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=512)> _
      Public states() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
      Public color() As Char
  End Structure
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure McaCfg
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
      Public ctx() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
      Public srv() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public dev() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public prp() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
      Public tag() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public desc() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public shell() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public prpAlias() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public partner() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> _
      Public reserved() As Char
    Public append As Integer
  End Structure
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure DAQRec
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=80)> _
      Public fn_key() As Char ' /* keyword structure file name */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=80)> _
      Public fn_inp() As Char ' /* input file name */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
      Public ctx() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
      Public srv() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public dev() As Char
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public prp() As Char
    Public len As Integer ' /* length of call */
    Public fmt As Integer ' /* call format */
    Public hbt As Integer ' /* archiving heartbeat (not to be exceeded) */
    Public tmr As Integer ' /* polling interval */
    Public infmt As Integer ' /* input data format (if any) */
    Public inlen As Integer ' /* number of input data points */
    Public opt As Integer ' /* option word */
    Public active As Integer ' /* is table entry active */
    Public rec As Integer ' /* entry in record table */
  End Structure
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure DAQPrm
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public key() As Char ' /* parameter name */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
      Public units() As Char '       /* units */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public desc() As Char ' /* description */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
      Public plot() As Char '        /* plot style (LOG, LIN, etc.) */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public boundTo() As Char  ' /* bound to parameter */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
      Public subs() As Char  ' /* parameter subsystem */
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public assoc() As Char  '/* associate dev names to */
    Public fmt As Integer '/* allowable format */
    Public size As Integer '/* data array size assuming given format */
    Public scaleFactor As Single
    Public scaleOffset As Single
    Public maximum As Single
    Public minimum As Single
    Public aTolerance As Single
    Public pTolerance As Single
  End Structure

  Dim tnull As TDataType
  Public procs() As Proc
  Public states() As State
  Public Sub addNewState(ByVal newState As State)
    Dim n As Integer
    Dim i As Integer
    n = UBound(states)
    For i = 0 To n
      If newState.name = states(i).name Then Exit Sub
    Next
    ReDim Preserve states(n + 1)
    states(n + 1) = newState
    StatesList.Items.Add(newState.name)
  End Sub
  Dim needToUpdatedArchiver As Boolean
  Public Sub addNewProc(ByVal newProc As Proc)
    Dim n As Integer
    Dim i As Integer
    n = UBound(procs)
    For i = 0 To n
      If newProc.name = procs(i).name Then Exit Sub
    Next
    ReDim Preserve procs(n + 1)
    procs(n + 1) = newProc
    ProcList.Items.Add(newProc.name)
    needToUpdatedArchiver = True
  End Sub
  Private Const STATE_BUFFER_SIZE = 100
  Private Const PROC_BUFFER_SIZE = 50
  Private Const CONFIGS_BUFFER_SIZE = 20
  Private Const PROFILES_BUFFER_SIZE = 50
  Private Const DAQ_BUFFER_SIZE = 100
  Private Const DAQ_SET_SIZE = 6
  Dim declProcs(PROC_BUFFER_SIZE - 1) As DclProc
  Dim nDeclProcs As Integer
  Dim declStates(STATE_BUFFER_SIZE - 1) As DclState
  Dim nDeclStates As Integer
  Public configs(CONFIGS_BUFFER_SIZE - 1) As CFG
  Dim mcaCfgs(CONFIGS_BUFFER_SIZE - 1) As McaCfg
  Dim nConfigs As Integer
  Dim profiles(PROFILES_BUFFER_SIZE - 1) As String
  Dim prfCfgs(PROFILES_BUFFER_SIZE - 1) As PrfCfg
  Dim nProfiles As Integer
  Dim daqRecs(DAQ_BUFFER_SIZE - 1) As DAQRec
  Dim daqRecsActive(DAQ_SET_SIZE - 1) As DAQRec
  Dim daqParams(0) As DAQPrm
  Public paramPrp As List(Of String)
  Private ttsDclProc As TTaggedStruct
  Private ttsDclState As TTaggedStruct
  Private ttsMcaCfg As TTaggedStruct
  Private ttsPrfCfg As TTaggedStruct
  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    tnull = New TDataType(IntPtr.Zero)
    paramPrp = New List(Of String)
    TDataType.RegisterStructure(declProcs)
    TDataType.RegisterStructure(declStates)
    TDataType.RegisterStructure(mcaCfgs)
    TDataType.RegisterStructure(prfCfgs)
    TDataType.RegisterStructure(daqRecs)
    TDataType.RegisterStructure(daqParams)
    GetStateServerContexts()
  End Sub
  Dim stateServerContexts() As String
  Dim nStateServerContexts As Integer
  Sub GetStateServerContexts()
    Dim rc As Integer, i As Integer
    rc = GetEquipmentDeviceContextsForServer("STATE", stateServerContexts, nStateServerContexts)
    If rc <> 0 Then
      MsgBox("Cannot acquire alarm server context information!" + vbNewLine + ErrorToString(rc), vbOKOnly, "GetStateServerContexts")
      Exit Sub
    End If

    'Dim tgt As Integer
    For i = 0 To nStateServerContexts - 1
      contextCombo.Items.Add(stateServerContexts(i))
    Next
    contextCombo.SelectedIndex = 0
    'contextCombo.ListIndex = tgt
  End Sub
  Function GetConfigNamesFromServer(ByVal devPrp As String, ByRef cfgs() As String, ByRef listsize As Integer) As Integer
    Dim doutt As TDataType
    Dim n As Integer
    Dim devSrv As String
    Dim nams() As NAME64, tgtnam(0) As NAME64
    Dim rc As Integer, i As Integer

    defaultContext = contextCombo.SelectedItem()
    devSrv = "/" + defaultContext + "/STATE"
    ReDim nams(25)
    Dim lnk As TLink
    doutt = New TDataType(nams)
    lnk = New TLink(devSrv, devPrp + ".NAM", doutt, tnull, Access.CA_READ + Access.CA_MUTABLE)
    rc = lnk.Execute(300)
    If rc Then GoTo exitFunction
    n = doutt.GetDataArrayLength()
    ReDim cfgs(n)
    For i = 0 To n - 1
      cfgs(i) = nams(i).GetName
      If Len(cfgs(i)) = 0 Then Exit For
    Next
exitFunction:
    listsize = i
    GetConfigNamesFromServer = rc
  End Function
  Function GetDaqRecordsFromServer() As Integer
    Dim doutt As TDataType, dint As TDataType
    Dim n As Integer
    Dim rc As Integer, i As Integer, k As Integer
    Dim dev As String
    Dim lnk As TLink

    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/HISTORY/"
    doutt = New TDataType(daqRecs)
    dint = New TDataType("*.Procedure*".ToCharArray())
retryRecordInfo:
    lnk = New TLink(dev, "RECORD.INFO", doutt, dint, Access.CA_READ + Access.CA_MUTABLE)
    rc = lnk.Execute(300)
    If rc Then
      If MsgBox("error retrieving archive record information : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
        GoTo retryRecordInfo
      End If
      GoTo exitFunction
    End If
    n = doutt.GetDataArrayLength()
    For i = 0 To n - 1
      If daqRecs(i).active Then
        If k >= DAQ_SET_SIZE Then
          MsgBox("received more active DAQ sets than expected !")
          Exit Function
        End If
        daqRecsActive(k) = daqRecs(i)
        k = k + 1
      End If
    Next
    If k = 0 And n >= DAQ_SET_SIZE Then
      ' no active sets ?
      For i = n - DAQ_SET_SIZE To n - 1
        daqRecsActive(k) = daqRecs(i)
        k = k + 1
      Next
    End If
exitFunction:
    GetDaqRecordsFromServer = rc
  End Function
  Function SendProfileListToServer(ByVal index As Integer) As Integer
    Dim dint As TDataType
    Dim rc As Integer, i As Integer, n As Integer
    Dim dev As String
    Dim lnk As TLink
    Dim prfCfgNew(prfCfgs.Length - 1) As PrfCfg

    Dim s As String
    For i = 0 To configs(index).prfList.Length - 1
      s = New String(configs(index).prfList(i).type)
      If s.Length > 0 And Not s.Contains("deleted") Then
        prfCfgNew(n) = New PrfCfg()
        prfCfgNew(n) = configs(index).prfList(i)
        n = n + 1
      End If
    Next

    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/STATE/" + configs(index).name
    dint = New TDataType(prfCfgNew)
    dint.SetDataArrayLength(n)
    ' what about : doutt = New TDataType(ttsDclProc) (original idea?)
retrySendProfileList:
    lnk = New TLink(dev, "PROFILE", tnull, dint, Access.CA_WRITE)
    rc = lnk.Execute(300)
    If rc Then
      If MsgBox("could not send profile configurations to server : " + Str(lnk.GetStatus()), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
        GoTo retrySendProfileList
      End If
    End If
    If rc Then GoTo exitFunction
    configs(index).prfEdited = False
exitFunction:
    SendProfileListToServer = rc
  End Function
  Function GetProfileListFromServer(ByVal index As Integer) As Integer
    Dim doutt As TDataType
    Dim n As Integer
    Dim rc As Integer, i As Integer
    Dim dev As String
    Dim lnk As TLink

    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/STATE/" + configs(index).name
    doutt = New TDataType(prfCfgs)
    ' what about : doutt = New TDataType(ttsDclProc) (original idea?)
    lnk = New TLink(dev, "PROFILE", doutt, tnull, Access.CA_READ + Access.CA_MUTABLE)
    rc = lnk.Execute(300)
    If rc Then GoTo exitFunction
    n = doutt.GetDataArrayLength()
    ReDim configs(index).prfList(n - 1)
    configs(index).prfListSize = n
    For i = 0 To n - 1
      configs(index).prfList(i) = prfCfgs(i)
    Next
exitFunction:
    GetProfileListFromServer = rc
  End Function
  Function SendConfigListToServer(ByVal index As Integer) As Integer
    Dim dint As TDataType
    Dim n As Integer
    Dim rc As Integer, i As Integer
    Dim dev As String
    Dim lnk As TLink
    Dim mcaCfgNew(mcaCfgs.Length - 1) As McaCfg
    Dim s As String, p As String
    For i = 0 To configs(index).cfgList.Length - 1
      s = New String(configs(index).cfgList(i).tag)
      p = New String(configs(index).cfgList(i).prp)
      If p.Length > 0 And Not s.Contains("deleted") Then
        mcaCfgNew(n) = New McaCfg()
        mcaCfgNew(n) = configs(index).cfgList(i)
        n = n + 1
      End If
    Next
    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/STATE/" + configs(index).name
    dint = New TDataType(mcaCfgNew)
    dint.SetDataArrayLength(n)
retrySendConfigList:
    lnk = New TLink(dev, "CONFIGURATION", tnull, dint, Access.CA_WRITE + Access.CA_MUTABLE)
    rc = lnk.Execute(1000)
    If rc Then GoTo exitFunction
    If rc Then
      If MsgBox("could not send profile configurations to server : " + Str(lnk.GetStatus()), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
        GoTo retrySendConfigList
      End If
    End If
    If rc Then GoTo exitFunction
    configs(index).cfgEdited = False
exitFunction:
    SendConfigListToServer = rc
  End Function
  Function GetConfigListFromServer(ByVal index As Integer) As Integer
    Dim doutt As TDataType
    Dim n As Integer
    Dim rc As Integer, i As Integer
    Dim dev As String
    Dim lnk As TLink

    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/STATE/" + configs(index).name
    doutt = New TDataType(mcaCfgs)
    ' what about : doutt = New TDataType(ttsDclProc) (original idea?)
    lnk = New TLink(dev, "CONFIGURATION", doutt, tnull, Access.CA_READ + Access.CA_MUTABLE)
    rc = lnk.Execute(1000)
    If rc Then GoTo exitFunction
    n = doutt.GetDataArrayLength()
    ReDim configs(index).cfgList(n)
    configs(index).cfgListSize = n
    For i = 0 To n - 1
      configs(index).cfgList(i) = mcaCfgs(i)
    Next
exitFunction:
    GetConfigListFromServer = rc
  End Function
  Function GetStateListFromServer(ByRef states() As State, ByRef listsize As Integer) As Integer
    Dim doutt As TDataType
    Dim n As Integer
    Dim rc As Integer, i As Integer
    Dim dev As String
    Dim lnk As TLink

    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/STATE"
    doutt = New TDataType(declStates)
    lnk = New TLink(dev, "STATELIST", doutt, tnull, Access.CA_READ + Access.CA_MUTABLE)
    rc = lnk.Execute(1000)
    If rc Then GoTo exitFunction
    n = doutt.GetDataArrayLength()
    ReDim states(n - 1)
    For i = 0 To n - 1
      states(i) = New State()
      states(i).name = declStates(i).devname
      states(i).machine = declStates(i).machine
      states(i).tag = declStates(i).statetag
    Next
exitFunction:
    listsize = i
    GetStateListFromServer = rc
  End Function
  Function GetProcListFromServer(ByRef procs() As Proc, ByRef listsize As Integer) As Integer
    Dim doutt As TDataType
    Dim n As Integer
    Dim rc As Integer, i As Integer
    Dim dev As String
    Dim lnk As TLink

    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/STATE"
    doutt = New TDataType(declProcs)
    ' what about : doutt = New TDataType(ttsDclProc) (original idea?)
    lnk = New TLink(dev, "PROCLIST", doutt, tnull, Access.CA_READ + Access.CA_MUTABLE)
    rc = lnk.Execute(1000)
    If rc Then GoTo exitFunction
    n = doutt.GetDataArrayLength()
    ReDim procs(n - 1)
    For i = 0 To n - 1
      procs(i) = New Proc()
      procs(i).name = declProcs(i).devname
      procs(i).machine = declProcs(i).machine
      procs(i).nstates = declProcs(i).nstates
      procs(i).states = New List(Of String)
    Next
exitFunction:
    listsize = i
    GetProcListFromServer = rc
  End Function
  Function GetNameListFromServer(ByVal devSrv As String, ByVal devPrp As String, ByVal tgt As String, ByRef names() As String, ByRef listsize As Integer) As Integer
    Dim doutt As TDataType
    Dim dint As TDataType
    Dim n As Integer
    Dim nams() As NAME64, tgtnam(0) As NAME64
    Dim rc As Integer, i As Integer
    If Len(devSrv) = 0 Or Len(devPrp) = 0 Then
      GetNameListFromServer = Errors.argument_list_error
      Exit Function
    Else
      If Len(tgt) > 0 Then
        tgtnam(0) = New NAME64()
        tgtnam(0).SetName(tgt)
        dint = New TDataType(tgtnam)
      Else
        dint = tnull
      End If
    End If
    ReDim nams(1000)
    Dim lnk As TLink
    doutt = New TDataType(nams)
    lnk = New TLink(devSrv, devPrp, doutt, dint, Access.CA_READ + Access.CA_MUTABLE)
    rc = lnk.Execute(1000)
    'rc = lnk.Execute(devSrv, devPrp, doutt, dint, Access.CA_READ + Access.CA_MUTABLE, 3000)
    If rc Then GoTo exitFunction
    n = doutt.GetDataArrayLength()
    ReDim names(n)
    For i = 0 To n - 1
      names(i) = nams(i).GetName
      If Len(names(i)) = 0 Then Exit For
    Next
exitFunction:
    listsize = i
    GetNameListFromServer = rc
  End Function
  Function GetEquipmentDeviceContextsForServer(ByVal devServer As String, ByRef contexts() As String, ByRef ncontexts As Integer) As Integer
    Dim rc As Integer
    rc = GetNameListFromServer("/SITE/ENS", "CONTEXTS", devServer, contexts, ncontexts)
    Return rc
  End Function
  Dim defaultContext As String
  Private Sub contextCombo_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles contextCombo.SelectedIndexChanged
    Dim nlst As Integer
    Dim rc As Integer, i As Integer
    Dim prclst() As Proc
    Dim statlst() As State

    rc = GetStateListFromServer(statlst, nlst)
    If rc = 0 Then
      StatesList.Items.Clear()
      ReDim states(nlst - 1)
      For i = 0 To nlst - 1
        states(i) = statlst(i)
        StatesList.Items.Add(states(i).name)
      Next
      ' If (nlst > 0) Then StatesList.SelectedIndex = 0
    End If

    rc = GetProcListFromServer(prclst, nlst)
    If rc = 0 Then
      ProcList.Items.Clear()
      ReDim procs(nlst - 1)
      For i = 0 To nlst - 1
        procs(i) = prclst(i)
        'procs(i).name = plst(i)
        ProcList.Items.Add(procs(i).name)
        getStatesForProc(i)
      Next
      If (nlst > 0) Then
        If StatesList.Items.Count > 0 Then StatesList.SelectedIndex = 0 Else ProcList.SelectedIndex = 0
      End If
      'ProcList.SelectedIndex = 0
    End If

    Dim nams() As String
    rc = GetConfigNamesFromServer("CONFIGURATION", nams, nlst)
    If rc = 0 Then
      CfgList.Items.Clear()
      nConfigs = nlst
      ReDim configs(nlst - 1)
      For i = 0 To nlst - 1
        configs(i) = New CFG()
        configs(i).name = nams(i)
        CfgList.Items.Add(configs(i).name)
      Next
      If (nlst > 0) Then CfgList.SelectedIndex = 0
    End If

    Dim dev As String
    Dim plst() As String
    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/ARCHIVER"
    rc = GetNameListFromServer(dev, "TAGS", "", plst, nlst)

    If rc = 0 Then
      paramPrp.Clear()
      For i = 0 To nlst - 1
        If Not plst(i).EndsWith(".NAM") Then
          paramPrp.Add(plst(i))
        End If
      Next
    End If
  End Sub

  Private Sub getStatesForProc(ByVal idx As Integer)
    Dim plst() As String
    Dim nlst As Integer
    Dim rc As Integer, i As Integer
    Dim dev As String
    If procs(idx).states.Count = 0 Then
      defaultContext = contextCombo.SelectedItem()
      dev = "/" + defaultContext + "/STATE/" + procs(idx).name
      rc = GetNameListFromServer(dev, "PROCSTATES", "", plst, nlst)
      If rc <> 0 Then Exit Sub
      If nlst <> procs(idx).nstates Then
        MsgBox("consistency check failed!" + vbNewLine + "retrieved state list has " + Val(nlst) + " elements vs " + procs(idx).nstates)
      End If
      procs(idx).nstates = nlst
      For i = 0 To nlst - 1
        procs(idx).states.Add(plst(i).Trim())
      Next
    End If
  End Sub
  Private Sub ProcList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProcList.SelectedIndexChanged
    Dim plst() As String
    Dim nlst As Integer
    Dim rc As Integer, i As Integer, idx As Integer
    Dim dev As String

    idx = ProcList.SelectedIndex
    If idx < 0 Then Exit Sub
    If procs(idx).states.Count = 0 Then
      defaultContext = contextCombo.SelectedItem()
      dev = "/" + defaultContext + "/STATE/" + ProcList.Text
      rc = GetNameListFromServer(dev, "PROCSTATES", "", plst, nlst)
      If rc <> 0 Then Exit Sub
      procs(idx).nstates = nlst
      For i = 0 To nlst - 1
        procs(idx).states.Add(plst(i).Trim())
      Next
    End If
    StateList.Items.Clear()
    For i = 0 To procs(idx).nstates - 1
      If i < procs(idx).states.Count Then
        StateList.Items.Add(procs(idx).states(i))
      Else
        procs(idx).nstates = i
        Exit For
      End If
    Next
    If (procs(idx).nstates > 0) Then StateList.SelectedIndex = 0
  End Sub
  Private Function getColor(ByVal colorString As String) As Color
    Dim rgb() As String
    Dim inptString As String
    getColor = Color.Black
    inptString = UCase(GetTrimmedString(colorString))
    Select Case inptString
      Case "RED"
        getColor = Color.Red
      Case "BLUE"
        getColor = Color.Blue
      Case "DARKGREY", "DARKGRAY"
        getColor = Color.DarkGray
      Case "GREEN"
        getColor = Color.Green
      Case "YELLOW"
        getColor = Color.Yellow
      Case "GRAY", "GREY"
        getColor = Color.Gray
      Case Else
        If Len(inptString) > 0 Then
          rgb = Split(colorString, ",")
          If UBound(rgb) = 2 Then
            getColor = Color.FromArgb(Val(rgb(0)), Val(rgb(1)), Val(rgb(2)))
          End If
        End If
    End Select
  End Function

  Private Sub CfgItemChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CfgList.SelectedIndexChanged
    Dim nlst As Integer
    Dim rc As Integer, i As Integer, idx As Integer

    idx = CfgList.SelectedIndex
    If configs(idx).cfgListSize = 0 Then
      rc = GetConfigListFromServer(idx)
    End If
    ParamList.Items.Clear()
    If rc = 0 Then
      nlst = configs(idx).cfgListSize
      For i = 0 To nlst - 1
        ParamList.Items.Add(New String(configs(idx).cfgList(i).desc))
      Next
      If (nlst > 0) Then ParamList.SelectedIndex = 0
    End If
    If configs(idx).prfListSize = 0 Then
      rc = GetProfileListFromServer(idx)
    End If
    ProfileList.Items.Clear()
    SliceList.Items.Clear()
    If rc = 0 Then
      nlst = configs(idx).prfListSize
      For i = 0 To nlst - 1
        ProfileList.Items.Add(New String(configs(idx).prfList(i).name))
      Next
      If (nlst > 0) Then ProfileList.SelectedIndex = 0
    End If

  End Sub

  Private Sub ProfileClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProfileList.SelectedIndexChanged
    Dim pidx As Integer, cidx As Integer
    cidx = CfgList.SelectedIndex
    If (cidx < 0) Then Exit Sub
    pidx = ProfileList.SelectedIndex
    If (pidx < 0) Then Exit Sub
    Dim p() As String
    p = Split(configs(cidx).prfList(pidx).states, ",")
    Dim i As Integer, n As Integer
    SliceList.Items.Clear()
    n = UBound(p) + 1
    For i = 0 To n - 1
      SliceList.Items.Add(p(i))
    Next
    If (n > 0) Then SliceList.SelectedIndex = 0
    colorLabel.BackColor = getColor(New String(configs(cidx).prfList(pidx).color))
    typeLabel.Text = New String(configs(cidx).prfList(pidx).type)
    textLabel.Text = New String(configs(cidx).prfList(pidx).name)
  End Sub
  Function GetTrimmedString(ByVal str As String) As String
    Dim s As String
    s = str.Trim()
    Dim i As Integer, slen As Integer
    slen = Len(s)
    For i = 0 To slen - 1
      If s(i) = Chr(0) Then Exit For
    Next
    GetTrimmedString = s.Substring(0, i)
  End Function
  Function GetProcListIndexFromState(ByVal stateString As String) As Integer
    Dim i As Integer
    Dim tgt As String
    tgt = GetTrimmedString(stateString)
    For i = 0 To ProcList.Items.Count - 1
      If procs(i).states.Contains(tgt) Then
        GetProcListIndexFromState = i
        Exit Function
      End If
    Next
    GetProcListIndexFromState = -1
  End Function
  Function GetNumberOfProcsFromState(ByVal stateString As String) As Integer
    Dim i As Integer, n As Integer
    Dim tgt As String
    n = 0
    tgt = GetTrimmedString(stateString)
    For i = 0 To ProcList.Items.Count - 1
      If procs(i).states.Contains(tgt) Then n = n + 1
    Next
    GetNumberOfProcsFromState = n
  End Function
  Function GetAllProcsForState(ByVal stateString As String, ByRef procStrings() As String) As Integer
    Dim i As Integer, n As Integer
    Dim tgt As String
    Dim ps(PROC_BUFFER_SIZE) As String
    n = 0
    tgt = GetTrimmedString(stateString)
    For i = 0 To ProcList.Items.Count - 1
      If procs(i).states.Contains(tgt) Then
        ps(n) = GetTrimmedString(procs(i).name)
        n = n + 1
      End If
    Next
    ReDim procStrings(n)
    For i = 0 To n - 1 Step 1
      procStrings(i) = ps(i)
    Next
    GetAllProcsForState = n
  End Function
  Private Sub StatesListChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StatesList.SelectedIndexChanged
    Dim idx As Integer
    idx = StatesList.SelectedIndex
    'stateTriggerLabel.Text = states(idx).name
    stateDescriptionLabel.Text = states(idx).tag
    stateNumProcsLabel.Text = Val(GetNumberOfProcsFromState(StatesList.SelectedItem))
    idx = GetProcListIndexFromState(StatesList.SelectedItem)
    If (idx < 0) Then
      ProcList.ClearSelected()
      StateList.ClearSelected()
      Exit Sub
    End If
    ProcList.SelectedIndex = idx
  End Sub

  Private Sub StatesList_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles StatesList.MouseDown
    If e.Button = Windows.Forms.MouseButtons.Right Then
      Me.ContextMenuStrip2.Show(StatesList, New Point(e.X, e.Y))
    End If
  End Sub

  Private Sub ContextMenuStrip2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMenuStrip2.Click
    Dim idx As Integer
    Dim i As Integer, n As Integer
    Dim ps() As String
    idx = StatesList.SelectedIndex
    statesEditor.stateIndex = idx
    statesEditor.triggerBox.Text = states(idx).name 'StatesList.SelectedItem
    statesEditor.descriptionBox.Text = states(idx).tag
    statesEditor.procCombo.Items.Clear()
    For i = 0 To UBound(procs) - 1
      statesEditor.procCombo.Items.Add(procs(i).name)
    Next
    n = GetAllProcsForState(states(idx).name, ps)
    If n > 0 Then
      statesEditor.procList.Items.Clear()
      For i = 0 To n - 1
        statesEditor.procList.Items.Add(ps(i))
      Next
      idx = statesEditor.procCombo.FindStringExact(ps(0))
      If idx >= 0 Then statesEditor.procCombo.SelectedIndex = idx
    End If
    statesEditor.Show()
  End Sub

  Private Sub ContextMenuStrip1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMenuStrip1.Click
    Dim i As Integer, n As Integer
    slicesEditor.procCombo.Items.Clear()
    For i = 0 To UBound(procs) - 1
      slicesEditor.procCombo.Items.Add(procs(i).name)
    Next
    n = SliceList.Items.Count
    If n > 0 Then
      slicesEditor.procList.Items.Clear()
      For i = 0 To n - 1
        slicesEditor.procList.Items.Add(SliceList.Items.Item(i))
      Next
    End If
    slicesEditor.sliceBox.Text = ProfileList.Text
    slicesEditor.initialColor = colorLabel.BackColor
    slicesEditor.initialType = typeLabel.Text
    slicesEditor.initialProfileIndex = ProfileList.SelectedIndex
    slicesEditor.initialConfigIndex = CfgList.SelectedIndex
    slicesEditor.Show()
  End Sub

  Private Sub ProfileList_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ProfileList.MouseDown
    If e.Button = Windows.Forms.MouseButtons.Right Then
      Me.ContextMenuStrip1.Show(ProfileList, New Point(e.X, e.Y))
    End If
  End Sub

  Private Sub ContextMenuStrip3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMenuStrip3.Click
    Dim i As Integer, n As Integer
    paramsEditor.ParamList.Items.Clear()
    n = ParamList.Items.Count
    For i = 0 To n - 1
      paramsEditor.ParamList.Items.Add(ParamList.Items.Item(i))
    Next
    paramsEditor.Show()
  End Sub

  Private Sub ParamList_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ParamList.MouseDown
    If e.Button = Windows.Forms.MouseButtons.Right Then
      Me.ContextMenuStrip3.Show(ParamList, New Point(e.X, e.Y))
    End If
  End Sub

  Private Sub ContextMenuStrip4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMenuStrip4.Click
    Dim val As String
    val = InputBox("Enter the new viewer configuration name")
    Dim i As Integer
    For i = 0 To nConfigs - 1
      If configs(i).name = val Then
        MsgBox("configuration already exists!", MsgBoxStyle.OkOnly)
        Exit Sub
      End If
    Next
    ReDim Preserve configs(nConfigs)
    configs(nConfigs) = New CFG()
    configs(nConfigs).name = val
    configs(nConfigs).cfgListSize = configs(0).cfgListSize
    ReDim configs(nConfigs).cfgList(configs(0).cfgListSize - 1)
    For i = 0 To configs(0).cfgListSize - 1
      configs(nConfigs).cfgList(i) = configs(0).cfgList(i)
    Next
    nConfigs = nConfigs + 1
    CfgList.Items.Add(val)
  End Sub

  Private Sub CfgList_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles CfgList.MouseDown
    If e.Button = Windows.Forms.MouseButtons.Right Then
      Me.ContextMenuStrip4.Show(CfgList, New Point(e.X, e.Y))
    End If
  End Sub
  Public Function GetFilledCharArray(ByVal strval As String, ByVal strlen As Integer) As Char()
    Dim ca As Char()
    Dim sca As Char()
    Dim i As Integer
    ReDim ca(strlen - 1)
    sca = strval.ToCharArray()
    If sca.Length < strlen Then strlen = sca.Length
    For i = 0 To strlen - 1
      ca(i) = sca(i)
    Next

    GetFilledCharArray = ca
  End Function
  Private Sub updateButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updateButton.Click
    Dim i As Integer, k As Integer, n As Integer, rc As Integer
    Dim dev As String
    Dim din As TDataType, dout As TDataType
    Dim lnk As TLink
    Dim restart As Boolean
    defaultContext = contextCombo.SelectedItem()
    dev = "/" + defaultContext + "/STATE"
    'run through states list for changes
    n = UBound(states)
    Dim pStates(n) As NAME64
    Dim xStates(n) As DclState
    For i = 0 To n
      If states(i).isEdited Then
        xStates(k) = New DclState
        xStates(k).devname = GetFilledCharArray(states(i).name, 64)  'states(i).name.ToCharArray()
        xStates(k).machine = states(i).machine
        xStates(k).statetag = GetFilledCharArray(states(i).tag, 64) 'states(i).tag.ToCharArray()
        k = k + 1
      End If
    Next
    ' property "STATELIST"
    'n = k
    'For i = 0 To n - 1
    '  Debug.Print(GetTrimmedString(New String(xStates(i).devname)))
    'Next
    If k > 0 Then
      restart = True
      din = New TDataType(xStates)
      din.SetDataArrayLength(k)
retryStatesList:
      lnk = New TLink(dev, "STATELIST", tnull, din, Access.CA_WRITE)
      rc = lnk.Execute(1000)
      If rc Then
        If MsgBox("update states list failed : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
          GoTo retryStatesList
        End If
        Exit Sub
      End If
    End If
    'run through procs list for changes
    Dim s As String
    n = UBound(procs)
    Dim xProcs(n) As DclProc
    k = 0
    For i = 0 To n
      If procs(i).isEdited Then
        xProcs(k) = New DclProc
        xProcs(k).devname = GetFilledCharArray(procs(i).name, 64) 'procs(i).name.ToCharArray
        xProcs(k).machine = procs(i).machine
        xProcs(k).nstates = procs(i).nstates
        s = GetTrimmedString(procs(i).name) + ".csv"
        xProcs(k).structfile = GetFilledCharArray(s, 64) 's.ToCharArray
        k = k + 1
      End If
    Next
    'property "PROCLIST"
    'n = k
    'For i = 0 To n - 1
    '  Debug.Print(GetTrimmedString(New String(xProcs(i).devname)))
    '  Debug.Print(New String(xProcs(i).structfile))
    'Next
    If k > 0 Then
      restart = True
      din = New TDataType(xProcs)
      din.SetDataArrayLength(k)
retryProcsList:
      lnk = New TLink(dev, "PROCLIST", tnull, din, Access.CA_WRITE)
      rc = lnk.Execute(1000)
      If rc Then
        If MsgBox("update procedures list failed : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
          GoTo retryProcsList
        End If
        Exit Sub
      End If
    End If
    n = UBound(procs) + 1
    For i = 0 To n - 1
      If procs(i).isEdited Then
        restart = True
        'property "PROCSTATES"
        For k = 0 To procs(i).states.Count - 1
          pStates(k).SetName(procs(i).states(k))
        Next
        Debug.Print("send " + Str(procs(i).states.Count) + " states")
        din = New TDataType(pStates)
        din.SetDataArrayLength(procs(i).states.Count)
retryProcStates:
        lnk = New TLink(dev + "/" + procs(i).name, "PROCSTATES", tnull, din, Access.CA_WRITE)
        rc = lnk.Execute(1000)
        If rc Then
          If MsgBox("update procedures list failed : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
            GoTo retryProcStates
          End If
          Exit Sub
        End If
      End If
    Next
    lnk = New TLink()
    If needToUpdatedArchiver Then
      Dim arcdev As String
      Dim reclen As Integer
      arcdev = "/" + defaultContext + "/HISTORY"
      Debug.Print("need to update archiver")
      'additions/deletions -> get corresponding record/keyword info and re-submit
      Dim num As Integer
      Dim pqs(1) As PrpQueryStruct
      num = 1
      rc = TQuery.GetPropertyInformation(arcdev, "STATECNT", pqs, num)
      If rc = 0 Then
        reclen = pqs(0).prpSize
      End If
      If reclen <> n Then
        rc = GetDaqRecordsFromServer()
        If rc = 0 Then
          ' deactive the old guys
          For i = 0 To DAQ_SET_SIZE - 1
            daqRecsActive(i).active = 0
          Next
          din = New TDataType(daqRecsActive)
retryDeactiveRecords:
          rc = lnk.Execute(arcdev, "RECORD.INFO", tnull, din, Access.CA_WRITE, 500)
          If rc Then
            If MsgBox("deactivate record info failed : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
              GoTo retryDeactiveRecords
            End If
            Exit Sub
          End If
          ' now configure the new guys :
          Dim fn As String, p As String
          Dim v As Integer
          dout = New TDataType(daqParams)
          For i = 0 To DAQ_SET_SIZE - 1
            fn = New String(daqRecsActive(i).fn_key)
retryGetKeywordInfo:
            rc = lnk.Execute(arcdev + "/" + fn, "KEYWORD.INFO", dout, tnull, Access.CA_READ, 500)
            If rc Then
              If MsgBox("get keyword info failed : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
                GoTo retryGetKeywordInfo
              End If
              Exit Sub
            End If
            p = GetTrimmedString(New String(daqRecsActive(i).dev))
            v = Val(fn.Substring(Len(p))) + 1
            fn = p + Str(v).Trim() + ".csv"
            daqParams(0).size = n
            din = New TDataType(daqParams)
retryPutKeywordInfo:
            rc = lnk.Execute(arcdev + "/" + fn, "KEYWORD.INFO", tnull, din, Access.CA_WRITE, 500)
            If rc Then
              If MsgBox("get keyword info failed : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
                GoTo retryPutKeywordInfo
              End If
              Exit Sub
            End If
            daqRecsActive(i).fn_key = GetFilledCharArray(fn, 80)
            daqRecsActive(i).len = n
            daqRecsActive(i).active = 1
            daqRecsActive(i).rec = -1
          Next
retryActiveRecords:
          din = New TDataType(daqRecsActive)
          rc = lnk.Execute(arcdev, "RECORD.INFO", tnull, din, Access.CA_WRITE, 500)
          If rc Then
            If MsgBox("update procedures list failed : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
              GoTo retryActiveRecords
            End If
            Exit Sub
          End If
        End If
        ' "DB.RELOAD" for "HISTORY" and "ARCHIVER"
retryRestart1:
        rc = lnk.Execute(arcdev, "DB.RELOAD", tnull, tnull, Access.CA_WRITE, 3000)
        If rc Then
          If MsgBox("restart " + arcdev + " : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
            GoTo retryRestart1
          End If
          Exit Sub
        End If
        arcdev = "/" + defaultContext + "/ARCHIVER"
retryRestart2:
        rc = lnk.Execute(arcdev, "DB.RELOAD", tnull, tnull, Access.CA_WRITE, 3000)
        If rc Then
          If MsgBox("restart " + arcdev + " : " + Str(lnk.GetStatus), MsgBoxStyle.RetryCancel) = MsgBoxResult.Retry Then
            GoTo retryRestart2
          End If
          Exit Sub
        End If
      End If
    End If
    'run through configs list
    For i = 0 To UBound(configs)
      If configs(i).cfgEdited Or configs(i).prfEdited Then
        restart = True
        SendConfigListToServer(i)
        SendProfileListToServer(i)
      End If
    Next
    If restart Then
      lnk = New TLink(dev, "RESTART", tnull, tnull, Access.CA_WRITE)
      rc = lnk.Execute(1000)
      If rc Then MsgBox("restart " + dev + " : " + Str(lnk.GetStatus), MsgBoxStyle.OkOnly)
    End If
  End Sub
End Class
Public Class State
  Public name As String
  Public tag As String
  Public machine As Integer
  Public nprocs As Integer
  Public isEdited As Boolean
  Public isRemoved As Boolean
End Class
Public Class Proc
  Public name As String
  Public states As List(Of String)
  Public nstates As Integer
  Public machine As Integer
  Public isEdited As Boolean
End Class
Public Class CFG
  Public name As String
  Public cfgListSize As Integer
  Public cfgList() As OpHist.McaCfg
  Public prfListSize As Integer
  Public prfList() As OpHist.PrfCfg
  Public cfgEdited As Boolean
  Public prfEdited As Boolean
End Class
