Imports System.Windows.Forms

Public Class paramsEditor
  Private paramListChanged As Boolean
  Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
    If paramListChanged Then
      Dim cidx As Integer
      cidx = OpHist.CfgList.SelectedIndex
      OpHist.configs(cidx).cfgEdited = True
    End If
    Me.DialogResult = System.Windows.Forms.DialogResult.OK
    Me.Close()
  End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

  Private Sub paramPrpBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles paramPrpBox.SelectedIndexChanged
    Dim dev As String, prp As String
    Dim plst() As String
    Dim rc As Integer, nlst As Integer, i As Integer
    dev = "/" + OpHist.contextCombo.SelectedItem() + "/ARCHIVER"
    prp = paramPrpBox.SelectedItem() + ".NAM"
    rc = OpHist.GetNameListFromServer(dev, prp, "", plst, nlst)

    If rc = 0 Then
      paramDevBox.Items.Clear()
      For i = 0 To nlst - 1
        If Not plst(i).EndsWith(".NAM") Then
          paramDevBox.Items.Add(plst(i))
        End If
      Next
      paramDevBox.SelectedIndex = 0
    End If

    paramTagBox.Text = paramPrpBox.SelectedItem()
  End Sub

  Private Sub ParamList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ParamList.SelectedIndexChanged
    Dim pidx As Integer, cidx As Integer
    Dim dev As String, prp As String, tag As String
    If ParamList.SelectedIndex < 0 Then Exit Sub 'could happen if item removed
    cidx = OpHist.CfgList.SelectedIndex
    pidx = ParamList.SelectedIndex
    dev = OpHist.GetTrimmedString(New String(OpHist.configs(cidx).cfgList(pidx).dev))
    prp = OpHist.GetTrimmedString(New String(OpHist.configs(cidx).cfgList(pidx).prp))
    tag = OpHist.GetTrimmedString(New String(OpHist.configs(cidx).cfgList(pidx).desc))
    Dim i As Integer
    i = paramPrpBox.FindStringExact(prp)
    If i >= 0 Then paramPrpBox.SelectedIndex = i
    i = paramDevBox.FindStringExact(dev)
    If i >= 0 Then paramDevBox.SelectedIndex = i
    paramTagBox.Text = tag
  End Sub

  Private Sub paramsEditor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim i As Integer
    paramPrpBox.Items.Clear()
    For i = 0 To OpHist.paramPrp.Count - 1
      paramPrpBox.Items.Add(OpHist.paramPrp(i))
    Next
    ParamList.SelectedIndex = 0
  End Sub

  Private Sub ParamList_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ParamList.DoubleClick
    If ParamList.SelectedIndex >= 0 Then
      Dim pidx As Integer, cidx As Integer
      cidx = OpHist.CfgList.SelectedIndex
      pidx = ParamList.SelectedIndex
      OpHist.configs(cidx).cfgList(pidx).tag = OpHist.GetFilledCharArray("deleted", 16) '"deleted".ToCharArray
      Dim s As String
      s = OpHist.GetTrimmedString(ParamList.Items.Item(pidx).ToString())
      ParamList.Items.Item(pidx) = s + "(deleted)"
      'ParamList.Items.RemoveAt(ParamList.SelectedIndex)
      OpHist.ParamList.Items.Item(pidx) = s + "(deleted)"
      paramListChanged = True
    End If
  End Sub

  Private Sub addButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles addButton.Click
    If Len(paramTagBox.Text) = 0 Then
      MsgBox("Please provide a descriptive tag for this parameter")
      Exit Sub
    End If
    Dim cidx As Integer, i As Integer, n As Integer
    Dim dev As String, prp As String, tag As String
    Dim isNew As Boolean
    isNew = True
    cidx = OpHist.CfgList.SelectedIndex
    n = OpHist.configs(cidx).cfgListSize
    For i = 0 To n - 1
      dev = OpHist.GetTrimmedString(New String(OpHist.configs(cidx).cfgList(i).dev))
      prp = OpHist.GetTrimmedString(New String(OpHist.configs(cidx).cfgList(i).prp))
      If prp = paramPrpBox.Text And dev = paramDevBox.Text Then
        tag = OpHist.GetTrimmedString(New String(OpHist.configs(cidx).cfgList(i).desc))
        If tag = paramTagBox.Text Then Exit Sub
        Exit For
        isNew = False
      End If
    Next
    If isNew Then
      Dim mca As OpHist.McaCfg
      mca = New OpHist.McaCfg
      mca.ctx = OpHist.GetFilledCharArray(OpHist.contextCombo.SelectedItem().ToString, 32) 'OpHist.contextCombo.SelectedItem().ToString.ToCharArray
      mca.srv = OpHist.GetFilledCharArray("ARCHIVER", 32) '"ARCHIVER".ToCharArray
      mca.prp = OpHist.GetFilledCharArray(paramPrpBox.Text, 64) 'paramPrpBox.Text.ToCharArray
      mca.dev = OpHist.GetFilledCharArray(paramDevBox.Text, 64) 'paramDevBox.Text.ToCharArray
      mca.desc = OpHist.GetFilledCharArray(paramTagBox.Text, 64) 'paramTagBox.Text.ToCharArray
      ReDim Preserve OpHist.configs(cidx).cfgList(n)
      OpHist.configs(cidx).cfgList(n) = mca
      OpHist.configs(cidx).cfgListSize = n + 1
      ParamList.Items.Add(paramTagBox.Text)
      paramListChanged = True
      OpHist.paramPrp.Add(paramTagBox.Text)
      OpHist.ParamList.Items.Add(paramTagBox.Text)
    Else
      OpHist.configs(cidx).cfgList(i).desc = paramTagBox.Text
    End If
    paramListChanged = True
  End Sub
End Class
