Attribute VB_Name = "CASfunctions"
Option Explicit

Global Const MAXALARMSstorage = 5000
Global Const MAXALARMSlive = 5000
Global Const MAXSUBS = 100 '20
Global Const MAXSERVERS = 100
'Global cqs As CASQS
Global subsys() As String, NSubSys%, nAlarmGroups%, NMaxAlarms%
Global mnsubidx() As Integer, mxsubidx() As Integer
Global srvs(MAXSERVERS) As String, nsrvs As Integer

Global MAXALARMSdisplay%

Global Const ViewALL = 0
Global Const ViewSubSystem = 1
Global Const ViewDeviceServer = 2
Global Const ViewAlarmSystem = 3
Global AlarmViewIndex%

'Global gAlarmHRT(MAXALARMSstorage) As Single
Global NAlarmsGrid%, NAlarmsInAlmGrid%()

Global gAlarmTable() As XAMS  ' 2-D array to store non-junk alarms, and alarms from each archive-server
Global gAlarmTableOld() As XAMSr3  ' 2-D array to store non-junk alarms, and alarms from each archive-server
Global NAlarmsTable%(), NAlarmTables% ' Number of INPUT alarms (live: total, archive: for each archive-server)
Global AlarmTableGroupIndex%() ' ALarmSystem_ViewWhich Alarm System has which table?
Global AlarmTableSubGroupIndex%() ' Device System View: DSubsystem and Device-Server

Global MoreThanMaxAlarmsFlag As Boolean
Global TotalAlarms%
Global gAlarmDevices%(MAXALARMSstorage)

Type SUBINFO
    sub As String
    srvs() As String
    cqs() As CASQS
    nsrvs As Integer
    NAlms(1) As Integer
    lnalms As Integer
    timestamp As Long
    WaitingForData As Boolean ' data for n-alarms hasn't come in yet....
    ' need to keep track of ARCHIVED alarms in DEVICE_VIEW?
    DeviceServer_nalms(MAXSUBS, 1) As Integer
End Type
Global SubData(MAXSUBS) As SUBINFO
Global SubDataNAlarms(MAXSUBS) As Long

Global g_timestampAppend As String
Global gNumAlarmsAtSeverity(MAXSUBS) As Integer
Global gStartStopArray(2) As Long
Type ALARMINFOSET
  tag As String
  nAlm As Integer
  nalms_id As Long
  alms_id As Long
End Type
Global almInfo(MAXSUBS) As ALARMINFOSET
Global almSystems() As String, almSystemIds() As Long
Global nAlmSystems As Integer, TESTAlarmSystemIndex%
Global Const DEVICE_SERVER_VIEW = 0
Global Const ALARM_SYSTEM_VIEW = 1
Global gAlarmSystemView As Integer, NAlarmIndex%, NAlarmLinks%
Global gAlarmOrderingDirection As Integer

Function CASGetServerInfo(ByVal srv As String, cqs As CASQS) As Integer
Dim DevName$, rc%, i%, n%
Dim dout As DBLK, din As DBLK
Static done As Boolean
If Not done Then
  done = True
  FILLSTRUCT "CASQS", Len(cqs), 1, CF_NULL
End If
DevName$ = casServerContext$ + "/" + casServer$ & "/" + srv
dout.dArrayLength = 1: dout.dFormat = CF_STRUCT: BARR dout.dTag(), "CASQS"
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(DevName, "SERVERINFO", dout, cqs, din, 0, 1, 1000)
If rc% Then GoTo CASGetServerInfoError

CASGetServerInfoError:
CASGetServerInfo = rc%
End Function
Function CASGetServers(ByVal subsys As String, s() As String) As Integer
Dim DevName$, ss$, rc%, i%, n%
Dim sn(100) As NAME16
Dim dout As DBLK, din As DBLK
If Len(subsys) > 0 Then ss$ = subsys Else ss$ = "ALL"
DevName$ = casServerContext$ + "/" + casServer$ & "/" + ss$
dout.dArrayLength = 100: dout.dFormat = CF_NAME16
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(DevName, "SERVERS", dout, sn(0), din, 0, 1, 1000)
If rc% Then GoTo CASGetServersError
n% = dout.dArrayLength
ReDim s(n% - 1)
For i% = 0 To n% - 1
  s(i%) = BSTR(sn(i%).nam())
Next
CASGetServersError:
CASGetServers = rc%
End Function
Function CASGetSubsystems(s() As String) As Integer
Dim DevName$, rc%, i%, n%, tries%
Dim sn(100) As NAME16
Dim dout As DBLK, din As DBLK
DevName$ = casServerContext$ + "/" + casServer$ & "/ALL"
dout.dArrayLength = 100: dout.dFormat = CF_NAME16
din.dArrayLength = 0: din.dFormat = CF_NULL
Do
  rc% = T_EXECLINK(DevName, "SUBSYSTEMS", dout, sn(0), din, 0, 1, 200)
  tries% = tries% + 1
Loop While rc% <> 0 And tries% < 3
If rc% Then GoTo CASGetSubsystemsError
n% = dout.dArrayLength
ReDim s(n% - 1)
For i% = 0 To n% - 1
    s(i%) = BSTR(sn(i%).nam)
Next
CASGetSubsystemsError:
CASGetSubsystems = rc%
End Function

Function CASGetSubsystemsC(s() As String, timeout As Long) As Integer
Dim DevName$, rc%, i%, n%, tries%
Dim sn(100) As NAME16
Dim dout As DBLK, din As DBLK
If timeout < 200 Then timeout = 200
DevName$ = casServerContext$ + "/" + casServer$ & "/ALL"
dout.dArrayLength = 100: dout.dFormat = CF_NAME16
din.dArrayLength = 0: din.dFormat = CF_NULL
Do
  rc% = T_EXECLINK(DevName, "SUBSYSTEMS", dout, sn(0), din, 0, 1, timeout)
  tries% = tries% + 1
Loop While rc% <> 0 And tries% < 3
If rc% Then GoTo CASGetSubsystemsError
n% = dout.dArrayLength
ReDim s(n% - 1)
For i% = 0 To n% - 1
    s(i%) = BSTR(sn(i%).nam)
Next
CASGetSubsystemsError:
CASGetSubsystemsC = rc%
End Function

Function CASGetSubsystemsB(s() As String, NSubSys%) As Integer
Dim DevName$, rc%, i%, n%
Dim sn(100) As NAME16
Dim dout As DBLK, din As DBLK
DevName$ = casServerContext$ + "/" + casServer$ & "/ALL"
dout.dArrayLength = 100: dout.dFormat = CF_NAME16
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(DevName, "SUBSYSTEMS", dout, sn(0), din, 0, 1, 1000)
If rc% Then GoTo CASGetSubsystemsError
' FIND LENGTH FROM FIRST EMPTY STRING!
n% = dout.dArrayLength
ReDim s(99)
For i% = 0 To 99 'n% - 1
    s(i%) = BSTR(sn(i%).nam)
    If s(i%) = "" Then
        NSubSys% = i%
        'Debug.Print
        Exit For
    End If
Next i%
'Exit Function
CASGetSubsystemsError:
CASGetSubsystemsB = rc%
End Function
Function CASGetAlarmSystems(s() As String, ID() As Long) As Integer
Dim DevName$, rc As Integer, i As Integer, n As Integer, tries%
Dim sn(100) As NAME16I
Dim dout As DBLK, din As DBLK
DevName$ = casServerContext$ + "/" + casServer$ & "/ALL"
dout.dArrayLength = 100: dout.dFormat = CF_NAME16I
din.dArrayLength = 0: din.dFormat = CF_NULL
Do
  rc = T_EXECLINK(DevName, "ALARMSYSTEMS", dout, sn(0), din, 0, 1, 200)
  tries% = tries% + 1
Loop While rc <> 0 And tries% < 3
If rc Then GoTo CASGetAlarmSystemsError
n = dout.dArrayLength
ReDim s(n - 1)
ReDim ID(n - 1)
For i = 0 To n - 1
  s(i) = BSTR(sn(i).nam)
  ID(i) = sn(i).iVal
Next
CASGetAlarmSystemsError:
CASGetAlarmSystems = rc
End Function


Function CASGetAlarmSystemsEx(s() As String, ID() As Long, timeout As Long) As Integer
Dim DevName$, rc As Integer, i As Integer, n As Integer, tries%
Dim sn(100) As NAME16I
Dim dout As DBLK, din As DBLK
If timeout < 200 Then timeout = 200
DevName$ = casServerContext$ + "/" + casServer$ & "/ALL"
dout.dArrayLength = 100: dout.dFormat = CF_NAME16I
din.dArrayLength = 0: din.dFormat = CF_NULL
Do
  rc = T_EXECLINK(DevName, "ALARMSYSTEMS", dout, sn(0), din, 0, 1, timeout)
  'rc = T_EXECLINK(devName, "ALARMSYSTEMS", dout, sn(0), din, 0, 1, 200)
  tries% = tries% + 1
Loop While rc <> 0 And tries% < 3
If rc Then GoTo CASGetAlarmSystemsError
n = dout.dArrayLength
ReDim s(n - 1)
ReDim ID(n - 1)
For i = 0 To n - 1
  s(i) = BSTR(sn(i).nam)
  ID(i) = sn(i).iVal
Next
CASGetAlarmSystemsError:
CASGetAlarmSystemsEx = rc
End Function


Function CASGetSubsystemsEx(s() As String, minidx() As Integer, maxidx() As Integer) As Integer
Dim DevName$, rc%, i%, n%, tries%
Dim sn(100) As USTRING
Dim dout As DBLK, din As DBLK
DevName$ = casServerContext$ + "/" + casServer$ & "/ALL"
dout.dArrayLength = 100: dout.dFormat = CF_USTRING
din.dArrayLength = 0: din.dFormat = CF_NULL
Do
  rc% = T_EXECLINK(DevName, "SUBSYSTEMS", dout, sn(0), din, 0, 1, 200)
  tries% = tries% + 1
Loop While rc <> 0 And tries% < 3
If rc% Then GoTo CASGetSubsystemsExError
n% = dout.dArrayLength
ReDim s(n% - 1)
ReDim minidx(n% - 1)
ReDim maxidx(n% - 1)
For i% = 0 To n% - 1
  s(i%) = BSTR(sn(i%).STR)
  minidx(i%) = sn(i%).f1val
  maxidx(i%) = sn(i%).f2val
Next
CASGetSubsystemsExError:
CASGetSubsystemsEx = rc%
End Function

Function CASGetNumAlarms(ByVal tgt As String, num() As Integer, starttime As Long, stoptime As Long, severity As Long) As Integer
Dim DevName$, ss$, rc%, i%, n%(1)
Dim dout As DBLK, din As DBLK
Dim stst(2) As Long
stst(0) = starttime: stst(1) = stoptime: stst(2) = severity
If Len(tgt) > 0 Then ss$ = tgt Else ss$ = "ALL"
DevName$ = casServerContext$ + "/" + casServer$ & "/" + ss$
dout.dArrayLength = 2: dout.dFormat = CF_SHORT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc% = T_EXECLINK(DevName, "NUMALARMS", dout, n%(0), din, stst(0), CA_READ, 1000)
If rc% Then GoTo CASGetNumAlarmsError
CASGetNumAlarmsError:
If UBound(num) >= 0 Then num(0) = n%(0)
If UBound(num) > 0 Then num(1) = n%(1)
CASGetNumAlarms = rc%
End Function

Public Function ALMDataStrLegacy(a As AMSr3) As String
  Dim i As Integer, k As Integer
  Dim iVal(3) As Integer
  Dim lval As Long
  Dim fval As Single
  Dim s As String
  s = " ": g_timestampAppend = ""
  Select Case a.alarmDataFormat + CF_DOUBLE
    Case CF_BYTE:
      For i = 0 To a.alarmDataArraySize - 1
        s = s + Hex$(a.alarmData(i)) + " "
      Next
    Case CF_SHORT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(iVal(0), a.alarmData(0), a.alarmDataArraySize * 2)
        s = s + STR$(iVal(i)) + " "
      Next
    Case CF_LONG:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(lval, a.alarmData(0), 4)
        s = s + STR$(lval) + " "
      Next
    Case CF_FLOAT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(fval, a.alarmData(0), 4)
        s = s + STR$(fval) + " "
      Next
      If a.alarmSystem = 750 Then g_timestampAppend = STR$(fval)
    Case CF_HITTS:
'      Call MEMCPY(fval, a.alarmData(0), 4)
'      s = s + str$(fval) + " "
      For i = 0 To 5
        s = s + Hex$(a.alarmData(i))
      Next
      s = s + " "
    Case CF_BIT:
      For i = 0 To 5 ' go thru all 6 bytes
        If i * 8 > a.alarmDataArraySize Then Exit For
        For k = 0 To 7
          If i * 8 + k > a.alarmDataArraySize Then Exit For
          s = s + STR$(GetBit(a.alarmData(i), k))
        Next
      Next
    Case CF_TEXT:
      s = BSTR(a.alarmData()) + " "
  End Select
ALMDataStrLegacy = s
End Function

Public Function ALMDataStr(a As AMS) As String
  Dim i As Integer, k As Integer
  Dim iVal(3) As Integer
  Dim lval As Long
  Dim fval As Single
  Dim s As String
  s = " ": g_timestampAppend = ""
  Select Case a.alarmDataFormat + CF_DOUBLE
    Case CF_BYTE:
      For i = 0 To a.alarmDataArraySize - 1
        s = s + Hex$(a.alarmData(i)) + " "
      Next
    Case CF_SHORT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(iVal(0), a.alarmData(0), a.alarmDataArraySize * 2)
        s = s + STR$(iVal(i)) + " "
      Next
    Case CF_LONG:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(lval, a.alarmData(0), 4)
        s = s + STR$(lval) + " "
      Next
    Case CF_FLOAT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(fval, a.alarmData(0), 4)
        s = s + STR$(fval) + " "
      Next
      If a.alarmSystem = 750 Then g_timestampAppend = STR$(fval)
    Case CF_HITTS:
'      Call MEMCPY(fval, a.alarmData(0), 4)
'      s = s + str$(fval) + " "
      For i = 0 To 5
        s = s + Hex$(a.alarmData(i))
      Next
      s = s + " "
    Case CF_BIT:
      For i = 0 To 5 ' go thru all 6 bytes
        If i * 8 > a.alarmDataArraySize Then Exit For
        For k = 0 To 7
          If i * 8 + k > a.alarmDataArraySize Then Exit For
          s = s + STR$(GetBit(a.alarmData(i), k))
        Next
      Next
    Case CF_TEXT:
      s = BSTR(a.alarmData()) + " "
  End Select
ALMDataStr = s
End Function


Public Function ALMDataStrXLegacy(a As XAMSr3) As String
  Dim i As Integer, k As Integer
  Dim iVal(3) As Integer
  Dim lval As Long
  Dim fval As Single
  Dim s As String
  s = " ": g_timestampAppend = ""
  Select Case a.alarmDataFormat + CF_DOUBLE
    Case CF_BYTE:
      For i = 0 To a.alarmDataArraySize - 1
        s = s + Hex$(a.alarmData(i)) + " "
      Next
    Case CF_SHORT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(iVal(0), a.alarmData(0), a.alarmDataArraySize * 2)
        s = s + STR$(iVal(i)) + " "
      Next
    Case CF_LONG:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(lval, a.alarmData(0), 4)
        s = s + STR$(lval) + " "
      Next
    Case CF_FLOAT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(fval, a.alarmData(0), 4)
        s = s + STR$(fval) + " "
      Next
      If a.alarmSystem = 750 Then g_timestampAppend = STR$(fval)
    Case CF_HITTS:
'      Call MEMCPY(fval, a.alarmData(0), 4)
'      s = s + str$(fval) + " "
      For i = 0 To 5
        s = s + Hex$(a.alarmData(i))
      Next
      s = s + " "
    Case CF_BIT:
      For i = 0 To 5 ' go thru all 6 bytes
        If i * 8 > a.alarmDataArraySize Then Exit For
        For k = 0 To 7
          If i * 8 + k > a.alarmDataArraySize Then Exit For
          s = s + STR$(GetBit(a.alarmData(i), k))
        Next
      Next
    Case CF_TEXT:
      s = BSTR(a.alarmData()) + " "
  End Select
ALMDataStrXLegacy = s
End Function

Public Function ALMDataStrX(a As XAMS) As String
  Dim i As Integer, k As Integer
  Dim iVal(3) As Integer
  Dim lval As Long
  Dim fval As Single
  Dim s As String
  s = " ": g_timestampAppend = ""
  Select Case a.alarmDataFormat + CF_DOUBLE
    Case CF_BYTE:
      For i = 0 To a.alarmDataArraySize - 1
        s = s + Hex$(a.alarmData(i)) + " "
      Next
    Case CF_SHORT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(iVal(0), a.alarmData(0), a.alarmDataArraySize * 2)
        s = s + STR$(iVal(i)) + " "
      Next
    Case CF_LONG:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(lval, a.alarmData(0), 4)
        s = s + STR$(lval) + " "
      Next
    Case CF_FLOAT:
      For i = 0 To a.alarmDataArraySize - 1
        Call MEMCPY(fval, a.alarmData(0), 4)
        s = s + STR$(fval) + " "
      Next
      If a.alarmSystem = 750 Then g_timestampAppend = STR$(fval)
    Case CF_HITTS:
'      Call MEMCPY(fval, a.alarmData(0), 4)
'      s = s + str$(fval) + " "
      For i = 0 To 5
        s = s + Hex$(a.alarmData(i))
      Next
      s = s + " "
    Case CF_BIT:
      For i = 0 To 5 ' go thru all 6 bytes
        If i * 8 > a.alarmDataArraySize Then Exit For
        For k = 0 To 7
          If i * 8 + k > a.alarmDataArraySize Then Exit For
          s = s + STR$(GetBit(a.alarmData(i), k))
        Next
      Next
    Case CF_TEXT:
      s = BSTR(a.alarmData()) + " "
  End Select
ALMDataStrX = s
End Function


