Attribute VB_Name = "Alarm"
Option Explicit

Global Const almNEWALARM = &H1
Global Const almHEARTBEAT = &H2
Global Const almOSCILLATION = &H4
Global Const almDATACHANGE = &H8
Global Const almINSTANT = &H10
Global Const almTERMINATE = &H40
Global Const almTEST = &H80

Global NCasContexts As Integer
Global CAServerNames$(), CAServerContextNames$()
Global NDeviceRows%(2, 20)
Global casServer$, casServerContext$

Type AMSr3            ' Alarm Message Structure
tag(15) As Byte
device(15) As Byte
almTag(15) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmData(5) As Byte
alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
alarmSystem As Integer
End Type '72 bytes

Type XAMSr3            ' Extended Alarm Message Structure (use with CAS only)
server(15) As Byte
device(15) As Byte
almText(39) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmSystem As Long
alarmData(7) As Byte
alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
End Type

Type AMS            ' Alarm Message Structure for Release 4.0
server(31) As Byte
device(63) As Byte
almText(31) As Byte
alarmCode As Long
timestamp As Long
timestampUSec As Long
starttime As Long
starttimeUSec As Long
alarmMask As Long
alarmData(63) As Byte
alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
alarmSystem As Integer
reserved(1) As Byte
End Type '224 bytes

Type XAMS            ' Extended Alarm Message Structure (use with CAS only) for Release 4.0
server(31) As Byte
device(63) As Byte
almText(63) As Byte
alarmCode As Long
timestamp As Long
timestampUSec As Long
starttime As Long
starttimeUSec As Long
alarmMask As Long
alarmSystem As Long
alarmData(63) As Byte
alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
End Type '256 bytes

Type AMRB         ' Alarm Message Request Block
starttime As Long
stoptime As Long
severity As Long
reservered As Long
End Type

Type ASB        ' Alarm Status Block
nalarms As Long
mostRecentAlarmTime As Long
highestSeverity As Long
nalarmsAtMostRecentAlarmTime As Long
nalarmsAtHighestSeverity As Long
End Type

Type ADSr3
tag(15) As Byte
code As Long
mask As Long
severity As Integer
DataFormat As Byte ' format as Byte => CF_<format> - CF_DOUBLE !!!!
dataDim As Byte
timeRes As Long
hitsChannel As Integer
hitsModule As Integer
AlarmText(39) As Byte
deviceText(37) As Byte
alarmSystem As Integer
dataText(39) As Byte
url(39) As Byte
reserved As Long
End Type

Type ADS
tag(31) As Byte
code As Long
mask As Long
alarmSystem As Integer
severity As Integer
DataFormat As Byte ' format as Byte => CF_<format> - CF_DOUBLE !!!!
dataDim As Byte
reserved(1) As Byte
AlarmText(63) As Byte
deviceText(63) As Byte
dataText(63) As Byte
url(127) As Byte
End Type

Type CASQS
devcontext(15) As Byte
devServer(15) As Byte
subsystem(15) As Byte
arcExt(15) As Byte
SeverityLevel As Long
ArchiveLevel As Long
Retention As Long
AlarmLevel As Long
alarmSystem As Long
End Type

Declare Function appendAlarmInfoTable Lib "tinesrv32.dll" (ByVal LocalName As String, localADS As ADS) As Integer
Declare Function SetMaximumAlarms Lib "tinesrv32.dll" (ByVal maxnum As Integer) As Integer
Declare Sub setAlarmWindow Lib "tinesrv32.dll" (ByVal AlarmRetentionWindow As Long)
Declare Function getAlarmWindow Lib "tinesrv32.dll" () As Long
Declare Sub setTerminationWindow Lib "tinesrv32.dll" (ByVal AlarmTerminationWindow As Long)
Declare Function getTerminationWindow Lib "tinesrv32.dll" () As Long
Declare Sub setAlarmHeartbeat Lib "tinesrv32.dll" (ByVal AlarmHeartbeat As Long)
Declare Function getAlarmHeartbeat Lib "tinesrv32.dll" () As Long

Type ALARM_WATCH_THRESHOLDS
  cnt As Long
  hi As Single
  hiwarn As Single
  lo As Single
  lowarn As Single
End Type

Declare Function appendAlarmWatchTable Lib "tinesrv32.dll" (ByVal LocalName As String, ByVal property As String, ByVal device As String, ByVal arraySize As Long, ByVal format As Long, ByVal arrayType As Long, ByVal severity As Long, ByVal alarmSystem As Long, alarmThresh As ALARM_WATCH_THRESHOLDS)
Function getAlarmServerInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, cas_col%
Dim fn$

fn$ = App.Path + "\" + fname

NCasContexts = getDatabaseSize(fn$)
If NCasContexts = 0 Then
  getAlarmServerInfo = 0
  Exit Function
End If

ReDim CAServerNames$(NCasContexts)
ReDim CAServerContextNames$(NCasContexts)

con_col = -1
cas_col = -1
Open fn$ For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      cas_col = colptr(a$, "ALARM SERVER")
      done = True
    Else
      If con_col > -1 Then CAServerNames$(i%) = getcol(a$, cas_col)
      If cas_col > -1 Then CAServerContextNames$(i%) = getcol(a$, con_col)
      i% = i% + 1
      If i% >= NCasContexts Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1
' if ONLY CONTEXT, then FILL-IN the "default" cas name "CAS"
' (Could, in principle, have TWO CAS in same context?)
' Then need SPECIFIC NAME for server?
If con_col = -1 Then
    For i% = 0 To NCasContexts - 1
        CAServerNames$(i%) = "CAS"
    Next i%
End If
getAlarmServerInfo = i%
End Function
Function getAlarmServerDisplayInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, cas_col%, R1_col%, R2_col%, R3_col%, tmpRC%
Dim fn$

fn$ = App.Path + "\" + fname

getAlarmServerDisplayInfo = 0

NCasContexts = getDatabaseSize(fn$)
If NCasContexts = 0 Then
    Dim tmpContextsStr$(), tmpnContexts%
    Dim tmpDevServersStr$(), tmpnDevServers%
    
    ' Get the list of contexts from the NAME-SERVER!
    tmpRC% = GetEquipmentDeviceContexts(tmpContextsStr$(), tmpnContexts%)
    If tmpRC% <> 0 Then
        MsgBox "Error reading contexts from Name-Server!" + RPCERROR(tmpRC%)
    End If
    
    ' Loop through, and check which have a CAS SERVER!
    ReDim CAServerNames$(tmpnContexts%)
    ReDim CAServerContextNames$(tmpnContexts%)
    NCasContexts = 0

    For i% = 0 To tmpnContexts% - 1
        'Function GetEquipmentDeviceServers(devcontext As String, devSubSystem As String, devServers() As String, nDevServers As Integer) As Integer
        ' Search for ARCHIVER and HISTORY servers
        tmpRC% = GetEquipmentDeviceServers(tmpContextsStr$(i%), "ALL", tmpDevServersStr$, tmpnDevServers%)
        If tmpRC% <> 0 Then
            MsgBox "Error reading device-servers for context: " + tmpContextsStr$(i%) + RPCERROR(tmpRC%)
        Else
            For j% = 0 To tmpnDevServers% - 1
                If tmpDevServersStr$(j%) = "CAS" Then
                    ' This Context has a CAS!
                    CAServerContextNames$(NCasContexts) = tmpContextsStr$(i%)
                    CAServerNames$(NCasContexts) = "CAS"
                    NCasContexts = NCasContexts + 1
                    Exit For
                End If
            Next j%
        End If
    Next i%
    If NCasContexts < 1 Then Exit Function

Else
    ReDim CAServerNames$(NCasContexts)
    ReDim CAServerContextNames$(NCasContexts)
    
    con_col = -1
    cas_col = -1
    R1_col% = -1
    R2_col% = -1
    R3_col% = -1
    
    Open fn$ For Input Access Read Shared As #1
    Line Input #1, a$ ' Header Line (all possible column-names
    Do
      Line Input #1, a$
      tok$ = Left$(a$, 1)
      If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
        If Not done Then
          con_col = colptr(a$, "CONTEXT")
          cas_col = colptr(a$, "ALARM SERVER")
          
          ' For ALARM VIEWER!
          R1_col% = colptr(a$, "NDevR1")
          R2_col% = colptr(a$, "NDevR2")
          R3_col% = colptr(a$, "NDevR3")
          done = True
        Else
          If con_col > -1 Then CAServerContextNames$(i%) = getcol(a$, con_col)
          If cas_col > -1 Then CAServerNames$(i%) = getcol(a$, cas_col)
          
          If R1_col% > -1 Then NDeviceRows%(0, i%) = Val(getcol(a$, R1_col%))
          If R2_col% > -1 Then NDeviceRows%(1, i%) = Val(getcol(a$, R2_col%))
          If R3_col% > -1 Then NDeviceRows%(2, i%) = Val(getcol(a$, R3_col%))
          
          i% = i% + 1
          If i% >= NCasContexts Then Exit Do
        End If
      End If
    Loop While Not EOF(1)
    Close 1

    ' if ONLY CONTEXT, then FILL-IN the "default" cas name "CAS"
    ' (Could, in principle, have TWO CAS in same context?)
    ' Then need SPECIFIC NAME for server?
    If cas_col = -1 Then
        For i% = 0 To NCasContexts - 1
            CAServerNames$(i%) = "CAS"
        Next i%
    End If
End If

getAlarmServerDisplayInfo = NCasContexts 'i%
End Function




Function GetAlarmDefinitions(devServer As String, adefs() As ADS, nadefs As Integer) As Integer
Dim DevName$, DevProp$, rc%, i%, n%, p%
Dim dout As DBLK, din As DBLK
Dim adefs3() As ADSr3
Dim ctx As String, srv As String

p% = InStr(devServer, "/")
If p% = 1 Then
  ctx = Right(devServer, Len(devServer) - 1)
  p% = InStr(ctx, "/")
  srv = Right(ctx, Len(ctx) - p%)
  ctx = Left(ctx, p% - 1)
  p% = InStr(srv, "/")
  If p% > 0 Then srv = Left(srv, p%)
End If

DevName$ = "/" + ctx + "/CAS/" + srv
DevProp$ = "SYSALMDEFS"

n% = 200 ' nice query size
ReDim adefs(n%)

retryGetAlarmDefinitions:
'Debug.Print devServer + ": Reading ALM definitions: rc, n: " + str$(rc%), str$(n%)
'dout.dArrayLength = n: dout.dFormat = CF_STRUCT
dout.dArrayLength = n: dout.dFormat = CF_STRUCT
BARR dout.dTag, "ADSr4"
rc% = T_EXECLINK(DevName, DevProp, dout, adefs(0), din, 0, CA_READ + CA_RETRY, 200)
If rc% = illegal_equipment_number Then
  'not yet known to CAS
  DevName$ = "/" + ctx + "/" + srv + "/*"
  DevProp$ = "ALMDEFS"
  GoTo retryGetAlarmDefinitions
End If
If rc% Then
    n% = 0
    GoTo GetAlarmDefinitionsError
Else
    n% = dout.dArrayLength
End If
nadefs = n%
GetAlarmDefinitions = rc%
Exit Function

GetAlarmDefinitionsError:
nadefs = n%
GetAlarmDefinitions = rc%
Debug.Print "GetAlarmDefinitions = " + STR$(rc%)
End Function

Function GetAlarmDefinitionsOLD(devServer As String, adefs() As ADS, nadefs As Integer) As Integer
Dim DevName$, DevProp$, MYrc%, i%, n%
Dim dout As DBLK, din As DBLK
Dim adefs3() As ADSr3
Dim ctx As String, srv As String

'' ADD OPTIONAL TIMEOUT BECAUSE SO MANY LINK-NOT-OPEN!
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
MYrc% = T_EXECLINK(devServer, "NALMDEFS", dout, n%, din, 0, CA_READ, 200)
If MYrc% = 45 Then
    dout.dArrayLength = 1: dout.dFormat = CF_SHORT
    din.dArrayLength = 0: din.dFormat = CF_NULL
    MYrc% = T_EXECLINK(devServer, "NALMDEFS", dout, n%, din, 0, CA_READ, 600)
End If
'If n% > 163 Then n% = 163 ' Phil's limit... because of DOS FECs, memory/data transfer limits...

If n% > 500 Then
    MsgBox " Too many alarm definitions! The Server (" + devServer$ + ") has " + STR$(n%) + " alarms!" + _
            " Truncating list to 500."
    n% = 500
End If
If MYrc% Or n% = 0 Then
    'Debug.Print
    GoTo GetAlarmDefinitionsError
End If
n% = 200 ' nice query size
ReDim adefs(n%)

'Debug.Print devServer + ": Reading ALM definitions: rc, n: " + str$(MYrc%), str$(n%)
'dout.dArrayLength = n * Len(adefs(0)): dout.dFormat = CF_STRUCT
dout.dArrayLength = n: dout.dFormat = CF_STRUCT
BARR dout.dTag, "ADSr4"
MYrc% = T_EXECLINK(DevName, DevProp, dout, adefs(0), din, 0, CA_READ + CA_RETRY, 200)
If MYrc% <> 45 Then
    ReDim adefs3(n)
    DoEvents
    dout.dArrayLength = CLng(n%) * Len(adefs3(0)): dout.dFormat = CF_STRUCT
    BARR dout.dTag, ""
    MYrc% = T_EXECLINK(devServer, "ALMDEFS", dout, adefs3(0), din, 0, CA_READ, 800)
    If MYrc% = 0 Then
      For i = 0 To n - 1
        adefs(i).alarmSystem = adefs3(i).alarmSystem
        MEMCPY adefs(i).AlarmText(0), adefs3(i).AlarmText(0), 40
        adefs(i).code = adefs3(i).code
        adefs(i).dataDim = adefs3(i).dataDim
        adefs(i).DataFormat = adefs3(i).DataFormat
        MEMCPY adefs(i).dataText(0), adefs3(i).dataText(0), 40
        MEMCPY adefs(i).deviceText(0), adefs3(i).deviceText(0), 38
        adefs(i).mask = adefs3(i).mask
        adefs(i).severity = adefs3(i).severity
        MEMCPY adefs(i).tag(0), adefs3(i).tag(0), 16
        MEMCPY adefs(i).url(0), adefs3(i).url(0), 40
      Next
    End If
End If
If MYrc% Then
    n% = 0
    GoTo GetAlarmDefinitionsError
Else
    n% = dout.dArrayLength
End If
nadefs = n%
GetAlarmDefinitionsOLD = MYrc%
Exit Function

GetAlarmDefinitionsError:
nadefs = n%
GetAlarmDefinitionsOLD = MYrc%
Debug.Print "GetAlarmDefinitions = " + STR$(MYrc%)
End Function

Public Sub CopyAMSintoXAMSLegacy(TableAMS() As AMSr3, IndexAMS%, TableXAMS() As XAMSr3, IndexXAMS%, NElements%)
Dim i%
' For ARCHIVE DATA:
For i% = 0 To NElements% - 1
    With TableAMS(i% + IndexAMS%)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).server(0), .tag(0), 16)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).device(0), .device(0), 16)
        
        ' Just copy it in - or get it in a call?
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).almText(0), .almTag(0), 16)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).alarmData(0), .alarmData(0), 6)
        
        TableXAMS(i% + IndexXAMS%).alarmCode = .alarmCode
        TableXAMS(i% + IndexXAMS%).timestamp = .timestamp
        TableXAMS(i% + IndexXAMS%).alarmMask = .alarmMask
        TableXAMS(i% + IndexXAMS%).alarmDataFormat = .alarmDataFormat
        TableXAMS(i% + IndexXAMS%).alarmDataArraySize = .alarmDataArraySize
        TableXAMS(i% + IndexXAMS%).severity = .severity
        TableXAMS(i% + IndexXAMS%).descriptor = .descriptor
        TableXAMS(i% + IndexXAMS%).alarmSystem = .alarmSystem
    
        Debug.Print ASCTIME(.timestamp)
    End With
Next i%

Debug.Print

'Type AMS            ' Alarm Message Structure
'tag(15) As Byte - is SERVER
'device(15) As Byte
'almTag(15) As Byte - is SHORT TEXT!
'alarmCode As Long
'timestamp As Long
'alarmMask As Long
'alarmData(5) As Byte
'alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
'alarmDataArraySize As Byte
'severity As Byte
'descriptor As Byte
'alarmSystem As Integer
'End Type
'
'Type XAMS            ' Extended Alarm Message Structure (use with CAS only)
'server(15) As Byte
'device(15) As Byte
'almText(39) As Byte

'alarmCode As Long
'timestamp As Long
'alarmMask As Long
'alarmData(7) As Byte
'alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
'alarmDataArraySize As Byte
'severity As Byte
'descriptor As Byte
'alarmSystem As Long
'End Type

End Sub

Public Sub CopyAMSintoXAMS(TableAMS() As AMS, IndexAMS%, TableXAMS() As XAMS, IndexXAMS%, NElements%)
Dim i%

' For ARCHIVE DATA:
For i% = 0 To NElements% - 1
    With TableAMS(i% + IndexAMS%)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).server(0), .server(0), 32)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).device(0), .device(0), 64)
        
        ' Just copy it in - or get it in a call?
        TableXAMS(i% + IndexXAMS%).alarmCode = .alarmCode
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).almText(0), .almText(0), 32)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).alarmData(0), .alarmData(0), 64)
        
        TableXAMS(i% + IndexXAMS%).timestamp = .timestamp
        TableXAMS(i% + IndexXAMS%).timestampUSec = .timestampUSec
        TableXAMS(i% + IndexXAMS%).starttime = .starttime
        TableXAMS(i% + IndexXAMS%).starttimeUSec = .starttimeUSec
        
Debug.Print i%, .timestamp, .timestampUSec, .starttime, .starttimeUSec

        TableXAMS(i% + IndexXAMS%).alarmMask = .alarmMask
        TableXAMS(i% + IndexXAMS%).alarmDataFormat = .alarmDataFormat
        TableXAMS(i% + IndexXAMS%).alarmDataArraySize = .alarmDataArraySize
        TableXAMS(i% + IndexXAMS%).severity = .severity
        TableXAMS(i% + IndexXAMS%).descriptor = .descriptor
        TableXAMS(i% + IndexXAMS%).alarmSystem = .alarmSystem
    
        Debug.Print ASCTIME(.timestamp)
    End With
Next i%
End Sub

