Attribute VB_Name = "Archive"
'==========================================================
'==                                                      ==
'==     archive retrieval routines following LPC format  ==
'==                                                      ==
'==========================================================
' Notes of change
' 10. Mar. 2006: AL.: In zwei Routinen fehlte "Dim devName$"

Global pmArchiveServer$, pmArchiveContext$
Global EventArchiveServer$
Global EventStorageServer$
Global MaxNumHistoryPoints As Integer

Type APCBLKr3
  SessionID As Long
  Event As Long
  Ext(3) As Byte
  SrvName(15) As Byte
  DevName(15) As Byte
  PropName(31) As Byte
  dSize As Integer
  dFormat As Integer
End Type

Type APCBLK ' r4
 SessionID As Long
 Event As Long
 Ext(15) As Byte
 CtxName(31) As Byte
 SrvName(31) As Byte
 DevName(63) As Byte
 PropName(63) As Byte
 dTag(15) As Byte
 dSize As Long
 dFormat As Integer
 reserved As Integer
' ( 0) sessionID 1.0000  515
' ( 1) event 1.0000  515
' ( 2) ext 4.0000  516
' ( 3) context 32.0000  516
' ( 4) server 32.0000  516
' ( 5) device 64.0000  516
' ( 6) property 64.0000  516
' ( 7) dTag 16.0000  516
' ( 8) dSize 1.0000  515
' ( 9) dFormat 1.0000  513
' ( 10) reserved 1.0000  513
' ( 11) APCBLKr4 228.0000  767
End Type

Type ARS
  starttime As Long
  idx As Integer
  mins As Integer
  Keyword(15) As Byte
End Type

Type ADRB
  eventNumber As Long
  starttime As Long
  stoptime As Long
  deviceServerName(15) As Byte
  deviceProperty(15) As Byte
  deviceName(15) As Byte
  DataFormat As Integer
  dataDimension As Integer
End Type

Type ADRBX
  eventNumber As Long
  starttime As Long
  stoptime As Long
  deviceContext(15) As Byte
  deviceServerName(15) As Byte
  deviceProperty(31) As Byte
  deviceName(31) As Byte
  DataFormat As Integer
  reserved As Integer
  dataIndex As Long
  dataDimension As Long
End Type

Type ADRBr4
  eventNumber As Long
  starttime As Long
  stoptime As Long
  deviceContext(31) As Byte
  deviceServerName(31) As Byte
  deviceProperty(63) As Byte
  deviceName(63) As Byte
  dataTag(15) As Byte
  DataFormat As Integer
  reserved As Integer
  dataIndex As Long
  dataDimension As Long
End Type  ' "ADRBr4"


'Type AMS            ' Alarm Message Structure
'tag(15) As Byte
'device(15) As Byte
'almTag(15) As Byte
'alarmCode As Long
'timestamp As Long
'alarmMask As Long
'alarmData(5) As Byte
'alarmDataFormat As Byte
'alarmDataArraySize As Byte
'severity As Byte
'descriptor As Byte
'AlarmSystem As Integer
'End Type

'Type HstViewSet
Type HstCfg ' Central Archiver Configuration (z.B. /DESY2/HISTORY: Property CONFIGURATION)
  ctx(31) As Byte
  srv(31) As Byte
  dev(63) As Byte
  prp(63) As Byte
  units(15) As Byte
  desc(63) As Byte
  'help(31) As Byte
  idx As Long
  sidx As Long
  scale As Single
  offset As Single
  max As Single
  min As Single
  plot As Long
End Type

'AddFieldToStruct "HstCfg", 0, 32, CF_TEXT, "context"
'AddFieldToStruct "HstCfg", 32, 32, CF_TEXT, "server"
'AddFieldToStruct "HstCfg", 64, 64, CF_TEXT, "device"
'AddFieldToStruct "HstCfg", 128, 64, CF_TEXT, "property"
'AddFieldToStruct "HstCfg", 192, 16, CF_TEXT, "units"
'AddFieldToStruct "HstCfg", 208, 32, CF_TEXT, "help"
'AddFieldToStruct "HstCfg", 240, 1, CF_LONG, "index"
'AddFieldToStruct "HstCfg", 244, 1, CF_LONG, "subIndex"
'AddFieldToStruct "HstCfg", 248, 1, CF_FLOAT, "scale"
'AddFieldToStruct "HstCfg", 252, 1, CF_FLOAT, "offset"
'AddFieldToStruct "HstCfg", 256, 1, CF_FLOAT, "max"
'AddFieldToStruct "HstCfg", 260, 1, CF_FLOAT, "min"
'AddFieldToStruct "HstCfg", 264, 1, CF_LONG, "plot"
'SealTaggedStruct "HstCfg", 268, 100


Type McaCfg ' Multi-Channel Configurations (z.B. /DESY2/HISTORY: Property CONFIGURATION.MCA)
  ctx(31) As Byte
  srv(31) As Byte
  dev(63) As Byte
  prp(63) As Byte
  tag(15) As Byte
  desc(63) As Byte
  shell(63) As Byte
  alias(63) As Byte
  partner(63) As Byte
  reserved(127) As Byte
  append As Long
End Type


Type OprCfg ' Operation History Configuration (z.B. /DESY2/STATE: Property CONFIGURATION)
  ctx(31) As Byte ' based more on Mca ("stripped-down") than on Hst
  srv(31) As Byte
  dev(63) As Byte
  prp(63) As Byte

  'units(15) As Byte
  'desc(63) As Byte
  'format(63) As Byte
  'idx As Long
  'scale As Single
  'offset As Single
  'max As Single
  'min As Single
  'plot As Long
End Type ' 360

Type PrfCfg ' Operation History Profiles  (z.B. /DESY2/HISTORY: Property CONFIGURATION.MCA)
  sliceName(63) As Byte
  sliceType(15) As Byte
  sliceStates(511) As Byte
  sliceColor(15) As Byte
End Type ' 608

Type DHS
    ChannelID(31) As Byte
    EventCode As Long
    arraySize As Integer
    dataType As Integer
    samplingRate As Single
    PreTrigger As Long
    timeOffset As Long
    lowCount As Long
    highCount As Long
    egu(15) As Byte
    eguLow As Single
    eguHigh As Single
    DataLength  As Long  ' was Reserved(3) As Byte
    desc(255) As Byte
End Type


Type DHS_New
    ChannelName(63) As Byte
    ChannelDesc(255) As Byte
    EventCode As Long
    TineDataType As Integer ' I/Q -> Int-Int?
    
    arraySize As Long
    PreTrigger As Long ' trigger position in array
    
    ' Calculation of the TIME-AXIS
    ' STANDARD Scaling for the Time Axis: ScaleX * array-index + OffsetX
    ScaleX As Single ' (sec)
    OffsetX As Single ' (sec)
    
    ' ADC Scaling Info: "raw" data (V?) to physical units
    ScaleYDesc(15) As Byte ' Description of VERTICAL AXIS SCALING: LINEAR, QUADRATIC, IQ,....
    ScaleY(7) As Single ' Typical: LINEAR with  ScaleY(1) * Raw + Scale(0)
    
    ' Plot Info: SEPARATE "Input" ("HW") Max, Min; "Scaled" (EGU?) Max, Min?

    PlotMaxY As Single
    PlotMinY As Single
    UnitsY(15) As Byte

    reserved(255) As Byte
End Type

Type String128Long
    ErrorText(127) As Byte
    ErrorCode As Long
End Type

' Structure used for Trace-Viewers data information, packaged in property with decoration .INFO
' Example A scope server with data array property "Trace" has the information in property "Trace.INFO"
' and X-Axis Scaling (if necessary - see below) in property "Trace.XAXIS"
Type TraceHS
    ChannelName(63) As Byte
    ChannelDesc(255) As Byte
    TineDataType As Long
    arraySize As Long
    PreTrigger As Long ' trigger position (Time zero!) in array
    ' Calculation of the TIME-AXIS
    ' STANDARD Scaling for the Time Axis: ScaleX * array-index + OffsetX
    ' If THIS scaling information is NOT applicable, then an ADDITIONAL PROPERTY
    ' with decoration ".XAXIS" must be provided by the server  (one example: Server /DESY2/D2IBunchInj)
    ScaleX As Single ' (sec)
    OffsetX As Single ' (sec)
    UnitsX(15) As Byte ' Units for X-axis ("normally" "s", "sec" or "seconds") If "date" then data are "unix timestamps?
    PlotMaxY As Single ' Default maximum value for Y scale
    PlotMinY As Single ' Default minimum value for Y scale
    UnitsY(15) As Byte ' Units for Y-Axis
    reserved(255) As Byte
End Type

'Type CASQS
'devContext(15) As Byte
'devServer(15) As Byte
'subSystem(15) As Byte
'arcExt(15) As Byte
'SeverityLevel As Long
'ArchiveLevel As Long
'Retention As Long
'AlarmLevel As Long
'AlarmSystem As Long
'End Type

Type RPCSTRING
  text(255) As Byte
End Type

Declare Function LOADEQP Lib "apc32.dll" (ByVal filename$, ByVal yr%) As Integer
Declare Function CLOSEEQP Lib "apc32.dll" () As Integer
Declare Function LPC Lib "apc32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal size%, d As Any, ByVal dSize%, ByVal fmt%) As Integer
Declare Function apc Lib "apc32.dll" Alias "APC" (ByVal eqm$, ByVal dev$, ByVal prop$, ByVal size%, d As Any, ByVal fmt%) As Integer
Declare Function A_LPC Lib "apc32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function FILER Lib "apc32.dll" (ByVal fname$, f As FSTRUCT, ByVal num%, ByVal yr%) As Integer
Declare Function READCMT Lib "apc32.dll" (ByVal cmt$, ByVal filename$, ByVal yr%) As Integer
Declare Function WRITECMT Lib "apc32.dll" (ByVal cmt$, ByVal filename$, ByVal yr%) As Integer
Declare Function REMOVE Lib "apc32.dll" (ByVal filename$, ByVal yr%) As Integer
Declare Function GetEventList Lib "apc32.dll" (ByVal archiveGroup$, ByVal starttime&, ByVal stoptime&, numEvents%, evnList&, evnTime As NAME32) As Integer
Declare Function GetEvents Lib "apc32.dll" (ByVal archiveGroup$, ByVal starttime&, ByVal stoptime&, numEvents%, evnList&) As Integer
Declare Function GetEventData Lib "apc32.dll" (ByVal archiveGroup$, ByVal evnNr&, ByVal DevName$, ByVal devProperty$, npoints&, ByVal format%, DataBuffer As Any) As Integer

'==========================================================
'==                                                      ==
'==         HERA DATA Retrieval routines                 ==
'==                                                      ==
'==========================================================

Declare Function FETCH Lib "apc32.dll" (ByVal Keyword$, ByVal index%, ByVal Start&, ByVal Minutes%, ByVal size%, dat As Any, tstamp&) As Integer
Declare Sub fTime Lib "apc32.dll" Alias "FTIME" (dst!, src&, ByVal shft&, ByVal num%)
Declare Sub ARRLOG Lib "apc32.dll" (dst!, src!, ByVal num%)
Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
Function GetArchivedKeywordsLegacy(arcServerName As String, Keywords() As String, numKeywords As Integer) As Integer
Dim rc%, i%, n%, nprps&, kwd$
Dim lclprps(1000) As NAME32
Dim prps() As String
Dim cntxt As NAME16, srv As NAME16, dev As NAME16
' NEED CONTEXT!
nprps& = 1000
BARR cntxt.nam(), "": BARR srv.nam(), arcServerName: BARR dev.nam(), "#0"
rc% = T_GETDEVICEPROPERTIES(cntxt, srv, dev, lclprps(0), nprps&)
If rc% Then nprps& = 0
numKeywords = nprps&
If rc% Then GoTo GetArchivedKeywordsErr
ReDim Keywords(numKeywords)
n% = 0
For i% = 0 To numKeywords - 1
  kwd$ = BSTR(lclprps(i%).nam())
  If (kwd$ <> "FETCH") And (kwd$ <> "dummy") Then
    Keywords(n%) = kwd$
    n% = n% + 1
  End If
Next
numKeywords% = n%
GetArchivedKeywordsErr:
  GetArchivedKeywordsLegacy = rc%
End Function
Function GetPMArchivedStruct(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal DevName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As AMS)
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8, tmpContextServer$

Static SessionID As Integer
Static EventTag As String
Static pmArcGrp As String
Static done As Boolean

If Not done Then
  FILLSTRUCT "APCBLKr4", Len(apc), 1, CF_NULL
  done = True
End If
tmpContextServer$ = "/" + pmArchiveContext$ & "/" & pmArchiveServer$
rc& = 0
evnTag$ = LCase(evnTag$)
If EventTag <> evnTag Or pmArchiveGroup$ <> pmArcGrp Then ' new session
  EventTag = evnTag
  pmArcGrp = pmArchiveGroup$
  If SessionID% > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK(tmpContextServer$ & "/" & pmArchiveGroup$, "CLOSE", dout, 0, din, SessionID%, 1, 1000)
    If rc& Then GoTo GetPMArchivedStructError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedStructError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK(tmpContextServer$ & "/" & pmArchiveGroup$, "OPEN", dout, SessionID%, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedStructError
End If
If EventTag = "" Then GoTo GetPMArchivedStructError

p% = InStr(DevName$, "/")
If p% = 0 Then
  dServerName$ = DevName$
  dName$ = "#0"
Else
  dServerName$ = Left$(DevName$, p% - 1)
  dName$ = Right$(DevName$, Len(DevName$) - p%)
End If

apc.SessionID = SessionID%
BARR apc.CtxName(), casServerContext$
BARR apc.SrvName(), dServerName$
BARR apc.DevName(), dName$
BARR apc.PropName(), devProperty$
BARR apc.dTag(), "AMSr4"
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLKr4"

dout.dArrayLength = npoints
dout.dFormat = CF_STRUCT
rc& = T_EXECLINK(tmpContextServer$, "READDATA", dout, DataBuffer, din, apc, 1, 1000)
If rc& Then GoTo GetPMArchivedStructError

GetPMArchivedStructError:
GetPMArchivedStruct = rc&
End Function


Function GetPMArchivedStructLegacy(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal DevName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As AMSr3)
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8, tmpContextServer$

Static SessionID As Integer
Static EventTag As String
Static pmArcGrp As String
Static done As Boolean

'If pmArchiveServer$ = "" Then
' pmArchiveServer$ = "APC"
'End If

If Not done Then
  FILLSTRUCT "APCBLKr4", Len(apc), 1, CF_NULL
  done = True
End If
tmpContextServer$ = "/" + pmArchiveContext$ & "/" & pmArchiveServer$
rc& = 0
evnTag$ = LCase(evnTag$)
If EventTag <> evnTag Or pmArchiveGroup$ <> pmArcGrp Then ' new session
  EventTag = evnTag
  pmArcGrp = pmArchiveGroup$
  If SessionID% > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK(tmpContextServer$ & "/" & pmArchiveGroup$, "CLOSE", dout, 0, din, SessionID%, 1, 1000)
    If rc& Then GoTo GetPMArchivedStructError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedStructError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK(tmpContextServer$ & "/" & pmArchiveGroup$, "OPEN", dout, SessionID%, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedStructError
End If
If EventTag = "" Then GoTo GetPMArchivedStructError

p% = InStr(DevName$, "/")
If p% = 0 Then
  dServerName$ = DevName$
  dName$ = "#0"
Else
  dServerName$ = Left$(DevName$, p% - 1)
  dName$ = Right$(DevName$, Len(DevName$) - p%)
End If

apc.SessionID = SessionID%
BARR apc.SrvName(), dServerName$
BARR apc.DevName(), dName$
BARR apc.PropName(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLKr4"

dout.dArrayLength = npoints
dout.dFormat = CF_STRUCT
rc& = T_EXECLINK(tmpContextServer$, "READDATA", dout, DataBuffer, din, apc, 1, 1000)
If rc& Then GoTo GetPMArchivedStructError

GetPMArchivedStructError:
GetPMArchivedStructLegacy = rc&
End Function

Function GetArchivedKeywords(arcContext As String, arcServerName As String, Keywords() As String, numKeywords As Integer) As Integer
Dim rc%, i%, n%, nprps&, kwd$
Dim lclprps(1000) As NAME32
Dim prps() As String
Dim cntxt As NAME16, srv As NAME16, dev As NAME16
nprps& = 1000
BARR cntxt.nam(), arcContext: BARR srv.nam(), arcServerName: BARR dev.nam(), "#0"
rc% = T_GETDEVICEPROPERTIES(cntxt, srv, dev, lclprps(0), nprps&)
If rc% Then nprps& = 0
numKeywords = nprps&
If rc% Then GoTo GetArchivedKeywordsErr
ReDim Keywords(numKeywords)
n% = 0
For i% = 0 To numKeywords - 1
  kwd$ = BSTR(lclprps(i%).nam())
  If (kwd$ <> "FETCH") And (kwd$ <> "dummy") Then
    Keywords(n%) = kwd$
    n% = n% + 1
  End If
Next
numKeywords% = n%
GetArchivedKeywordsErr:
  GetArchivedKeywords = rc%
End Function

Function GetArchivedParameters(arcContextName As String, arcServerName As String, arcSubSystem As String, Keywords() As String, numKeywords As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim rc%, i%, n%, nprps&, kwd$
Dim lclprps(1000) As NAME32, subs As NAME16
Dim prps() As String
Dim searchstr(80) As Byte
Dim tmpName$
tmpName$ = arcContextName + "/" + arcServerName + "/#0"
dout.dFormat = CF_SHORT: dout.dArrayLength = 1
din.dFormat = CF_NULL: din.dArrayLength = 0
rc% = T_EXECLINK(tmpName$, "NTAGS", dout, numKeywords, din, 0, CA_READ, 1000)
If numKeywords > 1000 Then numKeywords = 1000
If rc% Then GoTo GetArchivedParametersErr
dout.dFormat = CF_NAME32: dout.dArrayLength = numKeywords
If Left(arcSubSystem, 7) = "SEARCH:" Then
  BARR searchstr, Right(arcSubSystem, Len(arcSubSystem) - 7)
  din.dFormat = CF_TEXT: din.dArrayLength = Len(arcSubSystem) - 7
ElseIf Len(arcSubSystem) = 0 Or arcSubSystem = "All Systems" Then
  subs.nam(0) = 0
  din.dFormat = CF_NULL: din.dArrayLength = 0
Else
  BARR searchstr, arcSubSystem
  din.dFormat = CF_NAME16: din.dArrayLength = 1
End If
rc% = T_EXECLINK(tmpName$, "TAGS", dout, lclprps(0), din, searchstr(0), CA_READ, 1000)
If rc% Then
  numKeywords = 0
  GoTo GetArchivedParametersErr
End If
ReDim Keywords(numKeywords)
n% = 0
For i% = 0 To numKeywords - 1
  kwd$ = BSTR(lclprps(i%).nam())
  If Len(kwd$) > 0 And _
     (kwd$ <> "dummy") And _
     (Right(kwd$, 4) <> ".NAM") Then
    Keywords(n%) = kwd$
    n% = n% + 1
  End If
Next
numKeywords = n%
GetArchivedParametersErr:
GetArchivedParameters = rc%
End Function
Function GetArchivedSubSystems(arcServerName As String, SubSystems() As String, numSubSystems As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim rc%, i%, n%
Dim lclsubs(100) As NAME16
Dim subs$, tmpName$
'tmpName$ = "/" + arcServerName
dout.dFormat = CF_SHORT: dout.dArrayLength = 1
din.dFormat = CF_NULL: din.dArrayLength = 0
rc% = T_EXECLINK(arcServerName, "NSUBSYSTEMS", dout, numSubSystems, din, 0, CA_READ, 1000)
'rc% = T_EXECLINK(tmpName$, "NSUBSYSTEMS", dout, numSubSystems, din, 0, CA_READ, 1000)
If rc% Then
  numSubSystems = 0
  GoTo GetArchivedSubSystemsErr
End If
If numSubSystems > 100 Then numSubSystems = 100
dout.dFormat = CF_NAME16: dout.dArrayLength = numSubSystems
rc% = T_EXECLINK(arcServerName, "SUBSYSTEMS", dout, lclsubs(0), din, 0, CA_READ, 1000)
If rc% Then
  numSubSystems = 0
  GoTo GetArchivedSubSystemsErr
End If
ReDim SubSystems(numSubSystems + 1)
For i% = 0 To numSubSystems - 1
  subs$ = BSTR(lclsubs(i%).nam())
  If Len(subs$) > 0 And (subs$ <> "Dummy") Then
    SubSystems(n%) = subs$
    n% = n% + 1
  End If
Next
SubSystems(n%) = "All Systems"
numSubSystems = n% + 1
GetArchivedSubSystemsErr:
GetArchivedSubSystems = rc%
End Function


' this is the NEW API
Function GetPMGroups(devSrvNames() As String, numDevSrvs As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim dsn() As NAME16
Dim rc%, i%
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(EventArchiveServer$, "NDSERVERS", dout, numDevSrvs, din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMGroupsErr

' Check if number is NEGATIVE!
If numDevSrvs < 0 Then
    Exit Function
ElseIf numDevSrvs = 0 Then
    MsgBox " Number of Device-Servers for " + EventArchiveServer$ + " is zero!!??@#$@!"
    numDevSrvs = 5
End If
ReDim dsn(numDevSrvs)

dout.dArrayLength = numDevSrvs: dout.dFormat = CF_NAME16
rc% = T_EXECLINK(EventArchiveServer$, "DSERVERS", dout, dsn(0), din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMGroupsErr
ReDim devSrvNames(numDevSrvs)
For i% = 0 To numDevSrvs - 1
  If dsn(i).nam(0) = 0 Then Exit For
  devSrvNames(i%) = BSTR(dsn(i%).nam())
Next
numDevSrvs = i%

GetPMGroupsErr:
  GetPMGroups = rc%
End Function

' this is the NEW API
Function GetPMDevices(ByVal pmDeviceServer$, DeviceNames() As String, numDevices As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim dn() As NAME16
Dim rc%, i%

dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "NADEVICES", dout, numDevices, din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMDevicesErr
If numDevices < 0 Then GoTo NegDevices
If numDevices = 0 Then GoTo NullDevices

ReDim dn(numDevices)
dout.dArrayLength = numDevices: dout.dFormat = CF_NAME16
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "ADEVICES", dout, dn(0), din, 0, CA_READ, 1000)
If rc% Then GoTo GetPMDevicesErr
ReDim DeviceNames(numDevices)
For i% = 0 To numDevices - 1
  DeviceNames(i%) = BSTR(dn(i%).nam())
Next
GetPMDevicesErr:
GetPMDevices = rc%
Exit Function

NegDevices:
GetPMDevices = -100
Exit Function

NullDevices:
GetPMDevices = 0 '
Exit Function
End Function

' this is the NEW API
Function GetPMProperties(ByVal pmDeviceServer$, Properties() As String, numProperties As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim prp() As NAME16
'Dim prp() As NAME32
Dim rc%, i%, p%
'Dim dev As NAME16
Dim dev As NAME32
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
p% = InStr(pmDeviceServer$, "/")
If p% > 0 Then
  din.dArrayLength = 1: din.dFormat = CF_NAME32 'CF_NAME16
  BARR dev.nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  pmDeviceServer$ = Left$(pmDeviceServer$, p% - 1)
Else
  din.dArrayLength = 0: din.dFormat = CF_NULL
End If
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "NAPROPS", dout, numProperties, din, dev, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr

ReDim prp(numProperties)
dout.dArrayLength = numProperties:
dout.dFormat = CF_NAME16 'CF_NAME32
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "APROPS", dout, prp(0), din, dev, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr
Debug.Print RPCERROR(rc%)
ReDim Properties(numProperties)
For i% = 0 To numProperties - 1
  Properties(i%) = BSTR(prp(i%).nam())
Next

GetPMPropertiesErr:
GetPMProperties = rc%
End Function

Function GetPMProperties64(ByVal pmDeviceServer$, Properties() As String, numProperties As Integer) As Integer
Dim dout As DBLK, din As DBLK
Dim prp() As NAME64
Dim rc%, i%, p%, tmpstr$
Dim dev As NAME16
'Dim dev As NAME64
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
p% = InStr(pmDeviceServer$, "/")
If p% > 0 Then
  din.dArrayLength = 1: din.dFormat = CF_NAME16
  tmpstr$ = Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  BARR dev.nam(), tmpstr$
  pmDeviceServer$ = Left$(pmDeviceServer$, p% - 1)
Else
  din.dArrayLength = 0: din.dFormat = CF_NULL
End If
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "NAPROPS", dout, numProperties, din, dev, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr

ReDim prp(numProperties)
dout.dArrayLength = numProperties:
dout.dFormat = CF_NAME64
rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "APROPS", dout, prp(0), din, dev, CA_READ, 1000)
If rc% Then GoTo GetPMPropertiesErr
Debug.Print RPCERROR(rc%)
ReDim Properties(numProperties)
For i% = 0 To numProperties - 1
  Properties(i%) = BSTR(prp(i%).nam())
Next

GetPMPropertiesErr:
GetPMProperties64 = rc%
End Function


'this has been deprecated
Function GetPMArchivedData(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal DevName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant)
Static SessionID As Integer
Static EventTag As String
Static pmArcGrp As String
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8, tmpContextServer$
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double
Static done As Boolean

If Not done Then
  FILLSTRUCT "APCBLKr4", Len(apc), 1, CF_NULL
  done = True
End If
tmpContextServer$ = "/" + pmArchiveContext$ & "/" & pmArchiveServer$
rc& = 0
evnTag$ = LCase(evnTag$)
If EventTag <> evnTag Or pmArchiveGroup$ <> pmArcGrp Then ' new session
  EventTag = evnTag
  pmArcGrp = pmArchiveGroup$
  If SessionID > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK(tmpContextServer$ & "/" & pmArchiveGroup$, "CLOSE", dout, 0, din, SessionID, 1, 1000)
    If rc& Then GoTo GetPMArchivedDataError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedDataError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK(tmpContextServer$ & "/" & pmArchiveGroup$, "OPEN", dout, SessionID, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedDataError
End If
If EventTag = "" Then GoTo GetPMArchivedDataError

p% = InStr(DevName$, "/")
If p% = 0 Then
  dServerName$ = DevName$
  dName$ = "#0"
Else
  dServerName$ = Left$(DevName$, p% - 1)
  dName$ = Right$(DevName$, Len(DevName$) - p%)
End If

apc.SessionID = SessionID
BARR apc.SrvName(), dServerName$
BARR apc.DevName(), dName$
BARR apc.PropName(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLKr4"

If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
  rc& = 2
  GoTo GetPMArchivedDataError
End If

dout.dArrayLength = npoints
Select Case VarType(DataBuffer) - vbArray
  Case vbInteger:
       ReDim ID(npoints)
       dout.dFormat = CF_SHORT
       rc& = T_EXECLINK(tmpContextServer$, "READDATA", dout, ID(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ID(i%): Next
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       rc& = T_EXECLINK(tmpContextServer$, "READDATA", dout, ld(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = ld(i%): Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       rc& = T_EXECLINK(tmpContextServer$, "READDATA", dout, fd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = fd(i%): Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       rc& = T_EXECLINK(tmpContextServer$, "READDATA", dout, dd(0), din, apc, 1, 1000)
       For i% = 0 To npoints - 1: DataBuffer(i%) = dd(i%): Next
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDataError

GetPMArchivedDataError:
GetPMArchivedData = rc&
End Function

'this is the NEW API
Function GetPMArchivedHeader(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal DevName$, ByVal devProperty$, hdr As DHS) As Integer
Dim devHdr As DHS
Dim devadrb As ADRB, abx As ADRBX
Dim pass%, rc%, p%, dServerName$, dName$, dContext$
Dim dout As DBLK, din As DBLK
Dim s$
Dim dlength As Long
Static done As Boolean

If Not done Then
  FILLSTRUCT "DHS", Len(devHdr), 1, CF_NULL
  FILLSTRUCT "ADRB", Len(devadrb), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

If Left$(DevName$, 1) = "/" Then
  p% = InStr(Right$(DevName$, Len(DevName$) - 1), "/")
  dContext$ = Mid$(DevName$, 2, p%)
  DevName$ = Right$(DevName$, Len(DevName$) - p% - 1)
End If

p% = InStr(DevName$, "/")
If p% = 0 Then
  dServerName$ = DevName$
  dName$ = "#0"
Else
  dServerName$ = Left$(DevName$, p% - 1)
  dName$ = Right$(DevName$, Len(DevName$) - p%)
End If

RetryGetPMArchivedHeader:
dout.dArrayLength = 1: dout.dFormat = CF_STRUCT: BARR dout.dTag(), "DHS"
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.stoptime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
    rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "ARCHHEADER", dout, devHdr, din, abx, CA_READ, 1000)
Else
    devadrb.eventNumber = evnNumber&
    BARR devadrb.deviceName(), dName$
    BARR devadrb.deviceServerName, dServerName$
    BARR devadrb.deviceProperty, devProperty$
    devadrb.starttime = evnNumber&
    devadrb.stoptime = evnNumber&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
    rc% = T_EXECLINK(EventArchiveServer$ + "/" & pmDeviceServer$, "ARCHHEADER", dout, devHdr, din, devadrb, CA_READ, 1000)
End If
pass% = pass% + 1
If (rc% = 2 Or rc% = 23 Or rc% = 38) And (pass% < 2) Then GoTo RetryGetPMArchivedHeader


'devadrb.eventNumber = evnNumber&
'BARR devadrb.deviceName(), dName$
'BARR devadrb.deviceServerName, dServerName$
'BARR devadrb.deviceProperty, devProperty$
'devadrb.StartTime = evnNumber&
'devadrb.stoptime = evnNumber&
'
'din.dArrayLength = 1: din.dFormat = CF_STRUCT: BARR din.dTag(), "ADRB"

GetPMArchivedHeader = rc% 'RPCERROR(rc%)
dlength = devHdr.arraySize
If dlength < 1 Then dlength = devHdr.DataLength Else devHdr.DataLength = dlength

hdr = devHdr
Exit Function

' OLD Version: return a STRING
If rc% Then
  'GetPMArchivedHeader = RPCERROR(rc%)
  Exit Function
End If

s$ = ""
s$ = s$ + "ChannelID : " + BSTR(devHdr.ChannelID()) + vbNewLine
s$ = s$ + "ArraySize : " + STR$(dlength) + vbNewLine
s$ = s$ + "DataType : " + STR$(devHdr.dataType) + vbNewLine
s$ = s$ + "EGU : " + BSTR(devHdr.egu()) + vbNewLine
s$ = s$ + "eguHigh : " + STR$(devHdr.eguHigh) + vbNewLine
s$ = s$ + "eguLow : " + STR$(devHdr.eguLow) + vbNewLine
s$ = s$ + "eventCode : " + STR$(devHdr.EventCode) + vbNewLine
s$ = s$ + "highCount : " + STR$(devHdr.highCount) + vbNewLine
s$ = s$ + "lowCount : " + STR$(devHdr.lowCount) + vbNewLine
s$ = s$ + "preTrigger : " + STR$(devHdr.PreTrigger) + vbNewLine
s$ = s$ + "timeOffset : " + STR$(devHdr.timeOffset) + vbNewLine
s$ = s$ + "samplingRate : " + STR$(devHdr.samplingRate) + vbNewLine
s$ = s$ + "desc : " + BSTR(devHdr.desc()) + vbNewLine
'GetPMArchivedHeader = s$
End Function
'this is the NEW API
Function GetPMArchivedTaggedHeader(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal DevName$, ByVal devProperty$, hdr As DHS) As Integer
Dim devHdr As DHS
Dim devadrb As ADRB, abx As ADRBX
Dim pass%, rc%, p%, dServerName$, dName$, dContext$, pmServerContext$
Dim dout As DBLK, din As DBLK
Dim s$
Dim dlength As Long
Static done As Boolean

If Not done Then
  FILLSTRUCT "DHS", Len(devHdr), 1, CF_NULL
  FILLSTRUCT "ADRB", Len(devadrb), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

If Left$(DevName$, 1) = "/" Then
  p% = InStr(Right$(DevName$, Len(DevName$) - 1), "/")
  dContext$ = Mid$(DevName$, 2, p%)
  DevName$ = Right$(DevName$, Len(DevName$) - p% - 1)
End If

p% = InStr(DevName$, "/")
If p% = 0 Then
  dServerName$ = DevName$
  dName$ = "#0"
Else
  dServerName$ = Left$(DevName$, p% - 1)
  dName$ = Right$(DevName$, Len(DevName$) - p%)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If


RetryGetPMArchivedHeader:
dout.dArrayLength = 1: dout.dFormat = CF_STRUCT: BARR dout.dTag(), "DHS"
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.stoptime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
    rc% = T_EXECLINK(pmServerContext$, "ARCHHEADER", dout, devHdr, din, abx, CA_READ, 1000)
Else
    devadrb.eventNumber = evnNumber&
    BARR devadrb.deviceName(), dName$
    BARR devadrb.deviceServerName, dServerName$
    BARR devadrb.deviceProperty, devProperty$
    devadrb.starttime = evnNumber&
    devadrb.stoptime = evnNumber&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
    rc% = T_EXECLINK(pmServerContext$, "ARCHHEADER", dout, devHdr, din, devadrb, CA_READ, 1000)
End If
pass% = pass% + 1
If (rc% = 2 Or rc% = 23 Or rc% = 38) And (pass% < 2) Then GoTo RetryGetPMArchivedHeader

GetPMArchivedTaggedHeader = rc%

hdr = devHdr
Exit Function

End Function

'this is the NEW API
Function GetPMArchivedTraceHeader(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal DevName$, ByVal devProperty$, hdr As TraceHS) As Integer
Dim devHdr As TraceHS
Dim devadrb As ADRB, abx As ADRBr4
Dim pass%, rc%, p%, dServerName$, dName$, dContext$, pmServerContext$
Dim dout As DBLK, din As DBLK
Dim s$
Dim dlength As Long
Static done As Boolean

If Not done Then
  'FILLSTRUCT "TraceHS", Len(devHdr), 1, CF_NULL
  FILLSTRUCT "ADRBr4", Len(abx), 1, CF_NULL
  done = True
End If

If Left$(DevName$, 1) = "/" Then
  p% = InStr(Right$(DevName$, Len(DevName$) - 1), "/")
  dContext$ = Mid$(DevName$, 2, p%)
  DevName$ = Right$(DevName$, Len(DevName$) - p% - 1)
End If

p% = InStr(DevName$, "/")
If p% = 0 Then
  dServerName$ = DevName$
  dName$ = "#0"
Else
  dServerName$ = Left$(DevName$, p% - 1)
  dName$ = Right$(DevName$, Len(DevName$) - p%)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If


RetryGetPMArchivedHeader:
dout.dArrayLength = 1: dout.dFormat = CF_STRUCT: BARR dout.dTag(), "TraceHS"
    
    
BARR abx.deviceContext(), dContext$ '"FLASH" '
BARR abx.deviceServerName(), dServerName$
BARR abx.deviceName(), dName$ '"#3" 'dName$
BARR abx.deviceProperty(), devProperty$
abx.eventNumber = evnNumber&
abx.starttime = evnNumber&
abx.stoptime = evnNumber&
abx.dataIndex = dIndex&
abx.DataFormat = CF_STRUCT

din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "ADRBr4"
rc% = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, devHdr, din, abx, CA_READ, 1000)

GetPMArchivedTraceHeader = rc%

hdr = devHdr
Exit Function

End Function





' this is the NEW API
Function GetPMArchivedDeviceDataWithTimeout(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal DevName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant, DataTimeOut&)
Static pmDevSrv As String
Dim dout As DBLK, din As DBLK
Dim ab As ADRB, abx As ADRBX
Dim rc&, p%, dContext$, dServerName$, dName$, dIndex&, evn As NAME8, pmServerContext$
Dim i As Long
Dim pass%, vtype As Integer, isArray As Boolean
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double, bd() As Byte, tmpStatus&, tmpRCStatus&
Dim ds() As Byte, tmpTimeOut&, iAnswer%
Static done As Boolean

If Not done Then
  FILLSTRUCT "ADRB", Len(ab), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

rc& = 0
If Left$(DevName$, 1) = "/" Then
  p% = InStr(Right$(DevName$, Len(DevName$) - 1), "/")
  dContext$ = Mid$(DevName$, 2, p%)
  DevName$ = Right$(DevName$, Len(DevName$) - p% - 1)
End If
p% = InStr(DevName$, "/") '  z.B. L2TRCrf/#0
If p% = 0 Then
    dServerName$ = DevName$
    dName$ = "#0"
Else
    dServerName$ = Left$(DevName$, p% - 1)
    dName$ = Right$(DevName$, Len(DevName$) - p%)
End If
p% = InStr(dName$, "[") ' z.B. ALL_DATA[3]
If p% = 0 Then
  dIndex& = 0
Else
  dIndex& = Val(Right$(dName$, Len(dName$) - p%))
  dName$ = Left$(dName$, p% - 1)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If
'pmServerContext$ = EventArchiveServer$

retryGetPMArchivedData:
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.stoptime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
Else
    BARR ab.deviceServerName(), dServerName$
    BARR ab.deviceName(), dName$
    BARR ab.deviceProperty(), devProperty$
    ab.eventNumber = evnNumber&
    ab.starttime = evnNumber&
    ab.stoptime = evnNumber&
    
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
End If
pass% = pass% + 1
If VarType(DataBuffer) > vbArray Then
  If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
  vtype = VarType(DataBuffer) - vbArray
  isArray = True
ElseIf VarType(DataBuffer) = vbString Then
  vtype = vbString
Else
  vtype = VarType(DataBuffer)
  If npoints <> 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
End If
tmpTimeOut& = DataTimeOut&
TryAgain:

dout.dArrayLength = npoints
Select Case vtype
  Case vbInteger:
       ReDim ID(npoints)
       dout.dFormat = CF_SHORT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ID(0), din, abx, 1, tmpTimeOut&)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ID(0), din, ab, 1, tmpTimeOut&)
       End If
        If rc& = 45 Then
            iAnswer% = MsgBox("Error reading data: TIMEOUT! ", vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
            ElseIf iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 500
                GoTo TryAgain
            Else
            End If
        End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       ' Signed, or unsigned?
       For i = 0 To npoints - 1
           'If id(i) < 0 Then
           If isArray Then
               DataBuffer(i) = ID(i)
           Else
             DataBuffer = ID(i)
           End If
           'Else
           '    DataBuffer(i) = id(i) + &HFFFF
           'End If
      Next i
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, abx, 1, tmpTimeOut&)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, ab, 1, tmpTimeOut&)
       End If
        If rc& = 45 Then
            iAnswer% = MsgBox("Error reading data: ", vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
            ElseIf iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 500
                GoTo TryAgain
            Else
            End If
        End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = ld(i): Next
       Else
         DataBuffer = ld(0)
       End If
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, abx, 1, tmpTimeOut&)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, ab, 1, tmpTimeOut&)
       End If
        If rc& = 45 Then
            iAnswer% = MsgBox("Error reading data: ", vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
            ElseIf iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 500
                GoTo TryAgain
            Else
            End If
        End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) Then
        If (pass% < 2) Then GoTo retryGetPMArchivedData
       Else
        Dim ustrStatus(31) As Byte, strStatus As String
        dout.dArrayLength = 32
        dout.dFormat = CF_TEXT
        If pass% < 2 Then
         BARR abx.deviceProperty(), devProperty$ + ".STS"
         tmpRCStatus& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ustrStatus(0), din, abx, 1, tmpTimeOut&)
        Else
         BARR ab.deviceProperty(), devProperty$ + ".STS"
         tmpRCStatus& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ustrStatus(0), din, ab, 1, tmpTimeOut&)
        End If
        strStatus = BSTR(ustrStatus)
       End If
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = fd(i): Next
       Else
         DataBuffer = fd(0)
       End If
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, abx, 1, tmpTimeOut&)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, ab, 1, tmpTimeOut&)
       End If
        If rc& = 45 Then
            iAnswer% = MsgBox("Error reading data: ", vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
            ElseIf iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 500
                GoTo TryAgain
            Else
            End If
        End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = dd(i): Next
       Else
         DataBuffer = dd(0)
       End If
  Case vbByte:
       ReDim bd(npoints)
       dout.dFormat = CF_BYTE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, abx, 1, tmpTimeOut&)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, ab, 1, tmpTimeOut&)
       End If
        If rc& = 45 Then
            iAnswer% = MsgBox("Error reading data: ", vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
            ElseIf iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 500
                GoTo TryAgain
            Else
            End If
        End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = bd(i): Next
       Else
         DataBuffer = bd(0)
       End If
  Case vbString:
       ReDim ds(npoints)
       Select Case npoints
         Case 48:
           dout.dFormat = CF_NAME48
           dout.dArrayLength = 1
         Case 32:
           dout.dFormat = CF_NAME32
           dout.dArrayLength = 1
         Case 16:
           dout.dFormat = CF_NAME16
           dout.dArrayLength = 1
         Case Else:
           dout.dFormat = CF_TEXT
       End Select
        If rc& = 45 Then
            iAnswer% = MsgBox("Error reading data: ", vbAbortRetryIgnore)
            If iAnswer% = vbAbort Then
            ElseIf iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 500
                GoTo TryAgain
            Else
            End If
        End If
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, abx, 1, tmpTimeOut&)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, ab, 1, tmpTimeOut&)
       End If
       If (rc& = 2 Or rc& = 23) And (pass% < 2) Then GoTo retryGetPMArchivedData
       DataBuffer = BSTR(ds)
         
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDeviceDataError

GetPMArchivedDeviceDataError:
GetPMArchivedDeviceDataWithTimeout = rc&
End Function

' this is the NEW API
Function GetPMArchivedDeviceData(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal DevName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant)
Static pmDevSrv As String
Dim dout As DBLK, din As DBLK
Dim abx As ADRBr4
Dim rc&, p%, dContext$, dServerName$, dName$, dIndex&, evn As NAME8, pmServerContext$
Dim i As Long
Dim pass%, vtype As Integer, isArray As Boolean
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double, bd() As Byte, tmpStatus&, tmpRCStatus&
Dim ds() As Byte
Static done As Boolean

If Not done Then
  'FILLSTRUCT "ADRB", Len(ab), 1, CF_NULL
  FILLSTRUCT "ADRBr4", Len(abx), 1, CF_NULL
  done = True
End If

rc& = 0
If Left$(DevName$, 1) = "/" Then
  p% = InStr(Right$(DevName$, Len(DevName$) - 1), "/")
  dContext$ = Mid$(DevName$, 2, p% - 1)
  DevName$ = Right$(DevName$, Len(DevName$) - p% - 1)
End If
p% = InStr(DevName$, "/") '  z.B. L2TRCrf/#0
If p% = 0 Then
    dServerName$ = DevName$
    dName$ = "#0"
Else
    dServerName$ = Left$(DevName$, p% - 1)
    dName$ = Right$(DevName$, Len(DevName$) - p%)
End If
p% = InStr(dName$, "[") ' z.B. ALL_DATA[3]
If p% = 0 Then
  dIndex& = 0
Else
  dIndex& = Val(Right$(dName$, Len(dName$) - p%))
  dName$ = Left$(dName$, p% - 1)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If
'pmServerContext$ = EventArchiveServer$
pass% = 0

retryGetPMArchivedData:
BARR abx.deviceContext(), dContext$
BARR abx.deviceServerName(), dServerName$
BARR abx.deviceName(), dName$
BARR abx.deviceProperty(), devProperty$
abx.eventNumber = evnNumber&
abx.starttime = evnNumber&
abx.stoptime = evnNumber&
abx.dataIndex = dIndex&
abx.DataFormat = CF_STRUCT

pass% = pass% + 1

din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "ADRBr4"

'Type ADRBr4
'  eventNumber As Long
'  starttime As Long
'  stoptime As Long
'  deviceContext(31) As Byte
'  deviceServerName(31) As Byte
'  deviceProperty(63) As Byte
'  deviceName(63) As Byte
'  dataTag(15) As Byte
'  DataFormat As Integer
'  reserved As Integer
'  dataIndex As Long
'  dataDimension As Long
'End Type  ' "ADRBr4"

If VarType(DataBuffer) > vbArray Then
  If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
  vtype = VarType(DataBuffer) - vbArray
  isArray = True
ElseIf VarType(DataBuffer) = vbString Then
  vtype = vbString
Else
  vtype = VarType(DataBuffer)
  If npoints <> 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
End If

dout.dArrayLength = npoints
Select Case vtype
  Case vbInteger:
        ReDim ID(npoints)
        dout.dFormat = CF_SHORT
        rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ID(0), din, abx, 1, 2000)
       If rc& <> 0 Then GoTo GetPMArchivedDeviceDataError
       ' Signed, or unsigned?
       For i = 0 To npoints - 1
           'If id(i) < 0 Then
           If isArray Then
               DataBuffer(i) = ID(i)
           Else
             DataBuffer = ID(i)
           End If
           'Else
           '    DataBuffer(i) = id(i) + &HFFFF
           'End If
      Next i
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, abx, 1, 2000)
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = ld(i): Next
       Else
         DataBuffer = ld(0)
       End If
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
        rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, abx, 1, 2000)
       If rc& <> 0 Then GoTo GetPMArchivedDeviceDataError
        
        Dim ustrStatus(31) As Byte, strStatus As String
        dout.dArrayLength = 32
        dout.dFormat = CF_TEXT
         
         BARR abx.deviceProperty(), devProperty$ + ".STS"
         tmpRCStatus& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ustrStatus(0), din, abx, 1, 2000)
        
        strStatus = BSTR(ustrStatus)
       
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = fd(i): Next
       Else
         DataBuffer = fd(0)
       End If
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = dd(i): Next
       Else
         DataBuffer = dd(0)
       End If
  Case vbByte:
       ReDim bd(npoints)
       dout.dFormat = CF_BYTE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = bd(i): Next
       Else
         DataBuffer = bd(0)
       End If
  Case vbString:
       ReDim ds(npoints)
       Select Case npoints
         Case 48:
           dout.dFormat = CF_NAME48
           dout.dArrayLength = 1
         Case 32:
           dout.dFormat = CF_NAME32
           dout.dArrayLength = 1
         Case 16:
           dout.dFormat = CF_NAME16
           dout.dArrayLength = 1
         Case Else:
           dout.dFormat = CF_TEXT
       End Select
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23) And (pass% < 2) Then GoTo retryGetPMArchivedData
       DataBuffer = BSTR(ds)
         
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDeviceDataError

GetPMArchivedDeviceDataError:
GetPMArchivedDeviceData = rc&
End Function

Function GetPMArchivedDeviceDataLegacy(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal DevName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant)
Static pmDevSrv As String
Dim dout As DBLK, din As DBLK
Dim ab As ADRB, abx As ADRBX
Dim rc&, p%, dContext$, dServerName$, dName$, dIndex&, evn As NAME8, pmServerContext$
Dim i As Long
Dim pass%, vtype As Integer, isArray As Boolean
Dim ID() As Integer, ld() As Long, fd() As Single, dd() As Double, bd() As Byte, tmpStatus&, tmpRCStatus&
Dim ds() As Byte
Static done As Boolean

If Not done Then
  FILLSTRUCT "ADRB", Len(ab), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

rc& = 0
If Left$(DevName$, 1) = "/" Then
  p% = InStr(Right$(DevName$, Len(DevName$) - 1), "/")
  dContext$ = Mid$(DevName$, 2, p%)
  DevName$ = Right$(DevName$, Len(DevName$) - p% - 1)
End If
p% = InStr(DevName$, "/") '  z.B. L2TRCrf/#0
If p% = 0 Then
    dServerName$ = DevName$
    dName$ = "#0"
Else
    dServerName$ = Left$(DevName$, p% - 1)
    dName$ = Right$(DevName$, Len(DevName$) - p%)
End If
p% = InStr(dName$, "[") ' z.B. ALL_DATA[3]
If p% = 0 Then
  dIndex& = 0
Else
  dIndex& = Val(Right$(dName$, Len(dName$) - p%))
  dName$ = Left$(dName$, p% - 1)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If
'pmServerContext$ = EventArchiveServer$

retryGetPMArchivedData:
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.stoptime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
Else
    BARR ab.deviceServerName(), dServerName$
    BARR ab.deviceName(), dName$
    BARR ab.deviceProperty(), devProperty$
    ab.eventNumber = evnNumber&
    ab.starttime = evnNumber&
    ab.stoptime = evnNumber&
    
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
End If
pass% = pass% + 1
If VarType(DataBuffer) > vbArray Then
  If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
  vtype = VarType(DataBuffer) - vbArray
  isArray = True
ElseIf VarType(DataBuffer) = vbString Then
  vtype = vbString
Else
  vtype = VarType(DataBuffer)
  If npoints <> 1 Then
    rc& = 2
    GoTo GetPMArchivedDeviceDataError
  End If
End If

dout.dArrayLength = npoints
Select Case vtype
  Case vbInteger:
       ReDim ID(npoints)
       dout.dFormat = CF_SHORT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ID(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ID(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       ' Signed, or unsigned?
       For i = 0 To npoints - 1
           'If id(i) < 0 Then
           If isArray Then
               DataBuffer(i) = ID(i)
           Else
             DataBuffer = ID(i)
           End If
           'Else
           '    DataBuffer(i) = id(i) + &HFFFF
           'End If
      Next i
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = ld(i): Next
       Else
         DataBuffer = ld(0)
       End If
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) Then
        If (pass% < 2) Then GoTo retryGetPMArchivedData
       Else
        Dim ustrStatus(31) As Byte, strStatus As String
        dout.dArrayLength = 32
        dout.dFormat = CF_TEXT
        If pass% < 2 Then
         BARR abx.deviceProperty(), devProperty$ + ".STS"
         tmpRCStatus& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ustrStatus(0), din, abx, 1, 2000)
        Else
         BARR ab.deviceProperty(), devProperty$ + ".STS"
         tmpRCStatus& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ustrStatus(0), din, ab, 1, 2000)
        End If
        strStatus = BSTR(ustrStatus)
       End If
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = fd(i): Next
       Else
         DataBuffer = fd(0)
       End If
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = dd(i): Next
       Else
         DataBuffer = dd(0)
       End If
  Case vbByte:
       ReDim bd(npoints)
       dout.dFormat = CF_BYTE
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, bd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMArchivedData
       If isArray Then
         For i = 0 To npoints - 1: DataBuffer(i) = bd(i): Next
       Else
         DataBuffer = bd(0)
       End If
  Case vbString:
       ReDim ds(npoints)
       Select Case npoints
         Case 48:
           dout.dFormat = CF_NAME48
           dout.dArrayLength = 1
         Case 32:
           dout.dFormat = CF_NAME32
           dout.dArrayLength = 1
         Case 16:
           dout.dFormat = CF_NAME16
           dout.dArrayLength = 1
         Case Else:
           dout.dFormat = CF_TEXT
       End Select
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ds(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23) And (pass% < 2) Then GoTo retryGetPMArchivedData
       DataBuffer = BSTR(ds)
         
  Case Else:
       rc& = 2 ' illegal_format
End Select
If rc& Then GoTo GetPMArchivedDeviceDataError

GetPMArchivedDeviceDataError:
GetPMArchivedDeviceDataLegacy = rc&
End Function


' this has been deprecated
Function GetPMEventList(ByVal pmArchiveGroup$, ByVal starttime&, ByVal stoptime&, evnList() As String, evnTime() As String) As Integer
Dim dout As DBLK, din As DBLK
Dim nevents As Integer
Dim lStartStopArray(1) As Long
Dim eventNames() As NAME8
Dim i%, rc&, tmpTime As String * 32
Dim timeout&
Dim DevName$

timeout& = 1000
DevName$ = pmArchiveContext$ & "/" & pmArchiveServer$ & "/" & pmArchiveGroup$
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 2: din.dFormat = CF_LONG
lStartStopArray(0) = starttime&
lStartStopArray(1) = stoptime&
rc& = T_EXECLINK(DevName, "QUERY.NFILES", dout, nevents, din, lStartStopArray(0), 1, timeout&)
If rc& Then GoTo GetPMEventListError

If nevents = 0 Then GoTo GetPMEventListError
ReDim eventNames(nevents - 1)

If nevents > 5000 Then timeout& = 3000
dout.dArrayLength = nevents: dout.dFormat = CF_NAME8
rc& = T_EXECLINK(DevName, "QUERY.FILES", dout, eventNames(0), din, lStartStopArray(0), 1, timeout&)
If rc& Then GoTo GetPMEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = BSTR(eventNames(i%).nam())
  CTIME tmpTime, CLng(Val("&H" & evnList(i%)))
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMEventListError:
GetPMEventList = IIf(rc&, -rc&, nevents)
End Function

' this is the NEW API
Function GetPMDeviceEventList(ByVal pmDeviceServer$, ByVal starttime&, ByVal stoptime&, evnList() As Long, evnTime() As String) As Long
Dim dout As DBLK, din As DBLK
Dim nevents As Long
Dim lStartStopArray(1) As Long
Dim events() As Long
Dim i%, p%, rc&, tmpTime As String * 32
Dim dev As NAME16
Dim namStartStopArray(1) As NAME16I
Dim DevName$ ' AL. 10. Mar. 2006

p% = InStr(pmDeviceServer$, "/")
If p% > 0 Then
  din.dArrayLength = 2: din.dFormat = CF_NAME16I
  BARR dev.nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  namStartStopArray(0).iVal = starttime&
  namStartStopArray(1).iVal = stoptime&
  BARR namStartStopArray(0).nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  pmDeviceServer$ = Left$(pmDeviceServer$, p% - 1)
Else
  lStartStopArray(0) = starttime&
  lStartStopArray(1) = stoptime&
  din.dArrayLength = 2: din.dFormat = CF_LONG
End If

DevName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_LONG

If p% > 0 Then
  rc& = T_EXECLINK(DevName, "NDEVEVENTS", dout, nevents, din, namStartStopArray(0), 1, 1000)
Else
  rc& = T_EXECLINK(DevName, "NDEVEVENTS", dout, nevents, din, lStartStopArray(0), 1, 1000)
End If
If rc& Then GoTo GetPMDeviceEventListError

If nevents > 5000 Then
    MsgBox " Number of Events = " + STR$(nevents) + "!!!! Only reading 5000."
    nevents = 5000
ElseIf nevents < 0 Then
    MsgBox " Number of Events = " + STR$(nevents) + "!!!! Setting to ZERO!"
    nevents = 0
End If
If nevents = 0 Then GoTo GetPMDeviceEventListError
ReDim events(nevents - 1)

dout.dArrayLength = nevents: dout.dFormat = CF_LONG
If p% > 0 Then
  rc& = T_EXECLINK(DevName, "DEVEVENTS", dout, events(0), din, namStartStopArray(0), 1, 1000)
Else
  rc& = T_EXECLINK(DevName, "DEVEVENTS", dout, events(0), din, lStartStopArray(0), 1, 1000)
End If

If rc& Then GoTo GetPMDeviceEventListError
ReDim evnList(nevents)
ReDim evnTime(nevents)

For i% = 0 To nevents - 1
  evnList(i%) = events(i%)
  CTIME tmpTime, events(i%)
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMDeviceEventListError:
GetPMDeviceEventList = IIf(rc&, -rc&, nevents)
End Function

' this is the NEW API with TimeOut as parameter
Function GetPMDeviceEventListWithTimeOut(ByVal pmDeviceServer$, ByVal starttime&, ByVal stoptime&, evnList() As Long, evnTime() As String, timeout&) As Long
Dim dout As DBLK, din As DBLK
Dim nevents As Long
Dim lStartStopArray(1) As Long
Dim events() As Long
Dim i%, p%, rc&, tmpTime As String * 32
Dim dev As NAME16
Dim namStartStopArray(1) As NAME16I
Dim DevName$ ' AL. 10. Mar. 2006

p% = InStr(pmDeviceServer$, "/")
If p% > 0 Then
  din.dArrayLength = 2: din.dFormat = CF_NAME16I
  BARR dev.nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  namStartStopArray(0).iVal = starttime&
  namStartStopArray(1).iVal = stoptime&
  BARR namStartStopArray(0).nam(), Right$(pmDeviceServer$, Len(pmDeviceServer$) - p%)
  pmDeviceServer$ = Left$(pmDeviceServer$, p% - 1)
Else
  lStartStopArray(0) = starttime&
  lStartStopArray(1) = stoptime&
  din.dArrayLength = 2: din.dFormat = CF_LONG
End If

DevName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_LONG

If p% > 0 Then
  rc& = T_EXECLINK(DevName, "NDEVEVENTS", dout, nevents, din, namStartStopArray(0), 1, timeout&)
Else
  rc& = T_EXECLINK(DevName, "NDEVEVENTS", dout, nevents, din, lStartStopArray(0), 1, timeout&)
End If
If rc& Then GoTo GetPMDeviceEventListError

Dim tmpMax%
tmpMax% = 10000 '5000
If nevents > tmpMax% Then
    MsgBox " Number of Events = " + STR$(nevents) + "!!!! Only reading " + STR$(tmpMax%) + "." '10000."
    nevents = tmpMax%
ElseIf nevents < 0 Then
    MsgBox " Number of Events = " + STR$(nevents) + "!!!! Setting to ZERO!"
    nevents = 0
End If
If nevents = 0 Then GoTo GetPMDeviceEventListError
ReDim events(nevents - 1)

dout.dArrayLength = nevents: dout.dFormat = CF_LONG
If p% > 0 Then
  rc& = T_EXECLINK(DevName, "DEVEVENTS", dout, events(0), din, namStartStopArray(0), 1, timeout&)
Else
  rc& = T_EXECLINK(DevName, "DEVEVENTS", dout, events(0), din, lStartStopArray(0), 1, timeout&)
End If

If rc& Then GoTo GetPMDeviceEventListError
If nevents > tmpMax% Then nevents = tmpMax%
ReDim evnList(nevents)
ReDim evnTime(nevents)
' evnTime causes memory out of range for > 5000 events?

For i% = 0 To nevents - 1
  evnList(i%) = events(i%)
  CTIME tmpTime, events(i%)
  evnTime(i%) = Left$(tmpTime, 24)
Next

GetPMDeviceEventListError:
GetPMDeviceEventListWithTimeOut = IIf(rc&, -rc&, nevents)
End Function


Function GetHistoryData(ByVal DevName, ByVal devProperty As String, ByVal ArrayIndex, ByVal starttime As Long, ByVal stoptime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer)
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer, nread As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim legacySystem As Boolean
Dim arrayOffset As Integer

lStartStopArray(0) = starttime
lStartStopArray(1) = stoptime
lStartStopArray(2) = ArrayIndex

If npoints = 0 Then
  npts = stoptime - starttime ' won't be any worse than this
  If npts > 1000 Then npts = 1000
  If npts <= 0 Then
    npts = 0
    GetHistoryData = 0
    Exit Function
  End If
Else
  npts = npoints
End If
LaunchHistoryLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(DevName, devProperty & ".HIST", dout, fiDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo HistoryError
'If (fiDataArray(0).iVal <= npts) Or (npts > 150) Then done = True
'npts = fiDataArray(0).iVal
nread = dout.dArrayLength
If (nread <= npts) Or (npts > 150) Then done = True
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts > 16000 Then npts = 16000
If Not done Then GoTo LaunchHistoryLink
If npts > 0 Then
  ReDim fDataArray(npts - 1)
  ReDim lTimeArray(npts - 1)
End If
For i = 0 To npts - 1
  fDataArray(i) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i) = fiDataArray(i + arrayOffset).iVal
Next
'npoints = npts - 1
npoints = npts
HistoryError:
GetHistoryData = rc&

End Function
Function GetHistoryDataTrace(ByVal DevName, ByVal devProperty As String, ByVal ArrayIndex, ByVal targetTime As Long, fDataArray() As Single, npoints As Integer)
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer
Dim dout As DBLK, din As DBLK
Dim done As Boolean

lStartStopArray(0) = targetTime
lStartStopArray(1) = targetTime
lStartStopArray(2) = ArrayIndex

npts = npoints
LaunchHistoryTraceLink:
'ReDim fiDataArray(npts)
dout.dArrayLength = npts: dout.dFormat = CF_FLOAT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(DevName, devProperty & ".HIST", dout, fDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo HistoryTraceError
npoints = dout.dArrayLength
HistoryTraceError:
GetHistoryDataTrace = rc&

End Function

Function GetArchivedDataEx(ByVal context As String, ByVal Keyword As String, ByVal KeywordIndex As Integer, ByVal starttime As Long, ByVal stoptime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer, nread As Integer, nretry As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim ArchiveServer$
Dim legacySystem As Boolean
Dim arrayOffset As Integer

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
End Select

If MaxNumHistoryPoints = 0 Then MaxNumHistoryPoints = 5000

lStartStopArray(0) = starttime
lStartStopArray(1) = stoptime
lStartStopArray(2) = KeywordIndex

'npts = stoptime - StartTime ' won't be any worse than this
If npoints > 1 And npoints < MaxNumHistoryPoints Then
  npts = npoints
Else
  npts = MaxNumHistoryPoints - 1 ' start off at a reasonable number
End If

timout = 500

LaunchArchiveLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
If KeywordIndex > 0 Then din.dArrayLength = 3 Else din.dArrayLength = 2
din.dFormat = CF_LONG
'timout = iif(stoptime -starttime > 100000 ?
rc& = T_EXECLINK(ArchiveServer$, Keyword, dout, fiDataArray(0), din, lStartStopArray(0), 1, timout)
If rc& = tine.link_not_open And nretry < 2 Then
  nretry = nretry + 1
  timout = timout + 2000
  GoTo LaunchArchiveLink
End If
If rc& Then GoTo ArchiveErrorEx

nread = dout.dArrayLength
If (nread <= npts) Then done = True
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset

If npts = 0 Then
    ReDim fDataArray(1)
    ReDim lTimeArray(1)
    GoTo ArchiveErrorEx
End If
If Not done Then GoTo LaunchArchiveLink
If (npoints > 1) And (npts < npoints) Then
    ReDim fDataArray(npoints - 1)
    ReDim lTimeArray(npoints - 1)
    offset = npoints - npts - 1
Else
    ReDim fDataArray(npts - 1)
    ReDim lTimeArray(npts - 1)
    offset = 0
    npoints = npts
End If
For i = 0 To npts - 1
  fDataArray(i + offset) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i + offset) = fiDataArray(i + arrayOffset).iVal
Next
ArchiveErrorEx:
GetArchivedDataEx = rc&
End Function

Function GetArchivedTraceData(ByVal context, ByVal Keyword As String, ByVal targetTime As Long, fDataArray() As Single) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim dout As DBLK, din As DBLK
Dim ArchiveServer$

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
End Select

lStartStopArray(0) = targetTime
lStartStopArray(1) = targetTime
lStartStopArray(2) = 0

npts = UBound(fDataArray) - LBound(fDataArray)
If npts = 0 Then
  GetArchivedTraceData = 0
  Exit Function
End If
LaunchArchiveLink:
dout.dArrayLength = npts: dout.dFormat = CF_FLOAT
If KeywordIndex > 0 Then din.dArrayLength = 3 Else din.dArrayLength = 2
din.dFormat = CF_LONG
GetArchivedTraceData = T_EXECLINK(ArchiveServer$, Keyword, dout, fDataArray(0), din, lStartStopArray(0), 1, 1000)
End Function


Function GetArchivedData(ByVal Keyword As String, ByVal KeywordIndex As Integer, ByVal starttime As Long, ByVal stoptime As Long, fDataArray() As Single, lTimeArray() As Long, npoints As Integer) As Integer
Dim lStartStopArray(2) As Long
Dim npts As Long, nread As Long
Dim rc&, i As Integer
Dim dout As DBLK, din As DBLK
Dim fiDataArray() As FLTINT
Dim done As Boolean
Dim legacySystem As Boolean
Dim arrayOffset As Integer
Dim ServerName$

'If gHistoryServer$ = "" Then gHistoryServer$ = "HISTORY"
ServerName$ = gArchiveContext$ + "/" + gHistoryServer$

lStartStopArray(0) = starttime
lStartStopArray(1) = stoptime
lStartStopArray(2) = KeywordIndex

npts = stoptime - starttime ' won't be any worse than this
npts = 150 ' start off at a reasonable number
LaunchArchiveLink:
ReDim fiDataArray(npts + 1)
dout.dArrayLength = npts: dout.dFormat = CF_FLTINT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = EXECLINKEx(ServerName$, Keyword, dout, fiDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo ArchiveError
nread = dout.dArrayLength
'If (fiDataArray(0).iVal <= npts) Or (npts > 150) Then done = True
If (nread <= npts) Or (npts > 150) Then done = True
'npts = fiDataArray(0).iVal
If fiDataArray(0).iVal <= npts Then legacySystem = True
arrayOffset = IIf(legacySystem, 1, 0)
npts = nread - arrayOffset
If npts <= 0 Then GoTo ArchiveError
If npts > 16000 Then npts = 16000
If Not done Then GoTo LaunchArchiveLink
'ReDim fDataArray(npts - 1)
'ReDim lTimeArray(npts - 1)
ReDim fDataArray(npts)
ReDim lTimeArray(npts)
For i = 0 To npts - 1
  fDataArray(i) = fiDataArray(i + arrayOffset).fval
  lTimeArray(i) = fiDataArray(i + arrayOffset).iVal
Next
npoints = npts
ArchiveError:
GetArchivedData = rc&
End Function
Function GetArchiveDataTrace(ByVal context As String, ByVal Keyword As String, ByVal KeywordIndex As Integer, ByVal targetTime As Long, fDataArray() As Single, npoints As Integer)
Dim lStartStopArray(2) As Long
Dim npts As Long
Dim rc&, i As Integer
Dim dout As DBLK, din As DBLK
Dim done As Boolean
Dim ArchiveServer$

'Select Case context
'  Case "TTF": ArchiveServer$ = "TTFHISTORY"
'  Case "PETRA": ArchiveServer$ = "PEHISTORY"
'  Case "DESY", "DESY3", "DESY2": ArchiveServer$ = "D3HISTORY"
'  Case Else: ArchiveServer$ = "HISTORY"
'End Select

Select Case context
  Case "TTF": ArchiveServer$ = "TTFHISTORY"
  Case "PETRA": ArchiveServer$ = "PEHISTORY"
  Case "DESY", "LINAC", "LINAC2", "LINAC3", "DESY3", "DESY2": ArchiveServer$ = "DESYHISTORY"
  Case "DORIS": ArchiveServer$ = "DORISHISTORY"
  Case "HERA": ArchiveServer$ = "HEHISTORY"
  Case Else:
    If Left(context, 1) = "/" Then
      ArchiveServer$ = context
    Else
      ArchiveServer$ = "HISTORY"
    End If
End Select


lStartStopArray(0) = targetTime
lStartStopArray(1) = targetTime
lStartStopArray(2) = KeywordIndex

npts = npoints
LaunchArchiveTraceLink:
'ReDim fiDataArray(npts)
dout.dArrayLength = npts: dout.dFormat = CF_FLOAT
din.dArrayLength = 3: din.dFormat = CF_LONG
rc& = T_EXECLINK(ArchiveServer$, Keyword, dout, fDataArray(0), din, lStartStopArray(0), 1, 1000)
If rc& Then GoTo GetArchiveDataTraceError
npoints = npts
GetArchiveDataTraceError:
GetArchiveDataTrace = rc&

End Function

' this has been deprecated
Function RemovePMData(ByVal pmArchiveGroup$, ByVal evnTag$) As Integer
Dim DevName$
Dim fn As NAME8
Dim dbout As DBLK, dbin As DBLK

DevName$ = pmArchiveContext$ & "/" & pmArchiveServer$ & "/" & pmArchiveGroup$

dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
dbin.dArrayLength = 1
dbin.dFormat = CF_NAME8
BARR fn.nam(), evnTag$
RemovePMData = T_EXECLINK(DevName$, "REMOVE", dbout, 0, dbin, fn.nam(0), CA_WRITE, 500)

End Function

' this is the NEW API
Function RemoveArchivedPMData(ByVal pmDeviceServer$, ByVal evnNumber&) As Integer
  RemoveArchivedPMData = RemovePMArchivedData(pmDeviceServer$, evnNumber&)
End Function

' this is the NEW API
Function RemovePMArchivedData(ByVal pmDeviceServer$, ByVal evnNumber&) As Integer
Dim DevName$
Dim dout As DBLK, din As DBLK
Dim tmp&

DevName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_LONG
din.dArrayLength = 1: din.dFormat = CF_LONG
  
RemovePMArchivedData = T_EXECLINK(DevName, "REMOVE", dout, tmp, din, evnNumber&, CA_WRITE, 1000)

End Function
Function RemovePMArchivedDataSTORAGE(ByVal pmDeviceServer$, ByVal evnNumber&) As Integer
Dim DevName$
Dim dout As DBLK, din As DBLK
Dim tmp&

DevName$ = EventStorageServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 1: dout.dFormat = CF_LONG
din.dArrayLength = 1: din.dFormat = CF_LONG
  
RemovePMArchivedDataSTORAGE = T_EXECLINK(DevName, "REMOVE", dout, tmp, din, evnNumber&, CA_WRITE, 1000)

End Function
' this is the NEW API
Function RemovePMArchivedDataBlock(ByVal pmDeviceServer$, ByVal evnNumberStart&, ByVal evnNumberStop&) As Integer
Dim DevName$
Dim dout As DBLK, din As DBLK
Dim tmpIN&(1), tmpOUT&(1)

DevName$ = EventArchiveServer$ + "/" + pmDeviceServer$
dout.dArrayLength = 2: dout.dFormat = CF_LONG
din.dArrayLength = 2: din.dFormat = CF_LONG
tmpIN&(0) = evnNumberStart&
tmpIN&(1) = evnNumberStop&

RemovePMArchivedDataBlock = T_EXECLINK(DevName, "REMOVE", dout, tmpOUT&(0), din, tmpIN&(0), CA_WRITE, 1000)

End Function
' this is the NEW API
Function SetPMArchivedComment(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal Comment$) As Integer
Dim DevName$
Dim dout As DBLK, din As DBLK
Dim cmtstr$, cmtbarr() As Byte

DevName$ = EventArchiveServer$ + "/" + pmDeviceServer$
cmtstr$ = "[" + Trim$(STR$(evnNumber&)) + "] " + Comment$ '+ Chr(0)
ReDim cmtbarr(Len(cmtstr$))
BARR cmtbarr, cmtstr$
dout.dArrayLength = 0: dout.dFormat = CF_NULL
din.dArrayLength = Len(cmtstr$): din.dFormat = CF_TEXT
  
SetPMArchivedComment = T_EXECLINK(DevName, "ANNOTATE", dout, 0, din, cmtbarr(0), CA_WRITE, 1000)

Debug.Print cmtstr$

Debug.Print


'If SetPMArchivedComment = 36 Then
'    devName$ = EventStorageServer$ + "/" + pmDeviceServer$
'    SetPMArchivedComment = T_EXECLINK(devName, "ANNOTATE", dout, 0, din, cmtbarr(0), CA_WRITE, 1000)
'End If

End Function


' this is the NEW API
Function SetPMArchivedCommentTEST(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal Comment$) As Integer
Dim DevName$
Dim dout As DBLK, din As DBLK
Dim cmtstr$, cmtbarr() As Byte

'DevName$ = EventArchiveServer$ + "/" + pmDeviceServer$
DevName$ = pmDeviceServer$
'cmtstr$ = "[" + Trim$(STR$(evnNumber&)) + "]" + Comment$ + Chr(0)
cmtstr$ = Comment$ + "@" + Trim$(STR$(evnNumber&)) ' + Chr(0)
ReDim cmtbarr(Len(cmtstr$))
BARR cmtbarr, cmtstr$
dout.dArrayLength = 0: dout.dFormat = CF_NULL
din.dArrayLength = Len(cmtstr$): din.dFormat = CF_TEXT
  
SetPMArchivedCommentTEST = T_EXECLINK(DevName, "ANNOTATE", dout, 0, din, cmtbarr(0), CA_WRITE, 1000)

'If SetPMArchivedComment = 36 Then
'    devName$ = EventStorageServer$ + "/" + pmDeviceServer$
'    SetPMArchivedComment = T_EXECLINK(devName, "ANNOTATE", dout, 0, din, cmtbarr(0), CA_WRITE, 1000)
'End If

End Function

Function SendPMTrigger(subsys As String, cmt As String) As Integer
Dim DevName$, tmpStorageServer$, tmpSubSystem$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim triggerlevel%, pmtime&
' Input data (to send):
dbin.dArrayLength = 1
dbin.dFormat = CF_SHORT
triggerlevel% = 1 ' later user -1 to indicate a more critical trigger
' Output data (to receive):
dbout.dArrayLength = 1
dbout.dFormat = CF_LONG

' sub system to receive the trigger
p% = InStr(subsys$, "/")
If p% = 0 Then ' didn't find a delimiter!
    If EventStorageServer$ = "" Then
        ' Assume that it's a HERA Subsystem....
        DevName$ = "/PETRA/EVENTSTORE/" + subsys 'LCase(subsys)
    Else
        DevName$ = EventStorageServer$ + "/" + subsys 'LCase(subsys)
    End If
Else
    tmpStorageServer$ = Left$(subsys, p% - 1)
    tmpSubSystem$ = Right$(subsys, Len(subsys) - p%)
    DevName$ = tmpStorageServer$ + "/" + tmpSubSystem$ 'LCase(tmpSubSystem$)
End If

rc% = T_EXECLINK(DevName$, "TRIGGER", dbout, pmtime&, dbin, triggerlevel%, CA_WRITE, 500)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
' now send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(STR$(pmtime&))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
BARR rpccmt.text(), cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = T_EXECLINK(DevName$, "ANNOTATE", dbout, 0, dbin, rpccmt.text(0), CA_WRITE, 500)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
SendPMTrigger = 0
End Function
' trigger is a string of the form '/context/EVENTSTORE/trigger' or just 'trigger' if EventStorageServer$ is not an empty string
' if timeOfTrigger is 0 then the 'trigger time' will be ascertained 'normally'
' rangeStart if postive is the system stamp to use in accessing local history (.HIST event items) data.
'                       (local history access then uses a search startime of 'timeOfTrigger' minus 5 seconds.)
'            if negative it gives a timestamp offset in seconds to 'now' to be used in local history access
' rangeStop  if positive and >  rangeStart is the system stamp to use in access local history data (sequence request)
'                            == rangeStart signals a local history snapshot request
'                            <  rangeStart is used as a increment to rangeStart to provide the range stop parameter
'            if negative it gives a timestamp offset in seconds to 'now' to be used in local history access.
' rangeMaximum is the maxmimum number of acquisitions to make in a sequence of local history accesses.
'            if negative it indicates that no sequences of .HIST data over a range is to be taken (just do it).
'
Function SendPMTriggerEx(trigger As String, cmt As String, ByVal timeOfTrigger As Long, ByVal rangeStart As Long, ByVal rangeStop As Long, rangeMaximum) As Integer
Dim DevName$, tmpStorageServer$, tmpTrigger$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim triggerlevel%, pmtime&
Dim ivals(5) As Long
' Input data (to send):
dbin.dArrayLength = 1
dbin.dFormat = CF_SHORT
triggerlevel% = 1 ' later user -1 to indicate a more critical trigger
' Output data (to receive):
ivals(0) = triggerlevel%
ivals(1) = timeOfTrigger
If rangeMaximum < 0 Then
  dbout.dArrayLength = 2
Else
  ivals(2) = rangeStart
  ivals(3) = rangeStop
  ivals(4) = rangeMaximum
  dbout.dArrayLength = 5
End If
dbout.dFormat = CF_LONG

' sub system to receive the trigger
p% = InStr(trigger, "/")
If p% = 0 Then ' didn't find a delimiter!
    If EventStorageServer$ = "" Then
        ' Assume that it's a HERA Subsystem....
        DevName$ = "/PETRA/EVENTSTORE/" + trigger 'LCase(trigger)
    Else
        DevName$ = EventStorageServer$ + "/" + trigger 'LCase(trigger)
    End If
Else
    tmpStorageServer$ = Left$(trigger, p% - 1)
    tmpTrigger$ = Right$(trigger, Len(trigger) - p%)
    DevName$ = tmpStorageServer$ + "/" + tmpTrigger$ 'LCase(tmpTrigger$)
End If

rc% = T_EXECLINK(DevName$, "TRIGGER", dbout, pmtime&, dbin, ivals(0), CA_WRITE, 500)
If rc% Then
  SendPMTriggerEx = rc%
  Exit Function
End If
' now send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(STR$(pmtime&))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
BARR rpccmt.text(), cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = T_EXECLINK(DevName$, "ANNOTATE", dbout, 0, dbin, rpccmt.text(0), CA_WRITE, 500)
If rc% Then
  SendPMTriggerEx = rc%
  Exit Function
End If
SendPMTriggerEx = 0
End Function

Function SendPMComment(subsys As String, pmtime As Long, cmt As String) As Integer
Dim DevName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string

' sub system to receive the trigger
p% = InStr(subsys$, "/")
If p% = 0 Then
    If EventStorageServer$ = "" Then
        ' Assume that it's a HERA Subsystem....
        DevName$ = "EVENTSTORE/" + subsys 'LCase(subsys)
    Else
        DevName$ = EventStorageServer$ + "/" + subsys 'LCase(subsys)
    End If
Else
    tmpStorageServer$ = Left$(subsys, p% - 1)
    tmpSubSystem$ = Right$(subsys, Len(subsys) - p%)
    DevName$ = tmpStorageServer$ + "/" + tmpSubSystem$
End If

' send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(STR$(pmtime))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
BARR rpccmt.text(), cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = T_EXECLINK(DevName$, "ANNOTATE", dbout, 0, dbin, rpccmt.text(0), CA_WRITE, 500)
If rc% Then
  SendPMComment = rc%
  Exit Function
End If
SendPMComment = 0
End Function

Function GetPMComment(subsys As String, pmtime As Long, cmt As String) As Integer
Dim DevName$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string

' sub system to receive the trigger
p% = InStr(subsys$, "/")
If p% = 0 Then
    If EventStorageServer$ = "" Then
        ' Assume that it's a HERA Subsystem....
        DevName$ = "EVENTSTORE/" + subsys '"STORAGE/" + subsys 'LCase(subsys)
    Else
        DevName$ = EventStorageServer$ + "/" + subsys 'LCase(subsys)
    End If
Else
    tmpStorageServer$ = Left$(subsys, p% - 1)
    tmpSubSystem$ = Right$(subsys, Len(subsys) - p%)
    DevName$ = tmpStorageServer$ + "/" + tmpSubSystem$ 'LCase(tmpSubSystem$)
End If
'DevName$ = pmArchiveContext$ + "/" + DevName$
dbin.dArrayLength = 1
dbin.dFormat = CF_LONG
' Output data (to receive): NONE
dbout.dArrayLength = 256
dbout.dFormat = CF_TEXT
rc% = T_EXECLINK(DevName$, "COMMENT", dbout, rpccmt.text(0), dbin, pmtime, CA_READ, 1000)
If rc% Then
  GetPMComment = rc%
  Exit Function
End If
cmt = BSTR(rpccmt.text())
GetPMComment = 0
End Function

' a call to set context sets the default search context at the archive server
' if a device server is not found in the selected context, the entire context list is
' scanned until a match is found
' note that the default context can be changed by somebody else at any time !!!!
Function SetPMContext(subsys As String) As Integer
Dim DevName$
Dim dbin As DBLK, dbout As DBLK
Dim dummy As Long

'devName$ = "STORAGE/" + LCase(subsys)
DevName$ = EventStorageServer$ + "/" + subsys 'LCase(subsys)

dbin.dArrayLength = 1
dbin.dFormat = CF_LONG
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = T_EXECLINK(DevName$, "SELECT", dbout, 0, dbin, dummy, CA_READ, 500)
If rc% Then
  SetPMContext = rc%
  Exit Function
End If
SetPMContext = 0
End Function

' this is the NEW API
Function GetPMArchivedTimeSliceData(ByVal pmDeviceServer$, ByVal evnNumber&, ByVal DevName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As Variant, TimeBuffer() As Long)
Static pmDevSrv As String
Dim dout As DBLK, din As DBLK
Dim ab As ADRB, abx As ADRBX
Dim rc&, p%, i%, dContext$, dServerName$, dName$, dIndex&, evn As NAME8, pmServerContext$
Dim pass%, vtype As Integer, isArray As Boolean
Dim ld() As LNGINT, fd() As FLTINT, dd() As DBLINT
Dim ds() As Byte
Static done As Boolean

If Not done Then
  FILLSTRUCT "ADRB", Len(ab), 1, CF_NULL
  FILLSTRUCT "ADRBX", Len(abx), 1, CF_NULL
  done = True
End If

rc& = 0
If Left$(DevName$, 1) = "/" Then
  p% = InStr(Right$(DevName$, Len(DevName$) - 1), "/")
  dContext$ = Mid$(DevName$, 2, p%)
  DevName$ = Right$(DevName$, Len(DevName$) - p% - 1)
End If
p% = InStr(DevName$, "/") '  z.B. L2TRCrf/#0
If p% = 0 Then
    dServerName$ = DevName$
    dName$ = "#0"
Else
    dServerName$ = Left$(DevName$, p% - 1)
    dName$ = Right$(DevName$, Len(DevName$) - p%)
End If
p% = InStr(dName$, "[") ' z.B. ALL_DATA[3]
If p% = 0 Then
  dIndex& = 0
Else
  dIndex& = Val(Right$(dName$, Len(dName$) - p%))
  dName$ = Left$(dName$, p% - 1)
End If

' Is the CONTEXT in the pmDeviceServer Name?
p% = InStr(pmDeviceServer$, "/") '  z.B. DESYEVENTDATA/l2trcrf1p
If p% = 0 Then
    pmServerContext$ = EventArchiveServer$ + "/" + pmDeviceServer$
Else
    pmServerContext$ = pmDeviceServer$
End If
'pmServerContext$ = EventArchiveServer$

retryGetPMTimeSliceData:
If pass% = 0 Then
    BARR abx.deviceContext(), dContext$
    BARR abx.deviceServerName(), dServerName$
    BARR abx.deviceName(), dName$
    BARR abx.deviceProperty(), devProperty$
    abx.eventNumber = evnNumber&
    abx.starttime = evnNumber&
    abx.stoptime = evnNumber&
    abx.dataIndex = dIndex&
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRBX"
Else
    BARR ab.deviceServerName(), dServerName$
    BARR ab.deviceName(), dName$
    BARR ab.deviceProperty(), devProperty$
    ab.eventNumber = evnNumber&
    ab.starttime = evnNumber&
    ab.stoptime = evnNumber&
    
    din.dArrayLength = 1
    din.dFormat = CF_STRUCT
    BARR din.dTag(), "ADRB"
End If
pass% = pass% + 1
If VarType(DataBuffer) > vbArray Then
  If UBound(TimeBuffer) - LBound(TimeBuffer) < npoints - 1 Then
    rc& = tine.dimension_error
    GoTo GetPMArchivedTimeSliceDataError
  End If
  If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
    rc& = tine.dimension_error
    GoTo GetPMArchivedTimeSliceDataError
  End If
  vtype = VarType(DataBuffer) - vbArray
  isArray = True
Else
  rc& = tine.illegal_format
  GoTo GetPMArchivedTimeSliceDataError
End If

dout.dArrayLength = npoints
Select Case vtype
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LNGINT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, ld(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMTimeSliceData
       For i% = 0 To npoints - 1
         DataBuffer(i%) = ld(i%).lval
         TimeBuffer(i%) = ld(i%).iVal
       Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLTINT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, fd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMTimeSliceData
       For i% = 0 To npoints - 1
         DataBuffer(i%) = fd(i%).fval
         TimeBuffer(i%) = fd(i%).iVal
         If TimeBuffer(i%) > 1 Then Debug.Print "fval : ", fd(i%).fval, "ival : ", fd(i%).iVal, ASCTIME(fd(i%).iVal)
       Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DBLINT
       If pass% < 2 Then
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, abx, 1, 2000)
       Else
         rc& = T_EXECLINK(pmServerContext$, "ARCHDATA", dout, dd(0), din, ab, 1, 2000)
       End If
       If (rc& = 2 Or rc& = 23 Or rc& = 38) And (pass% < 2) Then GoTo retryGetPMTimeSliceData
       For i% = 0 To npoints - 1
         DataBuffer(i%) = dd(i%).dval
         TimeBuffer(i%) = dd(i%).iVal
       Next
  Case Else:
       rc& = tine.illegal_format
End Select
If rc& Then GoTo GetPMArchivedTimeSliceDataError

GetPMArchivedTimeSliceDataError:
GetPMArchivedTimeSliceData = rc&
End Function

