/////////////////////////////////////////////////////////////////////////////
// TINE sine service
//
// example and reference implementation of a simple TINE server "sine" as // a Windows service // // - example taken from PJ Naughters CNTService freeware example // // - modified by Stefan Weisse / DESY Zeuthen, September - December 2005 //
//        - changes: removed references to CString object and CStringBuffer,
//          replaced by default string handling (char *, string.h)
//        - removed MFC (completely? imho) out of the project (to have less dependencies)
//        - integrated TINE sine server into it
//        - added "set working directory" to the directory of the executable in
//          order to find the configuration files (*.csv)
//
// OPEN POINTS:
//    - error messages on command line are not sufficent (ie. not describing what really happened)
//
// NOTES:
//    - you have to specify a command line parameter (like -install, -uninstall or
//    -help) otherwise the service is attempted to be "touched" by StartServiceControl
//      which does only work from NT service manager (see "RunAsService")
// /////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "app_version.h"
#include "app_header.h"
#include <direct.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "tine.h"
#include "ntserv_msg.h"

#include "tineService.h"

BOOL CALLBACK EnumServices(DWORD /*dwData*/, ENUM_SERVICE_STATUS& Service)
{
  TRACE(_T("Service name is %s\n"), Service.lpServiceName);
  TRACE(_T("Friendly name is %s\n"), Service.lpDisplayName);

  return TRUE; //continue enumeration
}


int main( void )
{
	//Uncomment the following code to test the persistance functions
	/* 
	CTineService testService;
	UINT nValue = testService.GetProfileInt(_T("General"), _T("IntValue"), 33);
	CString sValue = testService.GetProfileString(_T("General"), _T("StringValue"), _T("DefaultValue"));

	BOOL bSuccess = testService.WriteProfileInt(_T("General"), _T("IntValue"), 37);
	bSuccess = testService.WriteProfileString(_T("General"), _T("StringValue"), _T("Test Value"));

	nValue = testService.GetProfileInt(_T("General"), _T("IntValue"), 33);
	sValue = testService.GetProfileString(_T("General"), _T("StringValue"));


	CStringArray array;
	array.SetAtGrow(0, _T("First String"));
	array.SetAtGrow(1, _T("Second and Last String"));
	bSuccess = testService.WriteProfileStringArray(_T("General"), _T("StringArrayValue"), array);

	BYTE* pSetData = new BYTE[10];
	for (int i=0; i<10; i++) pSetData[i] = (BYTE) i;
 	bSuccess = testService.WriteProfileBinary(_T("General"), _T("BinaryValue"), pSetData, 10);
	delete [] pSetData;

	array.SetSize(0);
	bSuccess = testService.GetProfileStringArray(_T("General"), _T("StringArrayValue"), array); 

	BYTE* pGetData = NULL;
	UINT nBytes;
	bSuccess = testService.GetProfileBinary(_T("General"), _T("BinaryValue"), &pGetData, &nBytes);
	if (bSuccess)
	{
		delete [] pGetData;
	}
	return FALSE;
	*/


	// Uncomment the following code to test the CServiceControlManager
	// and the CSCMService classes
  
	/*
	CNTServiceControlManager manager;
	SC_HANDLE hScm = manager;
	BOOL bSuccess = manager.Open(NULL, SC_MANAGER_ALL_ACCESS);
	hScm = manager;
	LPQUERY_SERVICE_LOCK_STATUS lpLockStatus = NULL;
	bSuccess = manager.QueryLockStatus(lpLockStatus);
	BOOL bIsLocked = (lpLockStatus->fIsLocked != 0);
	LPCTSTR lpszOwner = lpLockStatus->lpLockOwner;
	DWORD dwDuration = lpLockStatus->dwLockDuration;
	delete [] (BYTE*) lpLockStatus;
	bSuccess = manager.Lock();
	lpLockStatus = NULL;
	bSuccess = manager.QueryLockStatus(lpLockStatus);
	bIsLocked = (lpLockStatus->fIsLocked != 0);
	lpszOwner = lpLockStatus->lpLockOwner;
	dwDuration = lpLockStatus->dwLockDuration;
	delete [] (BYTE*) lpLockStatus;
	bSuccess = manager.EnumServices(SERVICE_WIN32, SERVICE_STATE_ALL, 0, EnumServices);
	CNTScmService service;
	SC_HANDLE hService = service;
	bSuccess = manager.OpenService(_T("Browser"), SERVICE_ALL_ACCESS, service);
	hService = service;
	bSuccess = service.Start(0, NULL);
	Sleep(4000);
	bSuccess = service.Control(128);
	bSuccess = service.Interrogate();
	bSuccess = service.Pause();
	Sleep(4000);
	bSuccess = service.Continue();
	BOOL bStop;
	bSuccess = service.AcceptStop(bStop);
	BOOL bPauseContinue;
	bSuccess = service.AcceptPauseContinue(bPauseContinue);
	BOOL bShutdown;
	bSuccess = service.AcceptShutdown(bShutdown);
	bSuccess = service.Stop();
	LPQUERY_SERVICE_CONFIG lpServiceConfig = NULL;
	bSuccess = service.QueryConfig(lpServiceConfig);
	TRACE(_T("dwServiceType is %d\n"),    lpServiceConfig->dwServiceType);
	TRACE(_T("dwStartType is %d\n"),      lpServiceConfig->dwStartType);
	TRACE(_T("dwErrorControl is %d\n"),   lpServiceConfig->dwErrorControl);
	TRACE(_T("lpBinaryPathName is %s\n"), lpServiceConfig->lpBinaryPathName);
	TRACE(_T("lpLoadOrderGroup is %s\n"), lpServiceConfig->lpLoadOrderGroup);
	TRACE(_T("dwTagId is %d\n"),          lpServiceConfig->dwTagId);
	TRACE(_T("lpDependencies are %s\n"),  lpServiceConfig->lpDependencies);
	TRACE(_T("lpServiceStartName is %s\n"), lpServiceConfig->lpServiceStartName);
	TRACE(_T("lpDisplayName is %s\n"), lpServiceConfig->lpDisplayName);
	delete [] (BYTE*) lpServiceConfig;
	service.EnumDependents(SERVICE_STATE_ALL, 0, EnumServices);
	*/

	/*
	// Uncomment the following code to test the CNTEventLog 
	// and the CEventLogRecord classes
  
	CNTEventLog el;
	HANDLE hEventLog = el;
	BOOL bSuccess = el.OpenSecurity(NULL);
	hEventLog = el;
	bSuccess = el.OpenSystem(NULL);
	bSuccess = el.OpenApplication(NULL);
	DWORD dwOldest;
	bSuccess = el.GetOldestRecord(dwOldest);
	bSuccess = el.Backup(_T("C:\\BACKUPLOG.TXT"));
	bSuccess = el.Close();
	bSuccess = el.OpenBackup(NULL, _T("C:\\BACKUPLOG.TXT"));
	DWORD dwRecords;
	bSuccess = el.OpenSystem(NULL);
	bSuccess = el.GetNumberOfRecords(dwRecords);
	//bSuccess = el.Clear(NULL);
	CEventLogRecord record;
	bSuccess = el.ReadNext(record);
	bSuccess = el.ReadNext(record);
	bSuccess = el.ReadPrev(record);
	*/


	// Uncomment the following code to test the 
	// CNTEventLogSource classes
	/*
	CNTEventLogSource els;
	LPCTSTR pString = _T("PJ's Demo NT Service");
	LPCTSTR* ppString = &pString;
	BOOL bSuccess = els.Register(NULL, pString);
	DWORD dwError = GetLastError();
	bSuccess = els.Report(EVENTLOG_INFORMATION_TYPE, 0, CNTS_MSG_SERVICE_STARTED, NULL, 1, 0, ppString, NULL);
	bSuccess = els.Deregister();
	*/


	//All that is required to get the service up and running
	//  Uncomment the following code to actually setup the service
	///*
  CNTServiceCommandLineInfo cmdInfo;
  CTineService Service;
  Service.ParseCommandLine(cmdInfo);
  Service.ProcessShellCommand(cmdInfo);
	//*/

	return 1;
}

CTineService::CTineService() : CNTService(_T(SERVICEUNIQUENAME), _T(SERVICECALLNAME), SERVICEACCEPTFUNCTIONS, _T(SERVICEDESCRIPTION)) 
{
	//Simple boolean which is set to request the service to stop
	m_bWantStop = FALSE;
	m_bPaused = FALSE;
}

void CTineService::ServiceMain(DWORD /*dwArgc*/, LPTSTR* /*lpszArgv*/)
{
	int cc=0;
	TCHAR szPath[MAX_PATH]; 
	char *pos;
    
	// Move current dir ("working directory") to the directory of the executable service file
  if( !GetModuleFileName( NULL, szPath, MAX_PATH ) )
  {
      printf("GetModuleFileName failed (%d)\n", GetLastError()); 
      exit(1);
  }
    
	if ((pos = strrchr((const char *) szPath, '\\')) != NULL) *pos = 0;

	if (_chdir(szPath) != 0) exit(1);
    // Move current dir ("working directory") to the directory of the executable service file END

	//register our control handler
	RegisterCtrlHandler();

	//Pretend that starting up takes some time
	ReportStatusToSCM(SERVICE_START_PENDING, NO_ERROR, 0, 1, 0);

	/* TINE initialization: */
	AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  // 0th order initialization:
	PreSystemInit();
  // server initialization:
	if ((cc=SystemInit(TRUE)) != 0) 
	{ 
		
		printf("init error: %s\n",erlst[cc]); 
		exit(1); 
	}
	// application specific initialization:
	PostSystemInit();
	
	ReportStatusToSCM(SERVICE_RUNNING, NO_ERROR, 0, 1, 0);

  //Report to the event log that the service has started successfully
  m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, CNTS_MSG_SERVICE_STARTED, m_sDisplayName);

	//The tight loop which constitutes the service


  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  BOOL bOldPause = m_bPaused;
	
	while (!m_bWantStop)
	{
		// TINE
	  if (!m_bPaused) SystemCycle(TRUE);
		Sleep(10);
		//SCM has requested a Pause / Continue
		if (m_bPaused != bOldPause)
		{
			if (m_bPaused)
			{
    		ReportStatusToSCM(SERVICE_PAUSED, NO_ERROR, 0, 1, 0);
				//Report to the event log that the service has paused successfully
				m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, CNTS_MSG_SERVICE_PAUSED, m_sDisplayName);
			}
			else
			{
				ReportStatusToSCM(SERVICE_RUNNING, NO_ERROR, 0, 1, 0);
				//Report to the event log that the service has stopped continued
				m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, CNTS_MSG_SERVICE_CONTINUED, m_sDisplayName);
			}
		}

		bOldPause = m_bPaused;
	}

  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//Pretend that closing down takes some time
	ReportStatusToSCM(SERVICE_STOP_PENDING, NO_ERROR, 0, 1, 0);
    
	// TINE
  feclog("Stopping RPC Server ...\n>");
  ServerExitCondition = 4;
  closeServers(0);
  ExitEQPModules();
  freeServerMemory();

	ReportStatusToSCM(SERVICE_STOPPED, NO_ERROR, 0, 1, 0);

  //Report to the event log that the service has stopped successfully
  m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, CNTS_MSG_SERVICE_STOPPED, m_sDisplayName);
}

void CTineService::OnStop()
{
  ::EnterCriticalSection(&lock);

  //Change the current state to STOP_PENDING
  m_dwCurrentState = SERVICE_STOP_PENDING;  

  //Signal the other thread to end
  m_bWantStop = TRUE;

  ::LeaveCriticalSection(&lock);
}

void CTineService::OnPause()
{
  ::EnterCriticalSection(&lock);

  //Change the current state
  m_dwCurrentState = SERVICE_PAUSE_PENDING;  

  //Signal the other thread
  m_bPaused = TRUE;

  ::LeaveCriticalSection(&lock);
}

void CTineService::OnContinue()
{
  ::EnterCriticalSection(&lock); //synchronise access to the variables

  //Change the current state
  m_dwCurrentState = SERVICE_CONTINUE_PENDING;  

  //Signal the other thread
  m_bPaused = FALSE;

  ::LeaveCriticalSection(&lock); //synchronise access to the variables
}

void CTineService::OnUserDefinedRequest(DWORD dwControl)
{
	dwControl;
	// NO user defined request implemented
}
void CTineService::ShowHelp()
{
	printf(COMMANDLINEHELP);
}